                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NETX.COM Negating MODE.COM Setting
   DOCUMENT ID#:	FYI.P.10198
           DATE:	22OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NETX.COM negates MODE.COM settings

ISSUE/PROBLEM

	The user used the following mode commands:

		mode com2,9600,n,8,1
		mode lpt2:=com2:

	This worked fine until he loaded NETX.  After loading NETX, the mode command did not work.

	The user has an AUTOEXEC.BAT file with the following:

		MODE LPT2 = COM2
		NETX
		NETX -U
		NETX

	The user has an application that prints to LPT2 and needs to print to serial port, COM2, where the printer is hooked up.  If the user executes mode command, LPT2 is redirected to COM2.  When the user executes NETX.COM, the redirection is broken.  When the user unloads NETX.COM and then reloads it, redirection is fine.

SOLUTION

	Put the following command line in the NET.CFG file:

		Set Local Printers = 2




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"File Server Not Found" ELS NetWare - Upgrade to DOS 5.0
   DOCUMENT ID#:	FYI.P.10216
           DATE:	21OCT92
        PRODUCT:	NetWare ELS Level I
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	"A file server could not be found"

ISSUE/PROBLEM

	The user had been trying to upgrade the workstations' shells and the workstations to DOS 5.0.  When he tried to log in to the server, the system displayed the following error at the workstation:

		Ŀ
		A file server could not be found
		

SOLUTION

	After the user shut down the sever and brought it back up, the user could log in to the server from all workstations including the workstation with DOS 5.0 on it.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems Setting Up DOS Variables Install NetWare MHS
   DOCUMENT ID#:	FYI.P.10171
           DATE:	16OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Problems setting up DOS variables

ISSUE/PROBLEM

	The user was installing Message Handling Service (MHS) on a server and was having problems setting up the DOS variables.  MHS calls for a mapping variable (MV) to be set to the root (SYS:) of the file server.

		Example: DOS SET MV="PRV-MAIL-CORP/SYS:

	The user had f: drive mapped to USERS/USERNAME and wanted to use the DOS SET MV="f:\" statement.  When they did a DOS SET MV="f:\" command, it would not set MV equal to the root of the volume (SYS:).  The system displayed the following error:

		Ŀ
		Script Error: Line contains no end quote
		

SOLUTION

	DOS SET MV="f:\\" sets MV equal to the root of the volume (SYS:).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"R6003 Divided by Zero"
   DOCUMENT ID#:	FYI.P.10169
           DATE:	16OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The workstation with VGA card and NE2000 gets error message "R6003 divided by zero" and hangs.

ISSUE/PROBLEM

	When the user configured a VGA card in a 16-bit mode and the NE2000 card with default option interrupt line 3 and I/O of 300h, the workstation hung and displayed the following message:

		Ŀ
		R6003 divided by zero
		

SOLUTION

	Reconfiguring the VGA card to the 8-bit mode solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	ECB Statistics Being Incremented for 90 Percent of Packets Received
   DOCUMENT ID#:	FYI.P.10136
           DATE:	14OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"No ECBs available" statistic incrementing

ISSUE/PROBLEM

	Some applications allow workstation statistics to be viewed.  One of the statistics is "No ECBs available."  Some users are reporting that this statistic is being incremented for 90 percent or more of the packets received at the workstation.  This is not a problem.

	The LAN driver at the workstation requests an Event Control Block (ECB) from IPX whenever it receives a valid packet from the LAN board.  The LAN driver passes a parameter containing the destination socket to IPX when requesting the ECB.  If there is not an open socket at the workstation matching the destination socket, then IPX reports back to the LAN driver that there are no ECBs available for that socket.  This will increment the "No ECBs available" counter and the LAN driver will discard the packet.

	For example: Routing Information Protocol (RIP) and Service Advertising Protocol (SAP) broadcasts will be given to the workstation LAN driver as valid packets.  A workstation will not have an open socket matching the RIP and SAP packets because it is not a router.  These packets will increment the "No ECBs available" counter at the workstation.  Therefore, on large networks a large percentage of packets received will increment the "No ECBs available" counter.  The percentage will vary depending on the usage of the workstation.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	TaskMAX Cut and Paste Not Working with GeoWorks
   DOCUMENT ID#:	FYI.P.10132
           DATE:	14OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	The user was attempting to use TaskMAX's cut and paste option with GeoWorks Pro.  When he brought up the menu, that option was grayed out as if it was not available.

ISSUE/PROBLEM

	This problem was supposed to have been resolved with the 12-91 update.

SOLUTION

	After the user manually copied the 04-92 files, the cut and paste feature worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	FILER Hangs Selecting "Who Has Rights Here"
   DOCUMENT ID#:	FYI.P.10101
           DATE:	13OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Workstation hangs

ISSUE/PROBLEM

	FILER hangs the workstation when selecting the "who has rights here" option.

SOLUTION

	An option in FILER allows you to find out who has rights in a directory, like TLIST.  Sometimes, especially if you have Network File System (NFS) loaded, the workstation hangs when you select the mentioned option.  The reason is that sometimes, depending on how much information is called by the option, the workstation runs out of memory and hangs.

	Because Novell's utilities just use base memory, there is a limitation on most of our utilities.  For example, NDIR has the same problem.  The OS/2 version of FILER does not have the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"SYS$MSG.DAT File Can Not be Found" - FILER
   DOCUMENT ID#:	FYI.P.10096
           DATE:	13OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM
	If the user was in the PUBLIC directory, then FILER would work.  If the user was in any other directory, the following error message appeared:

		Ŀ
		SYS$MSG.DAT file can not be found
		

ISSUE/PROBLEM

	The user had a pathmode=2 and a search mode=2 in the NET.CFG file.

SOLUTION

	After the user changed the search mode to 1, the system booted and worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	XTREE for Windows and DR DOS Problems
   DOCUMENT ID#:	FYI.P.10094
           DATE:	13OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user could not get XTREE for Windows to run with DR DOS v6.0 and was wondering if this was because of a compatibility issue.

SOLUTION

	Executive Systems (maker of XTREE) said the problem was not specific to DR DOS and that users could also have problems with other memory managers using the new XTREE for Windows, even using MS DOS or PC DOS.

	Executive Systems has a fix available on their BBS or on CompuServe.  Their BBS number is (805)546-9150 and the filename is XTWFIX01.EXE.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Supported Devices under HP-DIBI - SBACKUP
   DOCUMENT ID#:	FYI.P.10100
           DATE:	13OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Devices listed in SBACKU.TXT file

SOLUTION

	A file on NetWire named SBACKU.TXT lists all devices supported under SBACKUP.  This list is valid if a driver from B/R driver kit is used (using TAPEDC00).  However, if you are selecting HP-DIBI, this list is not a valid list.  The only devices that are supported under HP-DIBI are WANGTEK, ARCHIVE, and HP DAT devices.  It does not mean other devices do not work when using HP-DIBI but these are the only ones Novell supports.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR DOS Backup Command - Backup Hard Drive to Network
   DOCUMENT ID#:	FYI.P.10148
           DATE:	12OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user wanted to know how to backup a local hard drive to the network.

SOLUTION

	Map root the target drive on the network where the backup files will be placed.

		Example: MAP ROOT F:=SYS:USERS\JOHN

	Ensure the DRDOS directory is in your current path.

	At F:> prompt, type BACKUP C:\ F: /S

		C:\ is the source drive.
		F: is the map root drive on the file server.
		/S is switch to copy all sub-directories.

	BACKUP will create a BACKUP directory in the JOHN directory and copy BACKUP.001 and CONTROL.001 to the SYS:USERS\JOHN\BACKUP directory.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	INDISK.ZIP File to NetWire and NetWare Express
   DOCUMENT ID#:	FYI.P.10116
           DATE:	12OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This FYI concerns the INDISK.ZIP file that is available on NetWire or NetWare Express.

	This program is intended for all number-of-user versions of a NetWare v3.11 operating system.  INDISK.ZIP contains INDSKFIX.EXE that changes the SERVER.EXE file on the disk to fix the following message:

		Ŀ
		Abend: The sleeping process was prematurely awakened during Delay.
		

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Invalid Command in CONFIG.SYS - DR DOS
   DOCUMENT ID#:	FYI.P.10114
           DATE:	12OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	"Invalid command in CONFIG.SYS"

ISSUE/PROBLEM

	When the user booted the computer, the system displayed the following message:

		Ŀ
		Invalid command in CONFIG.SYS
		

	The user put question marks in front of all the lines in the CONFIG.SYS and could not locate any lines that were causing the error.  It turned out he had two blank lines in the CONFIG.SYS.

SOLUTION

	When the user removed the blank lines, the error disappeared.

	More likely than just blank lines causing problems is the chance that there may have been some "invisible" control characters on those lines, possibly from some text editor used that did not save in ASCII mode.  There have been numerous cases like this.

	After hearing this possibility, one user brought up the file in a hex editor and the control characters were visible.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Print Server Prompting for Password
   DOCUMENT ID#:	FYI.P.10110
           DATE:	12OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When loading PSERVER.NLM, the system prompts for user password on file server <servername.>

ISSUE/PROBLEM

	The wrong print server name was specified when the user loaded the print server.

SOLUTION

	When the user put in the correct name, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error Writing to Device" - NetWare v2.15c
   DOCUMENT ID#:	FYI.P.10077
           DATE:	09OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	The system started displaying the following error at the workstations and the console:

		Ŀ
		Error Writing to Device
		

	The user had just increased the directory entries to the maximum limit.

ISSUE/PROBLEM

	The user's disk was getting full.

SOLUTION

	Adding more hard drive space or decreasing the directory entries solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Internal Error Code 001" - DR DOS, DeskLink
   DOCUMENT ID#:	FYI.P.10049
           DATE:	08OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	While the user was running DR DOS v6.0 and attempting to load or run DeskLink from Traveling Software, the system displayed the following error and returned the user to the DOS prompt.

		Ŀ
		Internal Error Code 001
		

	No variation in memory management, drivers, or DR DOS file dates affected the symptom.  DeskLink worked fine under MS DOS 3.3, 4.01, Compaq 3.31, PC DOS 3.30; not tested under MS DOS 5.0.

ISSUE/PROBLEM

	DeskLink reportedly assumes that certain information is stored at a particular address that is valid under MS-DOS or PC-DOS but is not valid under DR DOS.

SOLUTION

	DeskLink was discontinued by Traveling Software, and for several years now they have not supported it.  Instead, they recommend users use LapLink that is compatible with DR DOS.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Log in to Profile Server" NNS
   DOCUMENT ID#:	FYI.P.10062
           DATE:	08OCT92
        PRODUCT:	NetWare Naming Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM

	The system displayed the following message:

		Ŀ
		Unable to log in to profile server.
		

	The user said that SLIST and track ON let all four servers recognize each other; however, the user could not log in to the default server.  The user also said that the server, which he could not access, kept changing.  It was not always the same server.

ISSUE/PROBLEM

	When the user checked the internal net numbers of the servers, two of them were the same.

SOLUTION

	After the user made the internal net numbers  unique, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Disable "Keep Alive" Function of NetBIOS
   DOCUMENT ID#:	FYI.P.10061
           DATE:	08OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	NetBIOS
     SUPERSEDES:	NA

SYMPTOM

	How to disable "Keep Alive" function of NetBIOS

ISSUE/PROBLEM

	Can the "Keep Alive" function of NetBIOS be totally disabled?  It has parameters, but the user wanted it OFF.

SOLUTION

	The answer is no.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	DR DOS Booting Up to IBM Basic
   DOCUMENT ID#:	FYI.P.10019
           DATE:	07OCT92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When user booted with the DR DOS INSTALL diskette, the machine went into IBM Basic.  The machine would not boot off the floppy diskette.

ISSUE/PROBLEM

	The user verified that the diskette was inserted in drive A: and the drive door was closed.  The user was using an IBM computer (the machines where IBM basic sits in ROM in case booting up with floppy does not work).  The user was using high-density diskettes in a computer that could not read them.  It did not ever give any error and just went into IBM Basic.

SOLUTION

	The solution is to use low-density diskettes for that machine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Diskless Workstations Will Not Boot - CNET 2000
   DOCUMENT ID#:	FYI.P.10026
           DATE:	07OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	286
     SUPERSEDES:	NA

SYMPTOM

	After the user switched from using an 8-bit card to a 16-bit card in the file server, he could not boot the diskless workstations.

ISSUE/PROBLEM

	Configuration:
		File server NIC is a CNET 2000.

	According to CNET documentation that is sent with the card, you cannot have a SHELL.CFG on the diskette from which NET$DOS.SYS is created.

SOLUTION

	After the user regenerated NET$DOS.SYS without a SHELL.CFG, he could boot the remote workstations.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Steps for Loading RPRINTER on OS/2 2.0
   DOCUMENT ID#:	FYI.P.10022
           DATE:	06OCT92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What are the steps to loading RPRINTER on OS2 2.0?

SOLUTION

	1.	Ensure you are using the RPRINTER from NSD201.ZIP available on NetWire or NetWare Express.

	2.	Set up a remote printer in PCONSOLE.

	3.	Drag a printer template from the template object and define it as LPT1 or whatever, and pick the driver for the printer to be used.

	4.	Double click on the Novell object.

	5.	Double click on the RPRINTER object.

	6.	Click on "CONFIG."

	7.	Click on the setup default.

	8.	Click on "Add."

	9.	Type the PSERVER name.

	10.	Type the printer number on the "printer name" field.

	11.	Click on "Load" on Startup.

	12.	Exit out of RPRINTER.


	The next time you click on RPRINTER, it will automatically load RPRINTER.

	Also, if you CAPTURE to a queue from the same machine, do not use the same LPT port for the CAPTURE.  If you do, the job goes into a loop bouncing between the queue and the workstation.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Hard Error Flushing Network Send Buffer"
   DOCUMENT ID#:	FYI.P.10510
           DATE:	13NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The SQL server received the following message:

		Ŀ
		Hard error flushing network send buffer
		

ISSUE/PROBLEM

	Configuration:

		Using NetWare Requester for OS/2 v1.3

	The above error would sometimes hang the SQL server.  At other times, the error would just appear in the SQL error log.

SOLUTION

	After the user upgraded the Microsoft SQL server from v1.1 to v4.2, the symptom disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Shared RAM Is Not on Correct Boundary"
   DOCUMENT ID#:	FYI.P.10501
           DATE:	13NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10
     SUPERSEDES:	NA

SYMPTOM

	The user's system displayed the following message when loading IPX:

		Ŀ
		Shared RAM is not on correct boundary.
		

ISSUE/PROBLEM

	Configuration:

		Using an IBM 16/4 Token-Ring card

	Shared RAM was set to 64 KB.

SOLUTION

	When the user switched back to 16 KB, IPX loaded without displaying the error.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Log in Applying TOKENDMA.LAN to New Disk Controller
   DOCUMENT ID#:	FYI.P.10472
           DATE:	10NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user added a new disk controller and the WORMROFX.NLM (in 311PT9.ZIP on available on NetWire or NetWare Express) patch to the operating system.  After adding these items, all workstations could recognize the server but could not log into the server.

ISSUE/PROBLEM

	Configuration:

		Using TOKENDMA.LAN with a 16/4 busmastering card

	The system was sending but not receiving packets.  There were 0 packets received in LAN statistics.  The problem still existed after the user took out the new controller.

SOLUTION

	After the user upgraded to TOKENDMA.LAN v3.13 contained in TOKENB.ZIP available on NetWire or NetWare Express, the symptoms disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Upload of IPXLSL.ZIP
   DOCUMENT ID#:	FYI.P.10465
           DATE:	10NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This FYI concerns IPXLSL.ZIP available on NetWire or NetWare Express.  IPXLSL.ZIP includes IPXODI.COM (v2.00) and LSL.COM (v2.00) for NetWare v2.2 and v3.11 operating systems.

	IPXODI.COM has been modified to support the IPXOpenLookAheadSocket API plus previous fixes.

	LSL.COM fixes a problem that occurs while running LSL.COM and Norton's anti-virus program plus previous fixes.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend GPI, NetWare v2.15c - User Defined Drive
   DOCUMENT ID#:	FYI.P.10470
           DATE:	10NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	The user changed boxes from a 386 25 to a 486 33 and replaced the same hardware that was working in the 386 box into the 486 box (wd10007v-se2 ESDI controller with Thomas-Conrad Arcnet network interface card).  At start up, the system displayed the following error:

		Ŀ
		Abend: GPI Running process Muxprc
		

ISSUE/PROBLEM

	The drive type was set to "user defined" in the drive setup.

SOLUTION

	After the user changed the drive type from "user defined" to "1" in the CMOS, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	CWORTHY Utilities Hang Machine with Screen at 132 Column Mode
   DOCUMENT ID#:	FYI.P.10464
           DATE:	10NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	If the user sets the screen to 132 column mode and runs any CWORTHY utility such as FILER or SYSCON, it hangs the machine.

ISSUE/PROBLEM

	CWORTHY does not support 132 column mode.

SOLUTION

	CWORTHY utilities will support 25 or 50 lines in 80 column mode.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"A File Server Could Not Be Found" and Packet Rate Problems - NETX.COM
   DOCUMENT ID#:	FYI.P.10479
           DATE:	11NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Problems running NETX.COM v3.22

ISSUE/PROBLEM

	While using NETX.COM v3.22, the user experienced the following problems:

	1.	Workstations received the following message when using preferred server

		Ŀ
		A file server could not be found
		

	2.	Workstations started sending out a stream of packets at 2500 a second.

SOLUTION

	1.	NETX.COM v3.26 solved the problem of not finding a file server.

	2.	The user said the problem of the packets being sent at 2500 per second was due to a bug in Attachmate's Extra for Windows v3.20.  The user got the solution from Attachmate.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NPRINT Returns Illegal Flag or Parameter Error
   DOCUMENT ID#:	FYI.P.10433
           DATE:	06NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	While trying to NPRINT a file directly to the queue (NPRINT xxxxx S=yyyyyy Q=zzzzzz), the system returned an error that said something about an illegal flag or parameter in the command syntax.

ISSUE/PROBLEM

	The user found NPRINT.COM and NPRINT.EXE in the PUBLIC directory.

SOLUTION

	After the user deleted the NPRINT.COM, everything worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR Multi-user DOS Hangs Loading NETM on Model 70
   DOCUMENT ID#:	FYI.P.10449
           DATE:	06NOV92
        PRODUCT:	DR Multi-user DOS
PRODUCT VERSION:	v5.1
     SUPERSEDES:	NA

SYMPTOM

	When running an I/O intensive application from NetWare in DOS Session 1 or 2 and the user switched to Session 3 or 4 and loaded NETM, the workstation (PS/2 Model 70) locked.

ISSUE/PROBLEM

	When the user tried using an NE/2 instead of 3C523 card, the system worked fine.

SOLUTION

	After the user updated the 3C523 driver to v2.3 and placed the 3C523 card back in, the hanging disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NWL102.ZIP Upload to NetWire
   DOCUMENT ID#:	FYI.P.10424
           DATE:	05NOV92
        PRODUCT:	NetWare Lite
PRODUCT VERSION:	v1.1
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This FYI concerns NWL102.ZIP available on NetWire or NetWare Express.

	INFORMATION ON SPECIFIC PATCHES

	OPENDEV.PAT - NetWare Lite Client Open Device Patch.

		Target:     CLIENT.EXE
		Checksums:  1DA, 6CB, 407, 1C30

		Problem:	When attempting to get file attributes (interrupt line 21 function 4300h) on a device (not a file), CLIENT returned an incorrect error to the calling application.

		Symptoms:	Print jobs were disappearing when sent to an LPT port that had been opened using the C fopen function.  Two examples of applications that requires this patch for CLIENT.EXE are MPM by CYMA and dBASE IV by Borland.

	STACKFIX.PAT - NetWare Lite server stack fix patch

		Target:     SERVER.EXE
		Checksums:  558, 481, 3F0

		Problem:	The server switches to its DOS reentrancy stack during initialization.  The Norton anti-virus device driver interrupts the server after initialization and does some work.  The server timer interrupts then kicks in, switches to the top of the server DOS reentrancy stack, and corrupts the data that the server had on the stack before the timer interrupt.

		Symptoms:	When the Norton anti-virus device driver is loaded and SERVER.EXE attempts to load, the server will hang.


	INT28FIX.PAT - NetWare Lite Client interrupt line 28 ISR patch

		Target:     CLIENT.EXE
		Checksums:  765, 6DE, 641, 28C, 6DE

		Problem:	Applications that are doing background printing on a NetWare Lite server/client where printing is captured to a printer connected locally may experience a server lock up.  The problem requires the station to be rebooted.  Each time the station is rebooted because of this problem, lost clusters are left on the hard drive.  If this happens enough times without running "chkdsk /f" the FAT table will become corrupted.

		Symptoms:	You may have this problem if you are running an application that performs background printing on a server/client with a printer connected locally and the station locks up.  An application that exhibits this problem is FoxPro.


	COMPOPEN.PAT

		Target:     SERVER.EXE
		Problem:    FCB Opens fail on read only files.

		This patch inserts code that was removed from v1.0 that handles FCB opens.  This patch should not be used with Windows or CD-ROM drives.


	RECONFIX.PAT - NetWare Lite Client reconnect patch

		Target:     CLIENT.EXE
		Checksums:  76A, 74F, 10EF, 66A, 64F, 8F7, 3A3, 3A3, 10EF

		Problem:	The reconnection between server and client fails to occur when the NET CAPTURE or NET PRINT commands are issued by a client to a server that has just been rebooted.  Subsequent NET CAPTURE or NET PRINT commands from the client station will work normally.

		Symptoms:	When using the NET CAPTURE or NET PRINT commands as the first commands from a client to a server that has just been rebooted, the error messages "Redirect device -- Too many open files." or "Write file -- Access denied." will be displayed and the command will fail.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Diskless PS/2 Machines Hang Running Reference Diagnostics
   DOCUMENT ID#:	FYI.P.10418
           DATE:	05NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user was running REFERENCE from a boot image file on the server.  Everything worked fine until the REFERENCE diagnostics was attempted.  The diskless workstation hung and had to be cold booted.

ISSUE/PROBLEM

	The IBM Reference diagnostics invokes the @E0000.DGS adapter diagnostics program (included on IBM REFERENCE diskette).  This @E0000.DGS program did a Token-Ring adapter reset.  This caused Novell's TOKEN.RPL code, which was sitting in workstation RAM at the time, to lose control of the adapter.  After finishing execution of the @E0000.DGS program, the reference diagnostics tried to load the next diagnostics routine that TOKEN.RPL tried to provide but could not because TOKEN.RPL could no longer access the reference boot image on the file server.

SOLUTION

	The @E0000.DGS program needs to check to see if the adapter is already initialized before resetting it.  If already initialized, the adapter should not be reset.

	Novell contacted the IBM software engineer who wrote @E0000.DGS.  He said if reference diagnostics is being run from a boot image on a file server already, then this constitutes a much more thorough adapter diagnostics than what @E0000.DGS performs.  Novell was willing to conference with IBM to help them change their code; however, the IBM engineer opted not to change the @E0000.DGS code.

	Novell recommends the following solutions to users:

	1.	Delete the @E0000.DGS file from the working copy of the REFERENCE diskette.  Then, if the user chooses to run reference diagnostics from a boot image, the adapter diagnostics routine will not execute.  The other diagnostic programs will run fine.

	2.	If the latest REFERENCE diskette is being used, the user can select from the diagnostics menu not to run the adapter check routine.

	3.	(If there are any other problems relating to running reference from a boot image, (such as workstation hangs when changing I/O Port, Shared RAM, or primary/alternate settings) try running reference from a file server subdirectory instead of from a boot image using the following steps:

		a.	Create a subdirectory off the LOGIN directory (REF).  Copy the entire contents of the REFERENCE diskette into this REF subdirectory.  You may want to delete the @E0000.DGS file out of the REF subdirectory in case diagnostics needs to be run.

		b.	Then, create a boot image that loads COMMAND.COM, LSL.COM, TOKEN.COM, IPXODI.COM, and NETX.COM.  This will get the workstation attached to the file server's login directory.

		c.	Log into the server as SUPERVISOR and change directories into the REF subdirectory.

		d.	Then type COMMAND<ENTER> at the prompt.  This will bring up the PS/2 REFERENCE program and reference can be run from the REF subdirectory.

		This procedure seems to have cleared up additional problems related to configuring adapters from a boot image reference diskette.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Upload of VRPELS.ZIP
   DOCUMENT ID#:	FYI.P.10421
           DATE:	05NOV92
        PRODUCT:	NetWare ELS Level I and Level II
PRODUCT VERSION:	v2.12, v2.15c
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This FYI concerns VRPELS.ZIP available on NetWire or NetWare Express.

	ELS users who have drives larger than 260 MB may have volumes that begin after the first 256 MB of the hard drive.  The VREPAIR.EXE that shipped with ELS does not properly repair drives with volumes starting after the first 256 MB on the drive.  These files are different ELS disk drivers linked with the latest VREPAIR.OBJ (also known as VRP215.ZIP).

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Disk Not Formatted for NetWare Network" - Stoned Virus
   DOCUMENT ID#:	FYI.P.10403
           DATE:	04NOV92
        PRODUCT:	NetWare ELS Level II
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When the user booted the server, the system displayed the following error:
		Ŀ
		Disk not formatted for NetWare network
		

	When running VREPAIR, the system displayed an error about the NetWare drive stamp missing.

ISSUE/PROBLEM

	This message is usually attributed to hardware but in this case the STONED virus was found that overwrites parts of track 0.  The changes to track 0 could be seen when using NetUtils and comparing the infected track with a good track on another server.

SOLUTION

	After the user cleaned off the virus, everything went back to normal.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Program Initialization Failure" - PSERVER.EXE
   DOCUMENT ID#:	FYI.P.10395
           DATE:	04NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user was trying to set up a dedicated print server with PSERVER.EXE that would run from the local drive instead of logging in to the file server first.  After executing PSERVER (PserverName), the system returned the following error:

		Ŀ
		Program Initialization Failure
		

ISSUE/PROBLEM

	Configuration:

		Using PSERVER.EXE v1.21
		Files copied to the local drive; IBM$RUN.OVL, PSERVER.EXE, SYS$ERR.DAT, SYS$HELP.DAT and SYS$MSG.DAT.
		SPX Connection were set to 60 in the SHELL.CFG or the NET.CFG.

	In the AUTOEXEC.BAT, the user was just loading IPX.COM and then PSERVER.

SOLUTION

	When the user loaded NETX.COM before running PSERVER, it came up just fine.

	Note:  This is documented one place in the NetWare Print Server manual on page 24 but not very clearly on page 149 where the manual describes what is needed to run PSERVER.EXE from a local drive.  Loading IPX and NETX is not mentioned at all.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Warning, Insufficient Memory to Cache Directories..."
   DOCUMENT ID#:	FYI.P.10377
           DATE:	02NOV92
        PRODUCT:	NetWare ELS Level II
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	The user had 4 MB RAM but FCONSOLE showed only 640 KB.  When the user booted the file server, it displayed the following message:

		Ŀ
		Warning, insufficient memory to cache directories.
		Not enough memory to cache volume <volume name>.  
		

ISSUE/PROBLEM

	When NetWare ELS Level II v2.12 is generated as a dedicated server, it runs in 86 mode (will run on an XT) and cannot access extended memory.
SOLUTION

	NetWare ELS Level II v2.12 must be generated as nondedicated to run in protected mode and recognize more than 640 KB of RAM.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	User Not Inheriting Security Equivalences of Group
   DOCUMENT ID#:	FYI.P.10353
           DATE:	30OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	When adding new users to a group, the added user would not inherit the security equivalences of the group.

SOLUTION

	Upgrading to SYSCON (v3.68) solved the problem.  This version of SYSCON is in SYS368.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Home Directories Not Being Automatically Created in SYSCON
   DOCUMENT ID#:	FYI.P.10340
           DATE:	29OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Home directories were not being automatically created for new users in SYSCON.

ISSUE/PROBLEM

	The "Create Home Directory for User:" field in "Default Account Balance/Restrictions" screen under "Supervisor" options in SYSCON was set to "No."

SOLUTION

	In SYSCON, it prompted for the path of the new user's home directory, ("Path to Create User's Home Directory") which is what the user was expecting.

	Set "Create Home Directory for User:" to "Yes."




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Transfer Mode Causing Problems with ELS Backup
   DOCUMENT ID#:	FYI.P.10316
           DATE:	28OCT92
        PRODUCT:	NetWare ELS Level II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	All the files (except the bindery files) and directories were inadvertently removed from the SYS: volume.  About two times per week the network software had to be reinstalled and all the files restored from backup.

ISSUE/PROBLEM

	After running through BACKUP and a RESTORE, the user noticed that the transfer mode was selected on the Maynard Mainstream system.  The transfer mode backups the server and then removes all the files backed up.  This mode is used for archiving files.

SOLUTION

	When the user switched to backup mode, the files no longer disappeared.  Maynard added the "transfer" mode to allow administrators to backup, then remove files that go unused for extended periods of time to free up disk space.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	LOGIN Hangs on NET$LOG.DAT ELS NetWare
   DOCUMENT ID#:	FYI.P.10313
           DATE:	28OCT92
        PRODUCT:	NetWare ELS Level II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	After getting the server up, the user could not log into the server.  The login process would hang while reading SYS:PUBLIC\NET$LOG.DAT.

ISSUE/PROBLEM

	The NET$LOG.DAT file was corrupted.  This is the file that holds the system login script.

SOLUTION

	At the F:> prompt, run ATTACH.EXE from the PUBLIC-5 diskette.

		Example:

			At F:> prompt, type A:ATTACH SERVER_1\SUPERVISOR to attach the user to the server.

			Then at the F:> prompt, type CD \PUBLIC to move to the PUBLIC directory.

	The Supervisor could not rename NET$LOG.DAT because it was still open.  He typed CLEAR STATION 3 at the file server console (which cleared the station holding the NET$LOG.DAT file open).  He then flagged NET$LOG.DAT SRW, then renamed it.  Then he could log in as Supervisor and recreate the system login script.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SYS2070: The System Could Not Demand Load a Support Segment
   DOCUMENT ID#:	FYI.P.10240
           DATE:	23OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM
	
	After adding the patches in NSD004.ZIP, the following message occurred:

		Ŀ
		SYS2070: The system could not demand load a support segment.
		NWCALLS was in error.                                       
		

ISSUE/PROBLEM

	The user had MS OS2 V1.3 CSD XR05015.  Novell requires the IBM OS2 V1.3 CSD 5050.

SOLUTION

	The user must replace OS2 with an IBM CSD 5050.  If the user is not able to upgrade to IBM CSD 5050, then there is not a solution.  Microsoft will not be upgrading or modifying their code.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Requester - "NWD0115: Error Getting Connection ID (0X88OF)"
   DOCUMENT ID#:	FYI.P.7994
           DATE:	23JUN92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

        SYMPTOM:	Errors: "NWD0115: Error getting connection ID (0x88oF)" and "SYS0059: An unexpected network error occurred"

ISSUE/PROBLEM

	After installing the NetWare Requester for OS2 v2.0 and rebooting the workstation, the following errors displayed after a time:

		Ŀ
		NWD0115: Error getting connection ID (0x88oF)
		
		Ŀ
		SYS0059: An unexpected network error occurred
		

	NET.CFG was configured correctly for the interrupt and IO PORT address and had no problem under the DOS drivers.

SOLUTION

	Under the LINK DRIVER NE2000 heading in the NET.CFG, the user had specified a "Frame Ethernet_802.2" option.  When specifying multiple frame types in the NET.CFG, the workstation will use the first frame type specified in the list when it does its "GET NEAREST SERVER."  The Ethernet driver at the file server was loaded with the Ethernet_802.3 frame type.  When the user changed the frame type in the NET.CFG from Ethernet_802.2 to Ethernet_802.3, the workstation no longer received the above errors and attached and logged into the server just fine.

	Another possible method of fixing the problem would be to bind the 802.2 frame at the file server.




                               FYI
(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Ground Clamp Not Allowing Second Drive to Be Recognized
   DOCUMENT ID#:	FYI.P.5085
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The second hard drive was not recognized.

ISSUE/PROBLEM

	Configuration:

		386AE file server
		Disk Coprocessor Board (DCB)
		Two embedded SCSI hard drives

	Because the user was not sure  what driver to select, he tried a generic SCSI; and the system only recognized one of the drives.  When the user tried a CDC embedded SCSI, the system also only recognized one drive.  Novell sent the user a hardware configuration from their resource manual and asked him to check the network termination setup.

	The user discovered that the ground clamp was not tight.

SOLUTION

	After the user reclamped the ground clamp, the system recognized both drives.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	IBM 24-Bit Token-Ring Busmaster/DMA Options Disk Upgrade
   DOCUMENT ID#:	FYI.P.5068
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When Fairness was displayed as being turned ON, it was really turned OFF.  When shown as OFF, it was really set to ON.

ISSUE/PROBLEM

	The original Options diskette that shipped with the Monterey adapter (IBM 24-bit busmaster Token-Ring adapter) had a problem with the *.ADF file displaying improper settings during reference.

SOLUTION

	Have users obtain the newest ECA 075 upgraded Options diskette from their IBM source.  This ECA 075 corrects the Fairness display problem.  The updated diskette's FRU number is 93F1260.  The Field Replaceable Unit (FRU) number appears on the diskette's label.  The proper firmware file is the following:

		MONT400.BIN  45440  11-19-90  5:15p    (or newer)

	Ensure that the user copies the new *.ADF files from the updated Options diskette.  One user could not get TOKENDMA.LAN to work in an IBM Model 95 because the MONT400.BIN file was corrupt.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Virus Causing dBASE Application to GPI on Nondedicated Server
   DOCUMENT ID#:	FYI.P.5078
           DATE:	31DEC91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	When the workstations ran the dBASE application, the system displayed the following errors:

		Ŀ
		Network error: Error sending on network
		
		Ŀ
		Network error: Error receiving from network
		

	The nondedicated file server/workstation received the following error when the user tried to run the dBASE application:

		Ŀ
		ABEND: General Protection Interrupt
		

ISSUE/PROBLEM

	The FRIDAY THE 13TH virus was on the same disk as the dBASE application.

SOLUTION

	After the user used the McAfee virus utility to get rid of the virus, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NCOPY Errors with Micropolis Drive Formatted in Mode 2
   DOCUMENT ID#:	FYI.P.5084
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user used NCOPY, file kept getting corrupted.

ISSUE/PROBLEM

	The Micropolis 1664-7 (300 MB hard drive) is supposed to format using 0 mode by default (Modes: 0=native, 1=17 sector, 2=60 sector).  The drive was formatted to the default, but ended up using mode 2.  Loading
	ISADISK /b worked for all functions of the network except NCOPY.

SOLUTION

	The user reformatted the drive specifying mode 0 and reinstalled.  Then when the user loaded ISADISK without the /b parameter, everything worked correctly including NCOPY.  Reformatting the drive and specifying mode 0, was the key.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"000 Token-Ring DMA Busmaster XX Adapter Check"
   DOCUMENT ID#:	FYI.P.5079
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The system displayed the following message after the user loaded the TOKENDMA adapter:

		Ŀ
		000 Token-Ring DMA busmaster xx adapter check
		

ISSUE/PROBLEM

	Configuration:

		Model 95 computer

	The Token-Ring busmaster DMA card was faulty.

SOLUTION

	When the user replaced the DMA card, the error went away.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	CHVVOL, VOLINFO, DOS DIR Show Different Information
   DOCUMENT ID#:	FYI.P.5080
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user saved a file in his word processor, the system started displaying disk full errors.  CHKVOL and VOLINFO showed 2 GB of data and 1 GB of free space available.  The DOS DIR showed 0 space available.  The user could not save any files to the network drive.

ISSUE/PROBLEM

	Configuration:

		Three 1.2 GB SCSI (SCSI IDs 4, 5, 6) drives on the Procomp FDCB set up as one large 3 GB volume.

		Restored approximately 2 GB of data.

	Procomp said their driver only supports SCSI IDs "below ID 6" (does not include 6).

SOLUTION

	When the user changed the drive addressed at ID 6 to ID 3, the system can now recognize the other 1 GB with DOS DIR and can write to it.

	Note: Procomp USA Inc. also said that their DRA.DSK drivers dated 11-06-90 (certified with NetWare v3.10 operating system) and the driver dated 09-26-91 (certified with NetWare v3.11 operating system) are identical, and the only difference is the creation date.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	HP IIIsi, QSERVER and RPRINTER
   DOCUMENT ID#:	FYI.P.5026
           DATE:	19DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user called up and explained that he was using the HP IIIsi with a Token-Ring board in the printer and using the QSERVER option as opposed to the RPRINTER option from HP.  The QSERVER mode allows the HP printer to act as its own print server.

	He was trying to install RPRINTER on a workstation and said he knew he had everything set up correctly in PCONSOLE.  However, RPRINTER was not working.

ISSUE/PROBLEM

	Neither PSERVER.EXE nor PSERVER.NLM had been loaded anywhere on the network.

SOLUTION

	For RPRINTER to run, PSERVER (.EXE or .NLM) must be loaded.  The HP IIIsi printer's "print server" will not support RPRINTER loaded at a workstation.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Adaptec 1740 BIOS Checksum Problems - SERVER.EXE
   DOCUMENT ID#:	FYI.P.5037
           DATE:	19DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10, v3.11
     SUPERSEDES:	NA
SYMPTOM

	Trouble accessing C: drive.

ISSUE/PROBLEM

	Some sites with the Adaptec 1740 (Enhanced Mode only) EISA HBA and BIOS checksum of 0C00 (on label of BIOS chip) have problems accessing the C: drive after SERVER.EXE is loaded.  If they exit to DOS from server, they the system may display a COMMAND.COM error.

SOLUTION

	Contact Adaptec Inc. technical support 408-945-2555, and ask for the BIOS with checksum of 8800.  This upgrade resolves the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR DOS Update Files for Windows
   DOCUMENT ID#:	FYI.P.5011
           DATE:	18DEC91
        PRODUCT:	DRDOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Where are update files for DOS 6.0, December 1991 release?

SOLUTION

	Some updated files that help DR DOS to work with WINDOWS are available from Digital Research Inc.

	The newest EMM386.SYS and HIDOS.SYS, as well as all future BBS files for downloading to registered DR DOS users, are available on Digital Research Inc. new public BBS.  The BBS phone number is (408) 647-6562.  It is a download only BBS with no uploading or message bases.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Boot to DOS Using PC Baseband Cards
   DOCUMENT ID#:	FYI.P.5019
           DATE:	18DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	The file server has two workstations connected to it with the end one being terminated.  Another workstation was added to the file server with a wrap plug.  Everything was fine when the workstation was added.  Suddenly, after some time, the added workstation could log in while the other two workstations could not even boot to DOS.

	If the user terminated both ends of the network, the two original workstations on the one side of the server were fine, but the added workstation could not boot to DOS.

ISSUE/PROBLEM

	The cable between the file server and one of the original workstations was faulty.

SOLUTION

	When the user replaced the faulty cable, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Disk Manager N NetWare v3.11 Hanging NetWare v2.2 Install
   DOCUMENT ID#:	FYI.P.5014
           DATE:	18DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	When the user pressed F10 at the file-server definition screen while running the INSTALL utility, the files started to copy to the hard drive and then the system hung.

ISSUE/PROBLEM

	Configuration:

		NEC 153 MB drive
		WD1007V-SE2 controller
		Ontrack's Disk Manager N utility

	Any version of Ontrack's Disk Manager N before v3.12 will not support the NetWare v2.2 operating system.

SOLUTION

	The user was using the Disk Manager N program v3.11.  As soon as the user upgraded to v3.12, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Directory Entry Contains an Invalid Filename"
   DOCUMENT ID#:	FYI.P.5000
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to mount the SYS: volume while doing a new install of a NetWare v3.11 operating system, the system displayed the following error message:

		Ŀ
		Directory entry contains an invalid file name
		

ISSUE/PROBLEM

	Configuration:

		Adaptec 1740 controller with AHA1740 disk driver

	No other volume displayed the symptom.  No matter where the SYS: volume was, it displayed the error.  The user tried using VREPAIR to fix the problem.  It looked as if VREPAIR fixed several things, but the SYS: volume still would not mount.  After running VREPAIR again, it looked as if it was fixing the same sectors; however, the SYS: volume still would not mount.

SOLUTION

	When the user loaded the AHA1740 driver using the io_combine=1 parameter, everything worked fine.

		Example:   load aha1740 io_combine=1 slot=3

	To use the io_combine=1 parameter, the AHA1740.DSK driver must be dated 03-27-91, 07-01-91, or later.  The io_combine=1 parameter disables Adaptec's "scatter gather" feature, and it should only be used with Adaptec 1740 or 1742 adapters.  The Adaptec 1740A and 1742A adapters do not require this parameter.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Timeout Second Line Offending Command.." - HP IIIsi
   DOCUMENT ID#:	FYI.P.4999
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When the user sent a second print job while printing in Printer Control Language (PCL) mode, the following error printed on a separate page after the job was printed.

		Ŀ
		ERROR: Timeout second line offending command: timeout error:
		       undefined offending command                          
		

	The job printed just fine.

ISSUE/PROBLEM

	Configuration:

		The printer modes and functions were set up exactly as explained in the HP manual.

	Evidently, the printer was not being reset to the Postscript mode as stated in the HP manual.

SOLUTION

	When the user put a command to change to PS mode in the reinitialize function, the printer worked fine.

	If the user wants to have the HP IIIsi in PostScript Mode and switch between PS and PCL, the configuration needed is shown as follows:

	Using PRINTDEF define the following:

	        HP LaserJet IIIsi-PCL          (device)
	          Switch_to_PCL                (mode)
	             Universal Exit Language   (function)
	             PJL-Enter PCL             (function)
	          Re-initialize                (mode)
	              Universal Exit Language  (function)

	         HP LaserJet IIIsi-PS          (device)
	           Switch_to_PS                (mode)
	              Universal Exit Language  (function)
	              PJL-Enter PS             (function)
	           Re-initialize               (mode)
	              Universal Exit Language  (function)

	Use PRINTCON to set up two print job configurations, one for PostScript and one for PCL.

		In both of the print job configurations:

			Set timeout to disabled.
			Set suppress form feed to yes.
			Set tabs to no.
		In the configuration for PS:

			List the device as HP LaserJet IIIsi-PS.
			Set the mode as Switch_to_PS.

		In the configuration for PCL

			List the device as HP LaserJet IIIsi-PCL
			Set the mode as Switch_to_PCL.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Create STARTUP.NCF on PS/2
   DOCUMENT ID#:	FYI.P.4998
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was installing a NetWare v3.11 operating system on a PS/2 with IBM SCSI drives.  When the user tried to load the SCSI driver from the C: drive using DOS v5.0, the system displayed the following error:

		Ŀ
		Unable to create file STARTUP.NCF
		

	The system displayed the same error when the user tried loading the driver from the A: drive also.

ISSUE/PROBLEM

	The SCSI ID was set at 1 on this drive.

SOLUTION

	Novell instructed the user to set the HBA to ID=7, the SCSI drives (two of them) at 6 for the boot-able drive, and the other drive at 5.  After the user reset the address, INSTALL was then able to create the STARTUP.NCF.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"NetWork Error Receiving" Compex Drivers
   DOCUMENT ID#:	FYI.P.5008
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	Every time the user accessed any utility from the file server, the system displayed the following error message:

		Ŀ
		Network error: Error receiving from network
		

ISSUE/PROBLEM

	Configuration:

		SMC PC-500 in file server
		SMC driver v1.03
		Compex eight-bit cards in the workstations

	The user could use DIR to look at a network directory and TYPE to display a file on the screen.  However, as soon as the user ran FCONSOLE or any other utility, the system displayed the error.

	The error still displayed even after the user replaced the file server LAN card three times.

SOLUTION

	When the user changed the workstation driver from the Compex LAN driver to a Novell RXNET driver, the error disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Problem with Drive 01: Error Reading Disk..."
   DOCUMENT ID#:	FYI.P.5002
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	Unable to read sector 14 on new drive.

	After the user added a new Micropolis 1588-15, the system displayed the following message when running COMPSURF:

		Ŀ
		Problem with drive 01: Error reading disk redirection      
		information on sector 14.  Abend: Attempt to configure     
		a non-operating drive.  Repair drive or remove from system.
		

ISSUE/PROBLEM

	The new drive was faulty.

SOLUTION

	After trying a myriad of things, the user sent the drive back and got another one of the same model which worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"NE2000 Hardware Failure during Card..."
   DOCUMENT ID#:	FYI.P.4987
           DATE:	16DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA
SYMPTOM

	The user was setting up a dual boot machine.  It would boot to DOS and connect to the network just fine, but when he booted to OS/2 and loaded the requester, the system displayed the following error.

		Ŀ
		NE2000 hardware failure during card initialization
		

	The user's NET.CFG had the following setup:

		Link NE2000
		        INT 5
		        PORT 360

	The NET.CFG was only executing the first two lines and the third line was ignored.  If the user added a frame type to the setup, it would execute all commands and he could log into the network.

ISSUE/PROBLEM

	If there is not a hard return after the last line in the NET.CFG, the OS2 operating system ignores the last line during execution.

SOLUTION

	When the user put a hard return after PORT 360 and took out the frame type, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: Free IPX Block Already on Free List
   DOCUMENT ID#:	FYI.P.4975
           DATE:	13DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"NetBIOS "Abend: Free ipx block already on freelist"
ISSUE/PROBLEM

	Configuration:

		SMCs v2.30 drivers for both the server and workstations

	When the user extended the Arcnet cable segment, the system began displaying the following error:

		Ŀ
		NetBIOS "Abend: Free ipx block already on freelist
		

SOLUTION

	When the user switched to using TRXNET drivers for both workstation and file server, the error disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Communication Buffers Exceeding Maximum Limit - ALR 486/33
   DOCUMENT ID#:	FYI.P.4982
           DATE:	13DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	Communication buffers (or routing buffers) exceeding maximum limits.

ISSUE/PROBLEM

	When the user was using an SMC PC-500 Arcnet "Long board" with the SMC Turbo II driver in an ALR 486/33 file server, the communication buffers kept exceeding maximum limits.

SOLUTION

	Slow down the file server to 25 MHz.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Mylex Motherboard and SD SCSI Adapter Problems
   DOCUMENT ID#:	FYI.P.4978
           DATE:	13DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10, v3.11
     SUPERSEDES:	NA

SYMPTOM

	During heavy read and writes, the file server stopped and received the following error messages:

		Ŀ
		ABEND: Invalid Opcode Processor Exception
		
		Ŀ
		ABEND: General Protection Processor Exception
		

	The user was running NetWare v3.11 without DUPDSKFX and CACHEFIX patches.  However, after these patches were applied, the errors continued.

	The user already had newest PAL chips from Mylex (this is something to check when looking at Mylex 486 EISA boards).  The user also had a Thomas-Conrad Fiber Optics card (TCNS); however, after removing it also, the errors continued.

	The Cache Buffers percentage was always above 50 percent.

ISSUE/PROBLEM

	Configuration:

		Mylex 486 (MAE) EISA machine
		Storage Dimensions 3222b SCSI Adapter
		LANSTOR5.DSK v4.1 driver

	Storage Dimensions Inc. said that some of their 3222b SCSI Adapters (32 bit) have problems with Mylex 486 EISA motherboards.  BusTek makes the 3222b adapter.  If users send the adapter to BusTek, they will replace the necessary chips.

	Storage Dimensions also stated that their SDC 1602b adapter does not have this problem with Mylex 486 EISA motherboards.  The SDC 1602b (16-bit) and 3222b (32-bit) SCSI adapters, with MCode 2.21 or greater and BIOS 2.41 or greater, do not have this problem with Mylex 486 EISA motherboards.

SOLUTION

	In this case, the user chose to replace their 3222b with a 1602b adapter.  After the user replaced the adapter, the system is up and running fine.

	The SDC 1602b adapter is newer than the SDC 1602 adapter.  Also, the LANStor5 driver v4.1 has the functionality of the DUPDSKFX patch built-in.  It has this because if you try to load DUPDSKFX.NLM after loading this driver, it will return the message "DUPDSKFX is already loaded".




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Duplexing ESDI Controllers on PS/2 Machines
   DOCUMENT ID#:	FYI.P.4959
           DATE:	12DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Unable to duplex ESDI Controllers on PS/2 Machines

ISSUE/PROBLEM

	More than one ESDI controller in a PS/2 machine will not be recognized by the Reference program.  Therefore, duplexing with two ESDI controllers is not supported.  However, duplexing ESDI with SCSI adapters or duplexing with two SCSI adapters is supported.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"No Accessible Disk Drives" - Storage Dimensions
   DOCUMENT ID#:	FYI.P.4968
           DATE:	12DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user used the following system to install NetWare and configure the subsystem.  The drives had been formatted and DOS partitions set up.  He booted from the drives, loaded server, the disk driver, and INSTALL.  However, when he chose Disk options, the drives could not be recognized, and the system displayed the following error:

		Ŀ
		No accessible disk drives
		

	The user verified that the termination and cabling connections were fine.

ISSUE/PROBLEM

	Configuration:

		Compaq 33L EISA file server
		Disk subsystem
		One - IBM Token Ring card
		Two - Storage Dimensions 16 bit controllers (duplexed)

	Storage Dimensions drivers require that a drive ID be set up on the drives.

SOLUTION

	When the user ran LANSTOR.EXE from DOS to create the IDs, then INSTALL worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: Stack Fault Processor Exception - IMC PCNIC
   DOCUMENT ID#:	FYI.P.4965
           DATE:	12DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Abend: Stack Fault Processor Exception"

ISSUE/PROBLEM

	When the user loaded the driver for the IMC PCNIC 16-bit UTP card, the system displayed the following error message:

		Ŀ
		Abend: Stack Fault Processor Exception
		

SOLUTION

	A newer driver available from IMC dated 11-19-91 solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Directory Sector Data Mirror Mismatch"
   DOCUMENT ID#:	FYI.P.4950
           DATE:	11DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	While trying to boot, the system displayed the following error message:

		Ŀ
		Directory sector data mirror mismatch
		

ISSUE/PROBLEM

	The user had recently restored data from a Maynard tape backup unit.

SOLUTION

	When the user suspected that a problem occurred during the restore, he copied the SYSTEM and PUBLIC files back to the file server.  After the user copied the files to the server, the system booted without the error.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Faulty Cable Causing "Internal Stack Overflow"
   DOCUMENT ID#:	FYI.P.4951
           DATE:	11DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	The user had just upgraded to a NetWare v2.2 from 2.0a operating system and added 1 MB of memory to the server during the upgrade.  The user also added a Packard Bell PB900 computer as a workstation.  When the Packard Bell logged in to the server, the file server stopped and displayed the following message:

		Ŀ
		Abend: Internal Stack Overflow
		

	None of the other nodes caused the server to stop and send the abend message.  When the Packard Bell computer was replaced with another computer, the server still had the same problems.

ISSUE/PROBLEM

	The problem was a faulty cable between the workstation and the server.
SOLUTION

	Replacing the cable to that workstation fixed the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Packed File Corrupt" PS-110 with v1.0 Driver
   DOCUMENT ID#:	FYI.P.4945
           DATE:	11DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	"Packed file is corrupt."

ISSUE/PROBLEM

	The user changed the server machine to a new machine.  The user also transferred hard drives to the new machine and replaced the server network interface card with a PC-500 (using driver v2.30).  From then on, every time a Model 60 workstation tried to log in, it received the following error:

		Ŀ
		Error "Packed file is corrupt.
		

	Every other machine on the LAN, mostly PS/2 Model 30/286 machines, worked fine.

SOLUTION

	The user ended up having to upgrade the workstation driver on the Model 60 (with PS-110 card in it) from v1.00 to a later version.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Model 34, 40 Motherboard without Interrupt Line 19
   DOCUMENT ID#:	FYI.P.4941
           DATE:	11DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	PS/2 models 35 and 40 cannot remote boot

ISSUE/PROBLEM

	Models 35 and 40 BIOS on motherboard do not have an interrupt line 19, so Novell boot PROMs cannot hook interrupt line 19 to enable remote boot.  These BIOS chips only have an interrupt line 18 that calls ROM basic in case of no Master Boot Sector found.

SOLUTION

	Have users request Engineering Change Announcement (ECA) 087 and ECA 085 for the Model 35 and Model 40.  These are new back planes (motherboards) that include interrupt line 19 along with interrupt line 18 BIOS routines.  ECA 087 is the main ECA number; however, ECA 087 is also part of the upgrade.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Corrupt AHA Driver Causes Wrong Drive Size in INSTALL
   DOCUMENT ID#:	FYI.P.4940
           DATE:	11DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was doing a fresh install of a NetWare v3.11 operating system with the following configuration:

		386/25 ISA clone, 8 MB RAM
		Maxtor 340 MB SCSI drive
		Adaptec 1542B controller
		BIOS revision 3.01
		AHA1540.DSK dated 03-27-91

	The drive had a 4 MB DOS partition.  The user brought up server to create a NetWare partition.  The user created the partition, then INSTALL prompted that free space available was more than 51 GB (this was a 340 MB drive).  When the user went ahead and created the NetWare partition, the partition showed that it was more than 51 GB.

ISSUE/PROBLEM

	The AHA1540.DSK driver was corrupt.

SOLUTION

	When the user loaded a new driver, everything worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Summary of 3Com Network Interface Cards
   DOCUMENT ID#:	FYI.P.4919
           DATE:	10DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The following list attempts to summarize the various names and numbers that are used to refer to 3Com network interface cards.

Ŀ
 Product               Name                       Assemblies     
Ĵ
3C100     Ethernet Transceiver                                   
3C501     Etherlink                         345/780/1221         
3C503     Etherlink II                      2227                 
3C503 TP  Etherlink II                      Built in transceiver 
3C505     Etherlink Plus                    1194/2012            
3C507                                                            
3C523     Etherlink/MC                      MCA Inc. transceiver 
3C523 TP  Etherlink/MC                      MCA Inc. transceiver 
3C603     Token Link                        Token Ring           
3C605     Token Link Plus                   Token Ring           
3C1100    3-Station                                              
NW1000    NetWare Ready Ethernet Card (BNC) 06-0094 8-Bit ISA    
NW1000-TP NetWare Ready Ethernet Card (TP)                       


SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Summary of Adaptec Host Adapters
   DOCUMENT ID#:	FYI.P.4918
           DATE:	10DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Non-Bus Master Adapters are the following:

		AHA1520  for ISA AT type machines
		AHA1522  for ISA AT type machines

	Drivers for the above adapters are available as product (not free) reference ASW1240 that must be revision 3.1 to function correctly with NetWare v2.2 and v3.11 operating systems.

	Bus Master Adapters are :

		AHA1540  for ISA AT type machines (16 bit)
		AHA1542  for ISA AT type machines (16 bit)
		AHA1640  for Micro channel machines (16 bit)
		AHA1740  for EISA machines (32 bit)

	The newest drivers for these cards are available from Adaptec as product (not free) reference ASW1440 that must be revision 3.1 to function correctly with NetWare v2.2 and v3.11 operating systems.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Real World Accounting - ABEND Errors, NetWare v2.2
   DOCUMENT ID#:	FYI.P.4914
           DATE:	10DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	The user was trying to run Real World Accounting Software on a nondedicated file server.  This software worked with a NetWare v2.15c operating system running nondedicated.  When the user upgraded to a  NetWare v2.2 operating system, the nondedicated server displayed the following error when the user tried to load the Real World (v4.0) software:

		Ŀ
		ABEND: Invalid channel semaphore state on other process release
		

	When the user upgraded the Real World software to the newest version, the server displayed the following error message:

		Ŀ
		ABEND: General Protection Interrupt ( GPI ) running process FSP #8
		

ISSUE/PROBLEM

	The files were corrupt.

SOLUTION

	When the user reinstalled the files for Real World, everything worked fine.  The user did not change any parameters, just reinstalled.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Boot, Load Operating System from Floppy - MS DOS 5.0
   DOCUMENT ID#:	FYI.P.4928
           DATE:	10DEC91
        PRODUCT:	NetWare ELS I
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	The hard drive failed, so the user tried to boot the operating system from a floppy diskette.  After entering NET$OS, the floppy drive (A: drive) went active, but did not load anything.  Thinking that he drive was faulty, the user booted it with one of the workstation boot disks, and it worked fine.

ISSUE/PROBLEM

	Configuration:

		Dedicated file server - DTK 286 machine

	After checking the differences between the two diskettes, the user found that the one that did not work was MS DOS v5.0.

SOLUTION

	The diskette that did work was DOS v3.3.  Using DOS v3.3 allowed the NET$OS.EXE to load successfully.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Cannot Attach to the File Server Using Remote Boot
   DOCUMENT ID#:	FYI.P.5077
           DATE:	31DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	While trying to remote boot using Proteon 1344, 1345, 1346, and 1347 cards, the user could not attach to the server.

ISSUE/PROBLEM

	Proteon Technical Support told the user that the image file had to have the name PRO4$AT.SYS.

SOLUTION

	Run DOSGEN to create NET$DOS.SYS and rename the image file to PRO4$AT.SYS.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	GPPEs with Mylex Card - Northgate 433E
   DOCUMENT ID#:	FYI.P.5001
           DATE:	17DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user's system kept displaying a "General Protection Processor Exception" error message.

ISSUE/PROBLEM

	Configuration:

		Mylex DCE 376 SCSI controller
		Storage Dimensions EISA controller in a Northgate Elegance 433e

	Mylex Corp. said the user's system needed updated ROM.  When the user replaced the RAM with Northgate RAM and tried a different SCSI card (sdc3222), the error still displayed.

SOLUTION

	When the user finally pulled the Mylex card and bought a different controller all together, the error ceased.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	GPPE Loading SERVER on EISA Machine
   DOCUMENT ID#:	FYI.P.5168
           DATE:	10JAN92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user put in the file-server boot diskette and typed SERVER, the machine, a Gateway 2000 486/33E, would chug for a minute and then display the error following error:

		Ŀ
		ABEND: General Protection Processor Exception
		

	When the user tried the diskettes on another machine, everything worked fine.

ISSUE/PROBLEM

	The machine was supposed to have 8 MB of RAM.  During POST (Power On Self Test), it counted to 8 MB.  Typing MEM showed 8 MB.  However, when the user ran EISA CONFIGURATION, it showed only 3 MB.

SOLUTION

	The user configured the machine through EISA CONFIGURATION to reflect the 8 MB that was physically installed.  After reconfiguring the machine, SERVER.EXE executed just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Token-Ring Shared RAM Override
   DOCUMENT ID#:	FYI.P.9397
           DATE:	18JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user tried using the original DOS ODI files from NetWare v3.11 software to override the shared RAM address; however, it did not work.  Then when the user tried DOSODIFT.ZIP file, it still did not work.

ISSUE/PROBLEM
	The ROM address cannot be changed but the shared RAM can.

SOLUTION

	Use the following example to change the shared RAM address in NET.CFG:

	        LINK DRIVER TOKEN
	             ; override the shared ram address
	             ; don't forget to make the address five hex digits
	             MEM #2 D4000

	This information may not be consistent from board to board depending upon how the driver is written.  However, this is true for Token-Ring.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NNS Utilities and Diskette Listing
   DOCUMENT ID#:	FYI.P.9396
           DATE:	15JUL91
        PRODUCT:	NetWare Naming Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The following is information on NNS utilities.

	When NetWare Name Service (NNS) has been installed on a set of servers and one or more of those servers are being upgraded to a NetWare v2.2 or v3.11 operating system, there has been some confusion about what set of utilities to use.  Should the user use the utilities from NetWare v3.11 or v2.2 software or should they reinstall the NNS set of utilities?  The utilities that ship with these versions of NetWare have been labeled as NNS "aware" utilities; however, some of them do not function properly with NNS.

	NNS, among other things, creates NNS objects upon installation, adds a level called profiles to the server, and sets up logical print queues across the domain servers.  A NNS aware utility is "aware" of these new objects and features.

	Example:

		Lets suppose you have two servers, FS1 and FS2, in a domain.  On FS1 you have a printer attached and have created printq_1 as the print queue.  FS2 will have a queue called printq_1 that is a logical queue pointing to the FS1 queue.  With a NNS AWARE capture, you are able to capture to the FS2 printq_1.  The CAPTURE SH command shows that you are currently captured to FS1, printq_1.  Capture is "aware" that the FS2, printq_1 is a logical queue pointing to FS1, printq_1.

	Usually the question of what set of utilities to use comes up when a site has NNS installed and is upgrading to a NetWare v2.2 or v3.11 operating system.  After the new set of utilities is copied to the server, the users want to know whether they should reinstall the NNS utilities to the servers.  The current recommendation is the NNS set of utilities should be recopied to the drive.  At this time, some of the NetWare v2.2 and v3.11 utilities are not NNS aware.  The following is a list of those utilities and an abbreviated explanation of why they are not NNS aware:

	SETPASS.EXE v3.54 32525 01-25-91 2:17p (v3.11/v2.2)

		This version of SETPASS.EXE recognizes the existence of NNS and that the server you are attempting to change the password on is in a domain.  However, when you execute SETPASS, it returns the message "You need to use a NetWare Name Service SETPASS to change your password."

	LOGIN.EXE v3.58 108437 02-08-91 4:19a (v3.11 and v2.2)

		This version of LOGIN.EXE does not recognize the existence of a profile; therefore, the profile script does not get executed.

	LOGOUT.EXE v3.55 23675 01-31-91 4:13p (v3.11 and v2.2)

		This version of LOGOUT.EXE does not recognize the @domain option.  Logout @(domain name) will return a usage error of "illegal control characters found in command line," or will hang the workstation.

	ATTACH.EXE v3.55 35169 01-23-91 10:44a (v3.11 and v2.2)

		This version of ATTACH.EXE does not recognize the @(domain option).  Attach (user name)@(domain name) returns "Unknown file server" message.

	MAKEUSER.EXE v3.52/3.60 202017/149123 (NNS, v3.11, and v2.2)

		These versions of MAKEUSER.EXE do not work with the #PROFILES option.  This is being treated as a documentation error by Novell.  It is being treated as such because the MAKEUSER.EXE code does not have the #PROFILES option in it.  On page 87 of the NetWare Name Service manual,  #PROFILES is shown as an option.

	Only a few NetWare utilities have been enhanced for use with NNS.  The following is a list of those utilities:

		ATTACH, CAPTURE, LOGIN, LOGOUT, MAKEUSER, NETCON, NPRINT, PCONSOLE, SETPASS, SLIST, SYSCON, VERSION, and WHOAMI

	A brief description of these utilities can be found on page 69 of the NetWare Name Service manual.

	Q:	What happens to the domains and profiles and queues and anything else that was created by NNS using the NETCON.EXE utility after a file server has been upgraded from a NetWare v2.1x or v3.x to v2.2 or v3.11 operating system?

	A:	To make this question easier to answer, let us view NNS in the following way.  NNS could be divided into two initial processes, the installation of NNS and the creation of NNS on the server.

      	First, the installation of NNS is done by NSINSTAL.EXE.  Its function is to copy the NNS utilities to the file server that you specify as the target.  After the initial install, NSINSTAL can be run from that server and the NNS utilities can be installed on additional servers using the network method.  This is similar to NETGEN.EXE.

      	Second, the creation of NNS.  This is done by using NETCON.EXE that sets up domains and profiles.

	    	The first effects the utilities, and the second effects the bindery.  When a server is upgraded, the bindery is either transferred to the new format as in a NetWare v2.x to v3.x upgrade, or the bindery is not modified as in NetWare v2.1x to v2.2 upgrade.  Therefore, the domain and profile information in the bindery is still intact and only the NNS utilities are effected by an upgrade.  NSINSTAL should be used to reinstall the NNS utilities to the file server.

	Note:  Also see FYI.P.2480.

SOLUTION

	NA



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printer Losing Connection from Network after Loading Turbo RxNet
   DOCUMENT ID#:	FYI.P.9395
           DATE:	12JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v2.15c
     SUPERSEDES:	NA

SYMPTOM

	Printers losing connections from network and server hangs after loading Turbo RxNet

ISSUE/PROBLEM

	The user loaded the Turbo RXNet driver v2.2 on the NetWare v2.15c installation.  After about an hour, the printers began losing connections from the network; then finally the server locked without an error message.

SOLUTION

	When the user went back to the using the Turbo RxNet driver 2.15c, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DOS Environment Scrambled - ELS NetWare
   DOCUMENT ID#:	FYI.P.9392
           DATE:	11JUL91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When nondedicated workstation would log in to the network, the DOS environment would be scrambled after logging in on this workstation.

ISSUE/PROBLEM

	The user had the following in the AUTOEXEC.BAT file:

		NET$OS.EXE
		set disp=123
		NET3
		F:
		Login

SOLUTION

	The solution was to move the set disp=123 after the F: command.  This case is similar to the problem with the prompt $P$G also needing to be positioned below the F: command.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Incorrect Disk Space Reported
   DOCUMENT ID#:	FYI.P.9393
           DATE:	11JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Incorrect disk space reported between DIR and VOLINFO

ISSUE/PROBLEM

	Configuration:

		PS/2 model 55 workstation
		NetWare v2.15 shell
		Logged in to the network as Supervisor

	When the user issued a DIR command, the system showed about 50 MB of disk space left on the network.  However, when the user issued the VOLINFO command, the system showed 114 MB of disk space left on the network.

SOLUTION

	After the user upgraded the shell to NetWare v3.01 revision D, the disk space reported from DIR and VOLINFO matched.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to find BASEDD001.SYS..." - Cannot RIPL with an OS/2
   DOCUMENT ID#:	FYI.P.9394
           DATE:	10JUL91
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3
     SUPERSEDES:	NA

SYMPTOM

	Unable to Remote Initial Program Load with OS/2.

ISSUE/PROBLEM

	When the user tried to use Remote Initial Program Load (RIPL) with an OS2 machine, the system displayed the following error:

		Ŀ
		Unable to find BASEDD001.SYS in the default directory.
		

	Also, the system will receive an error when it tries to load SPX.SYS as it goes through the requester statements in the CONFIG.SYS file.

SOLUTION

	The first error is a rights problem.  Page 17 of the OS/2 Requester v1.3 manual states that you must grant R and F rights to the user for the SYS:RPL directory.  The user must also have all rights to the SYS:RPL\USER\name directory and to SYS:RPL\COMPUTER\node directory.

	SPX.SYS was not designed to be loaded using RIPL.  However, it can be loaded by moving the device statements for SPX.SYS and SPDAEMON.EXE to the bottom of the CONFIG.SYS file.

	If you are using the Token Ring 16/4 adapter, then RIPL only works at interrupt line 2.

	The named pipe support drivers NMPIPE.SYS and NPSERVER.SYS cannot be loaded using RIPL.  This means diskless OS/2 workstations can be used on a NetWare network, but cannot access a named pipe server such as Microsoft's SQL Server.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NUT.NLM 386 Utility Interface Module
   DOCUMENT ID#:	FYI.P.9389
           DATE:	09JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What does the NUT.NLM, which is automatically loaded with CLIB when PSERVER is run, do in a NetWare v3.11 operating system?

SOLUTION

	The NUT.NLM is the NetWare 386 Utility User Interface module.  It is similar to CLIB and STREAMS in that programs can make calls to the utility.  Specifically, it is the C-Worthy interface calls.  It allows for common code, usually linked in with every program, to be globally available.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Recreating LOGIN Directory in NetWare v3.11
   DOCUMENT ID#:	FYI.P.9391
           DATE:	06JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user inadvertently deleted the LOGIN directory from SYS: volume. Then he recreated the SYS: volume and copied the files back into the directory with a COPY command.  When booting a workstation, it could not locate the LOGIN directory, so the user had to log in from a floppy diskette.

ISSUE/PROBLEM

	When the shell attaches you to the server, it maps you to a specific internal directory number (LOGIN).  As part of the process to mount the SYS: volume, the operating system checks to verify that the LOGIN directory is the correct internal directory number, and if not, the operating system changes it.

	This can be verified by renaming the LOGIN directory to something else and then attaching to the server.  You will get a drive mapped to that new directory.  This only works until you dismount and remount the SYS: volume because the operating system then recognizes that the LOGIN directory no longer corresponds to the correct internal directory number.  Then you must create a LOGIN directory and dismount and remount the SYS: volume.

SOLUTION

	Dismount and remount the SYS: volume.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	CACHEFIX and WDOGFIX Not Showing Up in Modules
   DOCUMENT ID#:	FYI.P.9382
           DATE:	03JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.0
     SUPERSEDES:	NA

SYMPTOM

	The user loaded CACHEFIX, WDOGFIX, and other patches.  Why did the other patches show in MODULES when CACHEFIX and WDOGFIX did not show?

ISSUE/PROBLEM

	CACHEFIX (CACHFX.ZIP) and WDOGFIX (WDOGFX.ZIP) are semi-static patches and not dynamic.  Patches that are not dynamic do not show up in the MODULES command but are recognized by PATCHMAN.

SOLUTION

	MODULES does not show patches that are not dynamic (NLMs).  They can be seen by typing PATCHES at the colon prompt when PATCHMAN is loaded.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: Disk Not Upgraded to Advanced NetWare
   DOCUMENT ID#:	FYI.P.9384
           DATE:	03JUL91
        PRODUCT:	NetWare I
PRODUCT VERSION:	v2.0a
     SUPERSEDES:	NA

SYMPTOM

	When booting, the system displayed the following error:

		Ŀ
		Abend: Disk not upgraded to Advanced NetWare
		

ISSUE/PROBLEM

	After replacing a crashed drive, the user used DISKMANAGER/N to format the drive; then ran START.BAT.  When it took a long time to finish, the user rebooted and finished with PREPARE and INSTALL, but used options 2, 3, and 5.

SOLUTION
	Without realizing it, using options 2, 3, and 5 omitted the installing of the server name.  So, the user deleted the partition and ran INSTALL option 1 that included naming the server.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: NMI Parity Error Generated by I/O
   DOCUMENT ID#:	FYI.P.9383
           DATE:	02JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10a
     SUPERSEDES:	NA

SYMPTOM

	When the user loaded SERVER.EXE to do the installation, the server displayed the following error:

		Ŀ
		Abend:NMI Parity Error generated by I/O
		

ISSUE/PROBLEM

	Configuration:

		File server:  AST Premium 386 with a VGA monitor
		LAN board:    SMC Ethernet (16 bit)
		Hard disk:    SCSI

	Certain EGA/VGA boards use interrupt line 2 for some of their services.  Monochrome boards do not do this.  The user may have been using interrupt line 2 for one of the other boards.  This would cause the system to stop and send an abend message.

	VGA and some EGA boards offer a video feature connector (usually the top side of board).  This edge connector and associated circuitry are provided for possible future connections and feature compatibility to the IBM PS/2 display adapter.  The feature connector uses interrupts to service the peripherals connected.  This is where the conflict sometimes comes into play.

SOLUTION
	The user replaced the VGA monitor and board with a monochrome monitor and board.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Cables Causing Printing Problems in WordPerfect
   DOCUMENT ID#:	FYI.P.9385
           DATE:	02JUL91
        PRODUCT:	NetWare and Print Server
PRODUCT VERSION:	v3.10
     SUPERSEDES:	NA

SYMPTOM

	Printing had been working using several different applications, including Lotus and WordPerfect.  One day, when the user printed a WordPerfect document, all spaces had been removed.  Lotus worked fine; although, the system did display some Lotus error message regarding memory problems.

ISSUE/PROBLEM

	The user tried to find the cause by searching all possibilities from new cables and ports to setting up WordPerfect printing again, as well as redoing queues, and using new copies of all printer files.

	Because the printer was an older HP laser, the user thought it probably could not reset itself.  However, he determined it was resetting by sending various types of print jobs.

	Finally, when the user decided to monitor the serial printer cable, he discovered that XON/XOFF was not working (although different cables did the same thing and had been working before).

SOLUTION

	After making his own cable, everything prints fine.




                               FYI
(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"NIC Initialization Signature Not Found"
   DOCUMENT ID#:	FYI.P.9386
           DATE:	02JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	The user had DOS=high and device=EMM386.SYS in the CONFIG.SYS file and was trying to load both IPX and NET5 to high memory.  When the user executed NET5, the system displayed the following error for his Arcnet board that used a base memory address of C000:

		Ŀ
		NIC initialization signature not found
		

ISSUE/PROBLEM

	The user discovered that if he took Device=EMM386.SYS out of the CONFIG.SYS, everything worked fine; however, IPX and NET5 could not be loaded in to the Upper Memory Block (UMB).

SOLUTION

	When the user put Device=EMM386.SYS NOEMS X=C000-C800 in the CONFIG.SYS, then everything worked fine while IPX and NET5 were loaded high.  The X represents Exclude, which kept any other program from stepping on the base memory address for the Arcnet board.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Novell CoaxMux Boards in a 386 Box
   DOCUMENT ID#:	FYI.P.9390
           DATE:	02JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	How many CoaxMux boards can you put in one 386 box?

SOLUTION

	The answer depends on what software you are running.

	If you are running Novell SNA Gateway software, one CoaxMux board is required per box.

	To add a second CoaxMux board, you need a second PC and a second copy of Novell SNA Gateway software.  Novell SNA Gateway software also supports Synchronous Data Link Control (SDLC) and Token-Ring connections.

	If you want to use Novell's NetWare for SAA software (a collection of NLMs), then you will not be able to use any CoaxMux adapters.  NetWare for SAA only supports SDLC and Token-Ring connections.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SYS: Volume Will Not Mount Due to a Faulty System Board
   DOCUMENT ID#:	FYI.P.9387
           DATE:	01JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.1
     SUPERSEDES:	NA

SYMPTOM

	The user was having problems with the SYS: volume not mounting all the time.

ISSUE/PROBLEM

	Configuration:

		NEC BusinessMate with a Storage Dimensions LANstore subsystem

	The user updated the LANstore driver but still had problems.  The cause ended up being a faulty system board.

SOLUTION

	After the user replaced the faulty system board, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: Unable to Reset Hard Disk Running Process Disk
   DOCUMENT ID#:	FYI.P.9374
           DATE:	30JUN91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	"Abend: Unable to reset hard disk running process disk"

ISSUE/PROBLEM

	At the same time the user moved the network, he wanted to change from nondedicated to dedicated and from Token-Ring to Ethernet.  At the new sight, the operating system installed fine.  However, as soon the cold boot loader came up, the system displayed the following error:

		Ŀ
		Abend: Unable to reset hard disk running process disk
		

	When the user booted from a floppy diskette, the same error displayed.

SOLUTION

	After the user regenerated the operating system as nondedicated, it came up fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"LAN A Initialization Failure Signature Missing"
   DOCUMENT ID#:	FYI.P.9376
           DATE:	28JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15a
     SUPERSEDES:	NA

SYMPTOM

	The user was running NetWare v2.15a on a PS/2 Model 80 with a 300 MB ESDI hard disk and using a Pure Data PDI508 network board.  When the server crashed, the user regenerated the server from the original diskettes because he did not have the working copies.  When he tried to boot the server, the system displayed the following error:

		Ŀ
		LAN A initialization failure signature missing
		

ISSUE/PROBLEM

	The user had used an old REFERENCE disk for the Model 80 that was not properly setting up all the hardware.

SOLUTION

	When the user used the new REFERENCE disk and ran the AUTOMATIC CONFIGURATION option, the system booted just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	"A File Server Could Not Be Found" at Login - NetWare v3.1
   DOCUMENT ID#:	FYI.P.9375
           DATE:	28JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.1
     SUPERSEDES:	NA

SYMPTOM

	An SMC 3016 LAN board (16-bit Ethernet 10base-T) was added to the file server that already had a Thomas Conrad 16-bit Arcnet board, thus creating an internal bridge.  When workstations on the Ethernet side of the bridge tried to log in, the system displayed the following error:

		Ŀ
		A file server could not be found
		

ISSUE/PROBLEM

	The user was using the latest version of the 3016 driver, v2.70 from SMC.  The user also tried numerous actions such as replacing cables, bypassing the concentrators, and generating different versions of the shell using SHGEN and WSGEN without success.

	Advanced Logic Research Inc. technical support said that if the PAL chip on the ALR system board is not revision E or higher, the file server will not run Ethernet.  The user had a revision lower than E.

SOLUTION

	After installing a new system board from ALR, the system worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	New Command Line Options for DOS Workstation Shell
   DOCUMENT ID#:	FYI.P.9379
           DATE:	27JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The NetWare DOS Workstation Shell v3.20 (NETX) includes two new command-line options: /C and /F.  The /C option was also in the shell v3.10.

	THE /C OPTION

		The /c option allows users to specify a configuration file for shell configuration.  Instead of having the system automatically look for a prenamed configuration file, users can designate the configuration file by entering the following syntax: netx /c=[path\]filename.ext

		The /c command is not case-sensitive: "/C" is also valid.  If no path is designated, the current directory is the default directory.  If no extension is given in the command string, none is assumed.  If the filename has an extension, it must appear in the command string.

		If the /c option is not specified when the user loads the shell, the shell gets configuration information from either NET.CFG or SHELL.CFG.

		When the shell loads, it displays the file name of the file being used to configure the shell.  This will help support personnel to find the active configuration file.

		The /c option is listed with other shell options that appear when a user enters the "netx /?" command.

	THE /F OPTION

		The /f command line option in the shell allows users to unload the shell forcibly.  The shell has a current unload option, /u.  However, the /u option does not unload the shell if other  terminate-and-stay resident (TSR) applications were loaded after the shell; however the /f option will.

		A user forces the shell to unload by typing the following at the command line: netx /f

		The option is not case-sensitive: "/F" is also valid.   The /f option does not allow the shell to be unloaded if any interrupts are hooked.
		The /f option appears with other shell options listed when a user enters "netx /?" at the command line.

		If the workstation is running DESQview, this option will not work.  This is also true with the /u option.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Workstation Hangs Transferring Files - NetWare v3.1
   DOCUMENT ID#:	FYI.P.9388
           DATE:	27JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.1
     SUPERSEDES:	NA

SYMPTOM

	The workstation hangs when transferring large files.

ISSUE/PROBLEM

	Configuration:

		3C503 network board
		Adaptec SCSI disk controller in the file server

	The user tried changing the maximum physical-receive packet size, increasing packet-receive buffers, installing new LAN board drivers, changing to 3C505 boards, installing new Adaptec driver and old LAN drivers.  Using a Modified Frequency Modulation (MFM) drive worked.

SOLUTION

	When the user switched the system board, the system ran fine.  Then when the user went back to the Modular Circuit Technologies (MCT) board and disabled caching, it has been running fine since.

	When Independent Manufacturing Support Program (IMSP) was asked under what circumstances do they have to disable cache on a 386 or 486 machine that they are certifying, the IMSP technician said the following:

	Caching has not been an issue when they have had to turn it off to get it to work with LAN boards; it has been bus speed.  A fair number of clones on the market are not sticking to the 8 MHz standard for ISA bus.  Clones running at speeds of 10, 12, and 16 MHz are the types of machines that  have needed to have their cache turned off (to slow bus speed back to 8).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NetWare Requester for OS/2 v1.3 Print Problems
   DOCUMENT ID#:	FYI.P.9380
           DATE:	27JUN91
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3
     SUPERSEDES:	NA

SYMPTOM

	"Print Screen" or file name appeared on top line of printouts.  Pressing the <PrtSc> key hung the keyboard.  Error messages did not display after issuing an ENDCAP.

ISSUE/PROBLEM

	The user was disabling the OS/2 Print Manager.

SOLUTION

	The design specification requires that the OS/2 Print Manager be enabled.  The requester APIs are not designed to work without the print manager in place.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems Loading CBTs on PS/2 Machines, Error 5
   DOCUMENT ID#:	FYI.P.9378
           DATE:	27JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user was using the Data Communications CBT on all models of PS/2 machines.  When loading the CBT on some machines, the system displayed an error 5.

ISSUE/PROBLEM

	The user looked for TSRs and noted the environment space but was not able to find the source of the problem.  Then when the user changed the monitor on one of the machines, the error went away and the CBT ran fine.

SOLUTION

	The IBM Model 8503 monitor will not work with the Data Communications CBT.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	286 Token-Ring Drivers Configurable with DCONFIG
   DOCUMENT ID#:	FYI.P.9381
           DATE:	26JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	286 Token-Ring Drivers Configurable with DCONFIG

ISSUE/PROBLEM

	TOKENB.ZIP contains 286OS.ZIP drivers v2.62 that have the ability for the first time to be dconfigured after they are linked into the operating system.  When running DCONFIG on NET$OS.EXE, locally administered addresses can now be assigned to LAN A, B, C, or D with Novell's Token-Ring drivers v2.62.

	Also, TRCONFIG.COM has been modified to configure LAN drivers A, B, C, and D after being linked into the operating system.  This can be a distinct advantage for users.  Doing a task, such as changing packet sizes, no longer requires relinking the LAN drivers into the operating system.  Just run TRCONFIG.COM against the operating system.

	This new TRCONFIG.COM is also contained in TOKENB.ZIP and is documented in 286OS.DOC (from within 286OS.ZIP).  TOKENB.ZIP is available on NetWire or NetWare Express.


SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"EXIT Command Followed by String Not Supported"
   DOCUMENT ID#:	FYI.P.9373
           DATE:	10JUN91
        PRODUCT:	NetWare
PRODUCT VERSION:	3.10a
     SUPERSEDES:	NA

SYMPTOM

	While setting up a network user for remote access, the Supervisor wanted to limit the files to which the network user had access.  The supervisor only gave the user rights to the LOGIN.EXE file in the PUBLIC directory.  When this user logged in, the system displayed the following error:

		Ŀ
		EXIT command followed by string not supported.
		

	If the Supervisor gave the user rights to the PUBLIC directory, everything worked fine.
ISSUE/PROBLEM

	The Supervisor needed to give the user rights to the NET$LOG.DAT file because it contains the System login script.

SOLUTION

	After the Supervisor gave the network user rights to the NET$LOG.DAT file, the user could log in just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Creating Mail Directory on Only One Server - NNS
   DOCUMENT ID#:	FYI.P.3822
           DATE:	16AUG91
        PRODUCT:	NetWare Name Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	When creating a new user, is there a way to instruct NetWare to create the MAIL directory on only one server?

SOLUTION

	No.  Part of the design criteria for NNS was no single point of failure and no multiple single points of failure.

	A single point of failure would be a centralized name service database, such as domain servers under LAN SERVER PROGRAM.  Although they allow you to specify a backup, what if the WAN link is down?  No way to get to the primary or the backup would be available.

	Multiple single points of failure are a single resource that the user must have access to get to any resources, such as the HOME SERVER idea within StreeTalk.  If you cannot reach your HOME SERVER, you cannot log in, even if the resource you need is available.
	If the SYS:MAIL directory was located on only one server and because that directory contains your login script and printer profiles, NNS would be just as vulnerable to shut down WAN links and server unavailability as is StreeTalk.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Copying Trustee Rights with NCOPY - NNS
   DOCUMENT ID#:	FYI.P.3815
           DATE:	16AUG91
        PRODUCT:	NetWare Name Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Is there a way to copy trustee rights as well as files when doing an NCOPY from server to server?

SOLUTION

	No.  Trustee rights are stored in the directory entry as a long integer (the object's bindery ID).  Although NNS synchronizes like-named bindery objects between servers, it does not synchronize bindery IDs.  Therefore, the same user will have two different bindery IDs even though other aspects of their user ID (such as full name, restrictions, or passwords) are synchronized.

	Therefore, copying the trustee assignments would be difficult because first you would have to ensure that the two servers were in the same domain and then translate one ID to another.  If the servers were not in the same domain, then some message about why trustee assignments cannot safely be copied would be necessary; and the message would be difficult to explain.

	Why would you want to copy trustee assignments even though you are using NNS?

	Trustee assignments are associated with directories (a bindery object has trustee assignments for certain directories).  What if two servers in a domain are used for different functions such as one having the applications on it and the other having user directories and data?  You cannot synchronize trustee assignments unless each server has identical directory structures.  This is not the idea behind NNS.  The purpose of NNS is to manage binderies across multiple servers.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"File Server Not Found" - Zeos 386SX
   DOCUMENT ID#:	FYI.P.3765
           DATE:	14AUG91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Configuration:

		Loading ELS II v2.12 on a ZEOS 386SX\20 computer with 16-bit VGA network board
		SMC PC130 server network board using Novell's RXNET driver
		Nondedicated server
		Arcnet board was set to interrupt line 2 and I/O=2E0h

	The user put the VGA network board (16-bit) in an 8-bit slot that supposedly forces the board to 8-bit mode.  The nondedicated workstation could function normally except for a slow keyboard.  The other workstations received the following message:

		Ŀ
		File server not found
		

SOLUTION

	When the user used DCONFIG to change the NET$OS.EXE LAN configuration to interrupt line 5, it worked fine.  The user tried putting the VGA board in a 16-bit slot, but it did not work.  As long as the user used interrupt line 5 and placed the VGA board in an 8-bit slot, the system worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	286b Server and Cold Boot Loader - NetWare v2.15c
   DOCUMENT ID#:	FYI.P.3772
           DATE:	14AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user has an old 286b server with a DCB.  When the system board went out, the user wanted to run the server on a clone until he could get the system board back.  Because the 286b server has a custom BIOS that instructs it to search for the cold boot loader on channel 1 if it is not found on channel 0 and the clones do not, the user could not get the BIOS to recognize the DCB and bring the server up.

SOLUTION

	In this case, the temporary solution for this user until receiving the original 286b system board was for the user to do the following:

	1.	Boot to DOS.
	2.	Load NET$OS.EXE from OSEXE-1.
	3.	Bring the server up from floppy diskettes.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	MAP.EXE "N" Parameter Not Supported in Login Script
   DOCUMENT ID#:	FYI.P.3767
           DATE:	14AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Can you use the MAP.EXE "N" parameter in a login script?

	Example:

		MAP N NW311/SYS:PUBLIC

SOLUTION

	No.  The "N" parameter is not supported with the login script MAP command.  A workaround is to execute the MAP.EXE command as follows:

		#MAP N NW311/SYS:PUBLIC




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"NCONFIG.EXE Disappeared from Volume AUXGEN"
   DOCUMENT ID#:	FYI.P.3770
           DATE:	14AUG91
        PRODUCT:	NetWare ELS
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	While the user was running ELSGEN from NetWare v2.15c using the RAM drive or floppy diskette method, the system displayed the following error after being prompted for the SUPPORT and AUXGEN diskettes:

		Ŀ
		NCONFIG.EXE Disappeared from Volume AUXGEN
		

ISSUE/PROBLEM

	Because the user was loading VDISK.SYS in the CONFIG.SYS, it was using base memory instead of accessing the high memory.

SOLUTION

	When the user removed VDISK.SYS from the CONFIG.SYS file and used the floppy method in ELSGEN, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	GPI with StarLAN Boards and Shells
   DOCUMENT ID#:	FYI.P.3757
           DATE:	13AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA

SYMPTOM

	The user changed everything on the network from StarLAN to NetWare.  Every now and again, the server went down with GPI (General Protection Interrupt) errors when running MUXPRC.

ISSUE/PROBLEM

	The user found some old stations seldomly used that still had StarLAN LAN boards and shells.  When they tried to bring up these machines, the GPI occurred.

SOLUTION

	After the user removed these machines from the network, the system worked fine.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Fix for Server Hanging under Heavy Load - NE386.ZIP
   DOCUMENT ID#:	FYI.P.3748
           DATE:	13AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Server hangs or locks

ISSUE/PROBLEM

	The server may hang occasionally under a heavy load with faster machines and the NE2000 network board.  This typically occurs with 486 machines.

SOLUTION

	A driver, NE2000.LAN v3.14 (07-26-91) in NE386.ZIP corrects this problem.  NE386.ZIP is available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Token-Ring Parameters with IPX v.304
   DOCUMENT ID#:	FYI.P.3761
           DATE:	12AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	There have been reports of the Token-Ring command line parameters working with IPX v3.04.  These are the result of an undocumented syntax requirement.

	You must use a comma before the Token-Ring command line arguments.  For example:

		IPX ,o,tbz={value},node={value}

	This will be changed in the next IPX version; however, it is correct this way.  IPX parses the line for its parameters until it finds the comma, then quits, discerning that the rest of the parameters are for something else (such as the Token-Ring driver).

	Note:  With IPX v3.04, the "O" option is no longer needed although it is okay to have because it is ignored.  Older IPX versions (3.01 and 3.02) require the "O" parameter and the comma before the Token-Ring parameters.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Duplicate File Name in Same Directory" - NetWare v3.10
   DOCUMENT ID#:	FYI.P.3705
           DATE:	09AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10
     SUPERSEDES:	NA

SYMPTOM

	"Duplicate file name in same directory"

ISSUE/PROBLEM

	When booting the server (a Compaq SystemPro), the following message displayed at the console screen:

		Ŀ
		Mounting volume SYS                  
		Duplicate file name in same directory
		Volume SYS not mounted               
		

SOLUTION

	Using VREPAIR fixed the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"PSERVER-Fatal, There Is Already a Print Server..."
   DOCUMENT ID#:	FYI.P.3701
           DATE:	09AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	The user's brand-new NetWare v2.2 file server (non-dedicated) appeared to come up and load the PSERVER.VAP v1.21 fine.  However, when the user logged in and typed CONSOLE, the following error appeared:

		Ŀ
		PSERVER-Fatal, There is already a print server named <pserver>
		running.  Print server is down.                               
		

ISSUE/PROBLEM

	The user forgot that a NetWare v3.10 server that was not being used for anything was still attached to the network.  The print server was already running there.  The same print server (same name) cannot be loaded on more than one file server sharing the same network.

SOLUTION
	The user must unload PSERVER.NLM from the v3.10 server or not load the print server VAP at the v2.2 file server.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Utilization Up to 85 Percent Loading PSERVER VAP
   DOCUMENT ID#:	FYI.P.3710
           DATE:	09AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	The user installed the PSERVER VAP with two LPT ports and two COM ports.  If the LPT2 port was configured, the file server utilization soared to around 85 percent immediately after the VAP was loaded and then the file server locked within minutes.  If the LPT2 port was not configured, then everything worked normally.

ISSUE/PROBLEM

	The file server (IBM model 80) network board defaulted to interrupt line 5.

SOLUTION

	When the user changed the board to another interrupt line, the VAP loaded just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	First Three Lines of System Login Script Not Executing
   DOCUMENT ID#:	FYI.P.3730
           DATE:	08AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15a
     SUPERSEDES:	NA

SYMPTOM

	The user had just finished increasing routing buffers and open files.  Then when the user logged in to the network, the first three lines of the system login script did not execute.  The user issued another login, and it worked just fine.  Then when the user logged out and logged back in, the same symptom occurred.

ISSUE/PROBLEM

	The user did not find anything obviously wrong when he typed the NET$LOG.DAT file.

	Understanding that a first time login reads LOGIN.EXE from the LOGIN directory and any login after that will be read from the search mapping to PUBLIC, the user decided to compare the two LOGIN.EXE files.  The files were a different size; so somehow LOGIN.EXE from the LOGIN directory was corrupted.

SOLUTION

	When the user copied LOGIN.EXE from the PUBLIC back to LOGIN directory, the user could log in just fine.  The user will also be looking for a virus.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Could Not Load A:\PINSTALL.NLM"
   DOCUMENT ID#:	FYI.P.3722
           DATE:	08AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Could not load A:\PINSTALL.NLM <Press ESCAPE to continue>
	
ISSUE/PROBLEM

	When the user selected "Product Options" inside INSTALL.NLM, pressed <Insert> to add a new product, and then entered the drive where new product is found (default is A: drive for installs of products from the floppy drive), the system displayed the following message:

		Ŀ
		Could not load A:\PINSTALL.NLM <Press ESCAPE to continue>
		
	
SOLUTION

	PINSTALL.NLM is an NLM that must be written by the developer of the add-on product.  It instructs the product options portion of the INSTALL.NLM how to install the product on the server (such as what directories to create, what files to copy or what .NCF files to modify).  If the PINSTALL.NLM written by the product developer is not found in the location you specify, the above error will be returned.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printing Server Configuration, Settings and Options
   DOCUMENT ID#:	FYI.P.9404
           DATE:	06AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	Printing Server Configuration, Settings and Options

ISSUE/PROBLEM

	Where can you get the configuration of the file server with all the settings and options printed out to give the user a valid hard copy of the system?

SOLUTION

	The CONFIG.DAT file created during linking in the SYSTEM-1 subdirectory or diskette in NetWare v2.2 provides such information.  Because it is a text file, you can NPRINT or copy it to PRN.  The following is an example:

Ŀ
           NetWare v2.2 Configuration Information             
                                                              
Operating system type: Dedicated NetWare v2.2                 
Core printing services included: Yes                          
Communication buffers: 150                                    
                                                              
LAN A:                                                        
  NetWare NE2000 w/AT 2  v3.10EC (901211)                     
  5: IRQ = 3, I/O Base = 320h, no DMA or RAM                  
  Network address: 12345678                                   
                                                              
Disk channel 0:                                               
  Industry Standard ISA or AT Comp. Disk Cont. V2.10 (901219) 
  0: ISADISK    PRIMARY      Verify=OFF    I/O=1F0h   IRQ=14  





                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Issues with Maynard Software and Verbatim Media
   DOCUMENT ID#:	FYI.P.3694
           DATE:	05AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	RESTORE hung part way through the process (no error message).  It always hung on the server it was supposed to be restored to even though it worked on another server.

ISSUE/PROBLEM

	Because Maynard software is not sophisticated enough to recognize errors in reading the Media, it accumulates a number of soft errors and then hang.  Maynard said that there is a known, undocumented incompatibility between Maynard Tape Drives and Verbatim Tape Media.

SOLUTION

	After the user replaced the Verbatim Tape Media with another kind, the problem did not happen again.  The solution is do not use Verbatim tapes with Maynard drives.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Abend: Bad Resource Address..." - NetWare v3.10a
   DOCUMENT ID#:	FYI.P.3693
           DATE:	05AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10a
     SUPERSEDES:	NA

SYMPTOM

	"Abend: Bad resource address detected in AES process."

ISSUE/PROBLEM

	When the user tried to delete an empty subdirectory under a WordPerfect subdirectory while using FILER, the system displayed the following message:

		Ŀ
		Abend: Bad resource address detected in AES process.
		

SOLUTION

	When the user ran RTAGFIX.EXE from RTAGFX.ZIP, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	TBMI NET.CFG Parameter Use of Interrupt 7A
   DOCUMENT ID#:	FYI.P.9401
           DATE:	01AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The INT7A parameter that can be set in the NET.CFG (formerly SHELL.CFG) file is read by IPX when it loads and determines whether applications can access IPX services through interrupt 7A.

	The Task-Switching Buffer Manager for IPX/SPX (TBMI) also offers a NET.CFG parameter to control its use of interrupt 7A.  The TBMI Users Guide states the following:

		"It is similar to the IPX configuration parameter; it specifies that TBMI should support interrupt 7Ah IPX and SPX calls."

	The difference between these parameters is just one space:

	IPX Interrupt 7A parameter:

		INT7A=[ON/OFF]

	TBMI Interrupt 7A parameter:

		INT 7A=[ON/OFF]

	Both parameters may be specified in the NET.CFG file.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"A File Server Could Not Be Found" - XMSNET5 with DOS 5.0
   DOCUMENT ID#:	FYI.P.9403
           DATE:	01AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"A file server could not be found" XMSNET5 with DOS 5.0

ISSUE/PROBLEM

	The user upgraded to DOS 5.0.  When the user tried to load XMSNET5, the system displayed the following error message:

		Ŀ
		A file server could not be found
		

	When the user tried to use the DOS 5 utility to LOADHI NET5.COM in to expanded memory, the same error displayed.  If the user cold reset the machine then tried loading either XMSNET5 or LOADHI NET5.COM, the system still displayed the error.  If the user then did a warm boot, XMSNET5 loaded and mapped the LOGIN drive correctly; LOADHI also worked.

SOLUTION

	Novell instructed the user to change the load statement to the following when loading EMM386.EXE:

		DEVICE=EMM386.EXE x=d800-dfff

	The x parameter instructs the expanded memory manager not to use the specified address range.  In this case, the address range that is specified is the I/O base of the network board in the machine (EXOS205).

	EMM386.EXE is a DOS 5.0 utility that maps extended memory in to expanded memory.  Also, if you use any programs that use expanded memory, this utility must be loaded.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DOS Variables in Login Scripts
   DOCUMENT ID#:	FYI.P.9402
           DATE:	01AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	A user was trying to use a DOS variable by simply enclosing it in angle brackets "<varname>" in a MAP command; however, the MAP command took the whole string literally.

ISSUE/PROBLEM

	The manuals are not very clear about how to use DOS environment variables in LOGIN scripts.

SOLUTION

	Just as any other variable used, the DOS variable enclosed in <> brackets must be prefaced by a % symbol.  Example:

		set DEFVOL = "VOL1"
		map g:= SERV\%<DEFVOL>:USERS\%LOGIN_NAME




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Remote Booting with ODI Shells
   DOCUMENT ID#:	FYI.P.3690
           DATE:	01AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	It is possible to remote boot and then load ODI drivers and shell.  However, you must load an IPX stack and shell if you want to access a server.  What you cannot do is to use the full multi-protocol features of ODI with remote boot.  For example, you cannot do a purely TCP remote boot over a TCP-only network to a NetWare server using IPX tunnelling.  The reason is that to make the initial boot connection, the ROM always uses raw IPX usually on 802.3.  However, when IPX and NET3/4/5 are loaded there is no reason why you should not be able to load other protocol stacks (such as LWP4DOS) for TCP/IP.

	Some boot ROMs support frame types other than 802.3.  When set for any other such frame type, this should be matched by the first frame type defined in the NET.CFG file.  For example, an NE1000 boot ROM will boot over Ethernet_II if you set the NE1000 to configuration option 2.  NET.CFG would then need to have Ethernet_II defined as the first frame type, in this case.

	Novell is currently developing a new ODI boot ROM specification.

	The following is a sample configuration of a workstation remote booting to a NetWare v3.11 server using the ODI shells with both the IPX and TCP/IP protocol stacks loaded:

	Server configuration: The server was a Novell 386a with 4 MB of RAM running NetWare v3.11 with one NE2000 board.

	AUTOEXEC.NCF Used:

	 AUTOEXEC.NCF
	 file server name NOVELL-03
	 ipx internal net 44D38603

	 # Load lan driver with frame types
	 Load NE2000 int=3 port=300 frame=ethernet_802.3 name=ne2000_ipx
	 Load NE2000 int=3 port=300 frame=ethernet_II    name=ne2000_ip

	 #Load TCPIP, monitors
	 Load TCPIP
	 Load TCPCON
	 Load Monitor

	 #Bind to ipx and ip
	 Bind ipx to ne2000_ipx net=44d10
	 Bind ip  to ne2000_ip  addr=100.0.0.0 mask=FF.FF.FF.FF

	Workstation Configuration:

	The workstation was a Novell 286 with a NE1000 board and a boot PROM v2.1. The DOS used was DOS v4.01. The version of ODI drivers used were from NetWare v3.11 with the versions of each file listed:

         LSL     v1.00
         RPLODI  v1.01
         NE1000  v1.10
         TCPIP   v4.00
         IPXODI  v1.00
         NET4    v3.02

	AUTOEXEC.BAT Used:

	 AUTOEXEC.BAT
	 echo off
	 LSL
	 RPLODI
	 NE1000
	 TCPIP
	 IPXODI
	 NET4
	 F:
	 LOGIN

	NET.CFG Used:

	 Link Support
	         Buffers 8 1500
	         Mempool 4096
	 Link Driver NE1000
	         INT #1 3
	         Port #1 300
	         Frame Ethernet_802.3
	         Frame Ethernet_II
	 Protocol Tcpip
	         IP_ADDRESS .....
	DOSGEN Files Used:

	 COMMAND.COM
	 AUTOEXEC.BAT
	 NET.CFG
	 LSL.COM
	 RPLODI.COM
	 NE1000.COM
	 TCPIP.COM
	 IPXODI.COM
	 NET4.COM

	Tests:

	The workstation booted without error.  (Do not forget to copy AUTOEXEC.BAT to SYS:LOGIN and the home directory.)  The user logged in several times and tested various NetWare utilities and was able to PING and ran a File Transfer Protocol (FTP) session to a UNIX host to show that the TCPIP stack was loaded correctly.  The user also created a multiple boot image file using BOOTCONF.SYS and received no errors.

	The NET.CFG file must have the line Frame Ethernet_802.3 before the line Frame Ethernet_II.  If Ethernet_II line is first, the workstation hangs when loading NE1000.  The default NET.CFG shipped with LWPD4 has the Ethernet_II frame type defined first, which is wrong for remote boot.  If you are remote booting the workstation, you must change the order of declaration of the two frame types.

	The file RPLODI.COM is on the DOS ODI WORKSTATION diskette and on the WSGEN disk.  This file must be loaded before the LAN driver (NE1000).  An error prompting you to load it is displayed if you leave it out.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Local Drives D: and E: Not Showing Up in MAP
   DOCUMENT ID#:	FYI.P.9400
           DATE:	30JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Local drives D: and E: do not show up from MAP.

ISSUE/PROBLEM

	The user had been mapping drive D: to a network drive.  When he changed this to another drive, MAP returned the following message:

	Ŀ
	Drive  A:   maps to a local drive
	Drive  B:   maps to a local drive
	Drive  C:   maps to a local drive
	Drive  F: = server\SYS:USER\name 
	

	The user was expecting to see drives D: and E: mapped to a local drive also.  When drive D: was mapped to a network drive, drive E: was not showing up.  The user thought that this was abnormal also.  The user also could not get to a D: drive that was physically there.

SOLUTION

	When the user loaded a driver "HARDRIVE.SYS" in the CONFIG.SYS file, the drives showed up properly.  Also, if a D: drive is physically there, the user can get to it now.

	The new replacement machines did not have this problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	XMSNET3 Shell Error :A20
   DOCUMENT ID#:	FYI.P.9399
           DATE:	26JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	The workstation occasionally received the following error:

		Ŀ
		XMSNET3 shell error :A20
		

ISSUE/PROBLEM

	Configuration:

		Shell v3.01a

	After the user changed machines and the network board, the workstation still received the error.

	The only information found was related to possible system board problems with address line 20.

SOLUTION

	The user later explained the only station receiving the error was also a gateway to a AS400.  Therefore, after increasing the SPX abort, listen, and verify timeout values in SHELL.CFG to triple the default values, the system no longer displayed the error.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Memory Requirements for NetWare for SAA
   DOCUMENT ID#:	FYI.P.9398
           DATE:	26JUL91
        PRODUCT:	NetWare, NetWare for SAA
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What are the memory requirements for file servers installed with NetWare for SAA?

SOLUTION

	The following is from the Rules of Thumb for NetWare for SAA v1.0, 64 sessions.

	If you are using the Runtime version of NetWare v3.11 that ships with NetWare for SAA, the minimum recommended system memory is 8 MB.

	If you are using the standard NetWare v3.11, use the following steps to determine the memory requirements for running NetWare for SAA.

	1.	Calculate the memory requirements for each volume.

	  	For each DOS volume, use the following:

	  		M=.023 X VOL size (in MB) / Block size (default is 4 KB)
	  	For each volume with added Name Space, use the following:

	  		 M=.032 X VOL size (in MB) / Block size (default is 4K)

	2.	Add memory requirements for all volumes.

	3.	Add 2 MB for the operating system and round the value to the next higher MB.  If the total is under 3 MB, use 4 MB for your NetWare v3.11 memory requirement.
	4.   Add 4 MB (to run NetWare for SAA) to the value determined in Step 3.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Lotus 3.1 Incompatibility with NETx 3.22
   DOCUMENT ID#:	FYI.P.4130
           DATE:	24SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"Error loading 123DOS"

ISSUE/PROBLEM

	When running Lotus v3.1 using NETX v3.22, the system displayed the following error:

		Ŀ
		Error loading 123DOS
		

SOLUTION

	Rename the directory that contains the Lotus 123 files to any name that is longer than eight characters.  For example rename the directory from "LOTUS" to "LOTUS123.R3."




                               FYI
(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error 10, Fatal Error Writing BRGEN-3"
   DOCUMENT ID#:	FYI.P.4092
           DATE:	20SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	"Error 10, Fatal Error Writing BRGEN-3"

ISSUE/PROBLEM

	At the end of the generation process running BRGEN, the system displayed the following error:

		Ŀ
		Error 10, Fatal Error Writing BRGEN-3
		

SOLUTION

	This error may be generated if the BRGEN-3 diskette is full.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Map: Not Attached to Specified Server"
   DOCUMENT ID#:	FYI.P.4090
           DATE:	20SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	"Map: Not attached to specified server"

ISSUE/PROBLEM

	The user had reduced the directory entries on SYS: volume, then restored the data from a tape drive system.  However, when the user tried to map a local drive, the system displayed the following message:

		Ŀ
		Map: Not attached to specified server
		

	This message did not display when the user tried to map a drive to another server to which he was attached.

SOLUTION

	When the user regenerated the operating system and increased directory entries on the SYS: volume back to where they were before he reduced them, the problem disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"ProcessNewMenu" Paradox and Novell MENU
   DOCUMENT ID#:	FYI.P.4082
           DATE:	19SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Error using Paradox and Novell MENU system.

ISSUE/PROBLEM

	When you load Paradox v3.5 inside the Novell MENU system (MENU.EXE v2.30), you get the following error when you exit Paradox.

		Ŀ
		Description:                                                    
		                                                                
		A call was made to ProcessNewMenu when the menu file was not    
		positioned to the start of a menu line.  Please check the format
		of the file.  Further program execution is not possible.        
		

SOLUTION

	Update MENU with MENU34.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	FAT Errors in NetWare v2.0a
   DOCUMENT ID#:	FYI.P.4016
           DATE:	12SEP91
        PRODUCT:	NetWare ELS I
PRODUCT VERSION:	v2.0a
     SUPERSEDES:	NA

SYMPTOM

	FAT errors

ISSUE/PROBLEM

	There is no VREPAIR for this version of NetWare.

SOLUTION

	You can copy the files to another directory, delete the originals, and copy them back.  This should rewrite the directory entries and get rid of the FAT errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	HP IIIsi Printer - Router Configuration Errors
   DOCUMENT ID#:	FYI.P.4013
           DATE:	12SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Router configuration errors

ISSUE/PROBLEM

	The user installed a second file server (NetWare v2.2) on the LAN.  He had modified the LAN address of the first file server (NetWare v3.1) to match the address of the new server.  He had made the change correctly; however, both file servers were receiving router configuration errors.

SOLUTION

	The user noticed later that the node address that was being sent with the error did not correspond to either of the two file servers.  He also had a HP IIIsi (the new HP printer that comes with a Token-Ring or Ethernet option to connect directly to the LAN).  The HP IIIsi had been up and running the whole time while he had changed the NetWare v3.1 server's (the original file server) LAN address.   When the user brought down the HP and brought it back up to reinitialize, the router configuration errors stopped.

	The HP gets the LAN address when it initializes. In this case, it had initialized to the original LAN address that was then changed without reinitializing the HP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Removing a File Server from a NNS Domain
   DOCUMENT ID#:	FYI.P.4006
           DATE:	11SEP91
        PRODUCT:	NetWare Naming Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM
	NA

ISSUE/PROBLEM

	A NetWare v3.11 server was physically removed from a network before it was logically deleted from the NNS domain through NETCON.  This server was to be used as a non-NetWare Naming Service server in a different network.  Now when logging into this server and attempting to use normal SYSCON functions, the user was prompted to use NETCON instead of SYSCON as though the server was still part of a domain.

SOLUTION

	As specified in the NNS manual, the proper way to remove a server from a domain is through NETCON.  In this case, the server was reattached to the network.  The supervisor then went into NETCON, but this server did not appear on the list of domain servers.  Pressing <Insert> allowed the user to add the server back into the domain.  The server was then deleted from the domain through NETCON and physically removed again.  Now the server acts as a non-domain server as desired.

	When a server is deleted from a domain, that server's copy of the DOMAIN login script becomes its SYSTEM login script.  You may need to edit this script to remove any domain-specific commands.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"LAN Receive Buffer Limit Reached" - AST 486/33
   DOCUMENT ID#:	FYI.P.3978
           DATE:	10SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Error: "No ecb count" and "LAN receive buffer limit reached."

ISSUE/PROBLEM

	Configuration:
		One NE2000
		Two NE3200s

	The user changed the server (machine) from AST 486/25 to AST 486/33.  LAN boards and disk controller stayed the same.  After the user switched the machines, they started to have problems with following errors:

		Ŀ
		No ecb count
		
		Ŀ
		LAN receive buffer limit reached
		

SOLUTION

	The user used the new NE3200.LAN (12389 07-26-91) found in NE386.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Free IPX Block Already on Free List"
   DOCUMENT ID#:	FYI.P.3980
           DATE:	10SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user's system displayed the following NetBIOS error:

		Ŀ
		Free IPX block - already on free list
		

ISSUE/PROBLEM

	This message is generated because of driver problems.

SOLUTION

	In this case, the user got a newer version (v3.23) of the Pronet4 driver.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems with File Saving and Corruption - NetWare v2.15c
   DOCUMENT ID#:	FYI.P.3977
           DATE:	10SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When a file was saved, it appeared to be saved properly.  However, after a while (a few minutes to a few hours), the file went back to its original date and size, just as if it had never been changed.  The system was also getting data corruption on some of the files.

ISSUE/PROBLEM

	Configuration:

		NetWare v2.15c on a HP Vectra RS/25C
		WREN VI drive

	The signal to Pin 20 was intermittent indicating that the cable that goes from the controller to the drive was faulty.

SOLUTION

	Replacing the faulty cable solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	RPRINTER and One Physical Printer Servicing Two Queues
   DOCUMENT ID#:	FYI.P.3986
           DATE:	10SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Slow printing

ISSUE/PROBLEM

	A user was setting up RPRINTER on a machine with one physical printer that was servicing two queues.  He set up the printer in PCONSOLE for each queue to print to a different logical printer.  So when he was loading RPRINTER, he loaded it twice, once for each logical printer defined.  The second queue was printing slowly, one line every two minutes.

SOLUTION

	After the user redefined only one logical printer to service the two queues, then he only had to load RPRINTER once which solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Questions and Answers on Server Rebooting
   DOCUMENT ID#:	FYI.P.3987
           DATE:	10SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.1x
     SUPERSEDES:	NA

SYMPTOM

	My server reboots.  What would cause this?

ISSUE/PROBLEM

	A reboot is the equivalent of a triple GPPE.  The processor does the restart.

	First time 	ABEND: General Protection Processor Exception
	Second time	ABEND: Double Fault Processor Exception or ABEND: Multiple abends are occurring.
	Thrid time	The server reboots.

	The cause may be due to things such as basic memory conflicts, hardware problems, corruption, or faulty NLMs.

SOLUTION

	If you want to understand the different processor abends, read the Intel book on the 486/386 processor explaining the different exceptions.  In one edition, it is in chapter 9.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Compute Portal Position Returned an Error Code 1"
   DOCUMENT ID#:	FYI.P.3995
           DATE:	09SEP91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	When MENU, FILER, or VOLINFO are exited, the system displayed the following error message and the workstation hung:

		Ŀ
		Compute portal position returned an error code 1.  
		Attempt to create portal height xx width xx failed.
		

	Pressing <Esc> resulted in the following error:

		Ŀ
		Memory allocation error...system halted.
		

ISSUE/PROBLEM

	The boot disk on the file server had "device=himem.sys" in the CONFIG.SYS file.

SOLUTION

	Removing the device driver allowed the other workstations to run the programs listed above without any errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Free Called with Memory Block..." - Core HC655-D Drive
   DOCUMENT ID#:	FYI.P.3959
           DATE:	06SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10a
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to install a Core drive HC655-D with Core MCK controller using MCKDISK.DSK driver in a PS/2 Model 80, the system displayed the following errors:

		Ŀ
		Free called with memory block invalid resource tag.
		
		Ŀ
		Unknown error returned by attach.
		

ISSUE/PROBLEM

	The user tried several things but finally decided the problem had to be an incompatibility with the drive or drivers in the Model 80.  There was some previous information about older Model 80 machines having problems.

	Novell suggested to the user that he check to see what motherboard he had.

SOLUTION

	The user called back later and said that IBM has an Engineering change #ECA048 that has to do with some timing issues.  After the user installed the new motherboard, everything else installed and is running fine.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Directory Caching Problems in ELS NetWare v2.12a
   DOCUMENT ID#:	FYI.P.3964
           DATE:	05SEP91
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.12
     SUPERSEDES:	NA

SYMPTOM

	Directory caching problems

ISSUE/PROBLEM

	The user tried to set up directory caching on a file server.  When the user brought up the system, it displayed a message about not having enough memory to cache the directory tables.

SOLUTION

	ELS NetWare II v2.12 in dedicated mode is actually in an 86 mode that only recognizes 640 KB of memory.  In the nondedicated mode, the machine will recognize the total memory.  ELS II v2.12 was the last product that Novell sold that would support an XT machine as a file server.  ELS NetWare Level II v2.15 runs in 286 mode in both dedicated and nondedicated.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Loading SMC3016 Driver Gives Error in NetWare v2.1x
   DOCUMENT ID#:	FYI.P.3971
           DATE:	05SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA
SYMPTOM

	"Unable to find "(heart symbol)"

ISSUE/PROBLEM

	When running NETGEN or SHGEN and doing a "load and select" to select the SMC3016 driver, the system displayed the following error:

		Ŀ
		Unable to find "(heart symbol)"
		

	Consequently, the user could not load the driver.

SOLUTION

	According to Standard Microsystems Corp. (SMC), Novell wrote a patch to allow this driver to be loaded correctly within NETGEN and SHGEN.  The patch is on the SMC Bulletin Board at 516-434-3162.  The file name is LANFIX.ZIP.  It is not available on NetWire.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NetPort and PCONSOLE - NetWare v3.11
   DOCUMENT ID#:	FYI.P.3945
           DATE:	04SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	A PSERVER was defined on two NetWare v3.11 file servers.  It was named the same on both so that the PSERVER.NLM on the first file server could service queues on both file servers that would then be serviced by a NetPort.

	After doing this and loading the PSERVER off file server 1 (FS1), everyone on the file server 2 (FS2) lost connection for about two minutes.  After 2 minutes, everyone would start working.  The NetPorts attached to the PSERVER on FS1 worked fine, but the queues serviced by FS1 off FS2 were not being serviced.

ISSUE/PROBLEM

	When defining the PSERVER on both the file servers, the user configured the printers on both file servers for "remote parallel."

SOLUTION

	The normal way to define PSERVER on both servers would be to define the printer as "remote parallel LPT1" on FS1 and "Defined elsewhere" on FS2.  By changing the configuration on FS2 to "Defined elsewhere," the NetPort came up fine and serviced both queues.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems Printing More Than Three Pages - RPRINTER v1.21
   DOCUMENT ID#:	FYI.P.3950
           DATE:	30AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Large print jobs would print only the first three pages and then stop.  There would be no errors and the job was gone from the print queue.  If the jobs were less than three pages, everything was fine.

ISSUE/PROBLEM

	Configuration:

		Using RPRINTER.EXE v1.21 on a workstation running a serial printer.

	Laserwriters and other postscript printers typically use software flow control (XON/XOFF=YES).  Three pages is just about the amount necessary for the laserwriter's buffer to fill the pages then send an XOFF command.  RPRINTER then ignores the job and continues sending the rest of the document into the bit bucket.

SOLUTION

	Get RPRINTER v1.21b or later.  RPRINTER v1.21b and later includes a fix for the XON/XOFF problem that v1.21 exhibited.  In v1.21, if you set XON/XOFF=YES in PCONSOLE, RPRINTER would ignore it and continue to use hardware flow control (as though XON/XOFF was still set to NO).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Abend: Operating System / Server Mismatch"
   DOCUMENT ID#:	FYI.P.3927
           DATE:	30AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.0a
     SUPERSEDES:	NA

SYMPTOM

	"Abend: Operating System / Server Mismatch"

ISSUE/PROBLEM

	The user had 2.0a running on a proprietary hardware platform (one of the old Novell 286A machines).  The motherboard died, so the machine was replaced with a clone.  After the user moved the drive to the new server, the system displayed the following error:

		Ŀ
		ABEND: Operating System / Server Mismatch
		

SOLUTION

	There is a patch on NetWire called PROPTH.ZIP.  This file converts the proprietary 286A version of NetWare to nonproprietary 286 to eliminate the above error.




                               FYI
(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Using System While Remirroring Is in Process
   DOCUMENT ID#:	FYI.P.3849
           DATE:	20AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Are there any problems using the system (such as logging in, saving files) while a partition remirror is occurring?

SOLUTION

	The remirror process is done in the background.  As such, other file server operations will continue to run properly.  However, some amount of performance reduction may be noticed.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DOS Time Runs Faster Than System Time - ELS NetWare
   DOCUMENT ID#:	FYI.P.3843
           DATE:	20AUG91
        PRODUCT:	NetWare ELS I
PRODUCT VERSION:	v2.0a
     SUPERSEDES:	NA

SYMPTOM

	DOS time running faster than System time

ISSUE/PROBLEM

	The DOS time is running its minutes like seconds (very fast).  The System time seems to be fine.

SOLUTION

	Run INSTALL and unspool LPT3.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Printing" on PSERVER Screen Changes to "Off-Line"
   DOCUMENT ID#:	FYI.P.3825
           DATE:	19AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The printer status for a serial printer running under the PSERVER.NLM would show "printing" on the PSERVER screen when a job was sent.  However, a couple of seconds later, the status switched to "off-line."

ISSUE/PROBLEM

	The printer was set to XON/XOFF=YES while the printer configuration in PCONSOLE was set to XON/XOFF=NO.

SOLUTION

	When the printer configuration in PCONSOLE was set up for XON/XOFF=YES, it printed fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Local Drives Disappear during RPL Loading Shell
   DOCUMENT ID#:	FYI.P.3826
           DATE:	19AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Local drives disappear during RPL loading shell

ISSUE/PROBLEM

	Several problems have been occurring involving the IBM model 55ls and other workstations where RAM drives and local hard drives disappear during remote program load.

	All local drive letters are present until the shell loads.  NET3.COM, NET4.COM, NET5.COM, EMSNETx.COM, XMSNETx.COM would check for a local drive A: and if not found, would delete the shell's local drive table and any local virtual or real drives then disappeared.

	The shell should have checked for local drive's B:, C:, D:, and any virtual RAM drive letters before deleting them out of the shell's drive table.

SOLUTION

	This problem was fixed with version v3.22 and later shells (NETX, EMSNETX, and XMSNETX).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Upload of UPS.ZIP, README
   DOCUMENT ID#:	FYI.P.3828
           DATE:	19AUG91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This concerns UPS.NLM 10595 12-18-90 included in UPS.ZIP on NetWire.

	This revision of UPS.NLM corrects an interrupt sharing conflict between Advanced Digital Information Corp. (ADIC) DCB.DSK and the UPS.NLM in NetWare 386 v3.10.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NETCON and Home Directories - NNS
   DOCUMENT ID#:	FYI.P.3833
           DATE:	16AUG91
        PRODUCT:	NetWare Naming Service
PRODUCT VERSION:	v1.00
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Why doesn't NETCON create the users home directory automatically the way SYSCON does?

SOLUTION

	Under NetWare Name Service there is not supposed to be a "HOME DIRECTORY" or "HOME SERVER" concept.

	Most users are not going to want to have user directories on all the file servers.  If NETCON.EXE had to synchronize home directories, it would increase the synchronization time significantly.  Also, NETCON does not synchronize trustee assignments.  When SYSCON creates a home directory, it gives the user all rights to the home directory.  For NETCON to take care of this process, it would take a lot of overhead.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Asynchronous Communication in NetWare v2.15c
   DOCUMENT ID#:	FYI.P.4494
           DATE:	28OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Does NetWare v2.15c support asynchronous communications above 2400 baud?

SOLUTION

	The Asynchronous Remote router will support up to 9600 baud if the WNIM+ adapter is used.  Otherwise, Link 64, Link T1, or Link X.25 are the Synchronous options.  The data transfer rate is independent from the version of NetWare; instead it is a function of the modem, port, and communication software.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	File Creation with Microsoft Link Replacing Files
   DOCUMENT ID#:	FYI.P.4482
           DATE:	28OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x, v3.x
     SUPERSEDES:	NA

SYMPTOM

	When the user created a new file with Microsoft Link (if the file names were duplicated within the search drive mappings), the link software replaced the old file (in the search mappings) and did not create the new file in the default directory.

ISSUE/PROBLEM

	The user was using the default Search Drive mode that contains the following parameter:

		{If a directory path leading to the data file is specified in the executable file, the executable file will search only that path.  If a path is not specified, the executable file will search the default directory and then all search drives.}

SOLUTION

	Novell instructed the user to change the MODE parameter in the SHELL.CFG to Search mode=2 that contains the following parameter:

		{the executable file will search only the default directory or path specified}




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Appending to Captured File
   DOCUMENT ID#:	FYI.P.4376
           DATE:	16OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	How can you capture to a file, then keep appending jobs to the file?

SOLUTION
	CAPTURE defaults to Autoendcap and closes the file so that it cannot be appended.  Using NoAutoendcap in the CAPTURE statement holds the file open so that it can be appended.

	The correct statement is the following:

		"CAPTURE CR=[FILENAME] NA"

	This procedure is also referenced on page 58 of the Print Server manual under the "Save data from several application" heading.

	Using NoAutoendcap in the CAPTURE statement also requires that you type ENDCAP when you are finished appending to the file.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"You Do Not Have Access Rights to Queue <queue name>"
   DOCUMENT ID#:	FYI.P.4372
           DATE:	16OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When the user issuing a CAPTURE command, the system returned the following error:

		Ŀ
		You do not have access rights to queue <queue name>
		

ISSUE/PROBLEM

	The user issuing the capture statement was not specified as a queue user.  By default the group EVERYONE is added as queue users, but if a user (even Supervisor) is not either added specifically as a queue user or is not a member of the group shown as queue users, the above error will occur.

SOLUTION

	Add the user to the queue or to a group shown as a queue user.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Network Spooler Error, Probably Not..." - PSERVER.NLM
   DOCUMENT ID#:	FYI.P.4342
           DATE:	14OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"Network spooler error, probably not enough space on volume SYS:"

ISSUE/PROBLEM

	The system displayed the following error even though the user still had  had more than 16 MB of space available on the SYS: volume:

		Ŀ
		Network spooler error, probably not enough space on volume SYS:
		

	Additionally, when the user sent print jobs, the jobs remained in the "adding" mode for 20 to 40 minutes.

SOLUTION

	Delete or disable (REM) the following lines from the CONFIG.SYS file on the workstation:

		device=emm
		device=ansi




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NE1000 Driver Causing Network Error in NetWare v3.11
   DOCUMENT ID#:	FYI.P.4339
           DATE:	14OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Network error on server <file server name>, error receiving from network."

ISSUE/PROBLEM

	All user's workstations frequently received the following error:

		Ŀ
		Network error on server <file server name>, error receiving
		from network.                                              
		

	The file server was using the NE1000.LAN operating system driver (01-31-91) that shipped with NetWare v3.11.

SOLUTION

	When the user upgraded the NE1000.LAN driver from the NE386.ZIP file available on NetWire or NetWare Express, the symptom disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Not Enough SPX Connections" - Loading PSERVER.EXE
   DOCUMENT ID#:	FYI.P.4331
           DATE:	11OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user was trying to load PSERVER.EXE.  The SHELL.CFG file on the workstation contained the statement "SPX Connections = 60."  When PSERVER.EXE was loaded, it displayed the following error:

		Ŀ
		There are not enough SPX connections to run the print server.
		

ISSUE/PROBLEM

	Some corruption or hidden characters were in the SHELL.CFG file that was not enabling the shell to load the SPX connections.

SOLUTION

	When the user renamed the SHELL.CFG file and created a new one that also had the "SPX connections = 60" statement, the user was able to load PSERVER.EXE just fine.

	Loading more than 60 SPX connections for the PSERVER.EXE is not necessary because that is the maximum the PSERVER will use.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Number of Volumes/Segments NetWare 386 Will Support
   DOCUMENT ID#:	FYI.P.4311
           DATE:	11OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA
SYMPTOM

	NA

ISSUE/PROBLEM

	How many volumes will NetWare 386 support?

	32 -	According to the Computer-Based Training (CBT) course

	32 -	According to the NetWare 386 Theory of Operations Versions 3.0 and 3.1 on page 14

	64 -	According to the NetWare Version 3.10 Concepts manual on page 322

	64 -	According to the NetWare Version 3.11 Concepts manual on page 271

SOLUTION

	NetWare v3.00 supports 32 volumes.  The CBT and NetWare 386 Theory of Operations were based on the 3.00 specification.  NetWare v3.10 and v3.11 supports 64 volumes.

	Some other specifications for NetWare v3.1x are the following:

 		Maximum number of segments per volume = 32
		Maximum number of name space modules per server = 5

	Definition of a segment:  It is not the number of drives that the volume can span.  The segment is a contiguous amount of disk space.  There can be multiple segments on a single drive.  The segments are defined when setting up the volume information, using INSTALL, in the form of allocating disk space for the volume.  The contiguous disk space allocated then becomes one segment.  If you do not use the entire drive or partition for the volume size, the remaining space is a separate segment.  You are allowed up to eight volume segments for each NetWare v3.11 partition.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Lost NetWare Ready Stamp"
   DOCUMENT ID#:	FYI.P.4327
           DATE:	11OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	The user had two drives mirrored.  First, the system displayed the following error:

		Ŀ
		Problem with duplicate redirection tables on mirrored drive.
		

	Then, when the user tried to go back to NETGEN to fix the drives and get them remirrored, the system displayed the following message:

		Ŀ
		The Primary drive has lost the NetWare ready stamp.
		

ISSUE/PROBLEM

	Normally, when the drive loses its NetWare-Ready stamp, the drive would have to be sent back to the manufacturer to have the stamp put back by their particular method.

SOLUTION

	Before completely giving up, the user reinitialized the drive and was able to reinstall successfully, restore the backup, and remirror with no problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Loader Cannot Find Public Symbol INITIALIZEDDISKCARD"
   DOCUMENT ID#:	FYI.P.4328
           DATE:	11OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user set up a NetWare v3.11 server including making partitions and volumes.  The server was shut down; when the user brought the server back up, the system displayed the following message:

		Ŀ
		Loader Cannot Find Public Symbol INITIALIZEDDISKCARD
		

ISSUE/PROBLEM

	The SERVER.EXE file on the C: partition was corrupt.

SOLUTION

	When the user used a new copy of SERVER.EXE, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Abend:Invalid Printer Definition Table" - VREPAIR
   DOCUMENT ID#:	FYI.P.4315
           DATE:	11OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA

SYMPTOM

	When the user executed VREPAIR from a v2.1x version, the system displayed the following error:

		Ŀ
		Abend:Invalid Printer Definition Table
		

ISSUE/PROBLEM

	The above error occurs when multiple printers (more than three) have been spooled in NETGEN or ELSGEN.
SOLUTION

	Two workarounds for this problem are the following:

	Workaround 1:	Download VRP215.ZIP and relink VREPAIR.  The VREPAIR.OBJ in this file does not have the problem with multiple printers.  Remember that ELS comes with a prelinked version of VREPAIR; so it needs to be linked with an ADV or SFT version with the ISADISK driver selected.

	Workaround 2:	Reenter NETGEN or ELSGEN; deselect your printers; run VREPAIR; and then use VREPAIR or ELSGEN to define your printers again when finished.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	PSERVER.NLM Losing Jobs in the Queue
   DOCUMENT ID#:	FYI.P.4295
           DATE:	10OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This user prints mostly from Windows.  Occasionally, a job went in to the queue and left the queue without printing.  The job got lost somewhere.

SOLUTION

	Upgrade to the PSERVER.NLM in PS121B.ZIP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unexpected Error 5, Error Code 8801." - MAP v2.03
   DOCUMENT ID#:	FYI.P.4297
           DATE:	10OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"Unexpected Error 5, Error Code 8801"

ISSUE/PROBLEM

	The user installed an application that required mapped roots.  When executing MAP.EXE v2.03 04-26-90 from command line, the system displayed the following error:

		Ŀ
		Unexpected Error 5, Error Code 8801
		

SOLUTION

	After the user recopied MAP.EXE v3.55 01-21-91, that is shipped with NetWare v2.2 and v3.11 operating systems, the system now supports mapped roots.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SBACKUP Hangs While Loading - IRQ Or DMA Conflict
   DOCUMENT ID#:	FYI.P.4300
           DATE:	10OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.1x
     SUPERSEDES:	NA

SYMPTOM

	While loading or just partially loading SBACKUP, the file server hung.

ISSUE/PROBLEM

	There was some kind of conflict with the settings.

SOLUTION

	After the user reset the Port, interrupt lines, and DMA in the DIBI2$DV.DAT file to default settings, the server came up fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Real Mode Bridge Will Not Remote Boot with Baseband
   DOCUMENT ID#:	FYI.P.4296
           DATE:	10OCT91
        PRODUCT:	NetWare SFT
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When the bridge was brought up in Protected mode, the remote boot worked fine.  However, if the bridge was brought up in Real mode, then remote boot would not work.  The bridge came up fine in either Real or Protected mode and properly passed packets across the bridge for workstations that were booting with a floppy diskette or local hard disk.

ISSUE/PROBLEM

	Configuration:

		The bridge was an IBM Model 30-286.

		The user had a Novell Bridge (now called a router) that was connecting remote boot workstations with PCNII to Token-Ring file servers on the other side.

		The PCNII driver at the bridge was v1.16 and the Token-Ring driver at the bridge was v2.60.

	The user tried bringing up the bridge nondedicated by typing BRIDGE 450; however, it did not make any difference.

	There just is not enough room in real mode to handle the bridge software and the remote boot code that needs to be downloaded to the workstation.

	The reason the user wanted real mode when protected mode worked was because (educational environment) of the old Model 30s (the 8086 version) they had that cannot run in Protected mode because it is an 8086 processor.

SOLUTION

	The PCNII remote boot VAP does not exist because the remote boot detection code is built into the driver.  However, the PCNII.RPL file still needs to be downloaded to the bridge so it can be downloaded to the workstation.  The PCNII driver running on the bridge upon bootup will attach to the nearest server and look for the PCNII.RPL file in the \LOGIN directory.  When the bridge is in real mode, it only loads a part of the driver because of the lack of memory; therefore, RPL does not work.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Open File FILE.MNU" - Novell MENU
   DOCUMENT ID#:	FYI.P.4280
           DATE:	09OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When trying to execute the MENU, the system displayed the following message:

		Ŀ
		Unable to open file FILE.MNU, Further program execution
		is not possible, Exiting to system                     
		

ISSUE/PROBLEM
	The file was not in the directory (or in a search drive directory) from which the user was trying to execute the MENU.

	This error will also occur on PC/XT class machines when the .MNU extension is not specified at command execution.

SOLUTION

	Things to check for that are helpful with this kind of menu error are the following:

	1.	The .MNU extension might need to be specified.

	2.	No rights to the directory from where they are executing the menu.

	3.	The user might need to specify the full path to the .MNU file as well as the extension.

	4.	The menu takes up a lot of memory and if they are executing it from the login script (so the memory is fragmented) and they have other TSRs loaded they may not have enough memory to execute the menu.  If this is the case, try the MENU in MENU34.ZIP or the hybrid menu from MENU.ZIP (available on NetWire) and have the menu called from a batch file to which the login script exits.

	5.	Running from Windows when opening a DOS box to run the menu, the user was sitting at a local drive.  Whenever you are trying to execute a network file from a local drive, the search mappings are treated like the DOS path and only look for .EXE, .COM, or .BAT files.  When the user created a batch file in the PUBLIC directory that changed to a network drive and then called the menu, the user was able to call the batch file from anywhere.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	RPRINTER Not Connecting on Reboot
   DOCUMENT ID#:	FYI.P.4244
           DATE:	07OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to reboot the workstation with RPRINTER on it, the system displayed an error about the connection already being used.  When the user put the RPRINTER -r command in the AUTOEXEC.BAT file, the system displayed an error about no RPRINTER being loaded; however, the workstation could then get a connection to PSERVER.

ISSUE/PROBLEM

	PSERVER will hold a connection open for 15 to 30 seconds.  A warm boot takes about 12 seconds.  While executing the RPRINTER -r command, it gave PSERVER enough time to drop the connection.

SOLUTION

	Putting a pause in the AUTOEXEC.BAT solved the problem.

	With the pause in the AUTOEXEC.BAT, RPRINTER sometimes still will not load because the timeout has not occurred.  To make it more automatic and completely foolproof, using the following batch file will guarantee a load with no user intervention:

		:loop
		RPRINTER printserver printer#
		if errorlevel 1 goto :loop
		Echo RPRINTER loaded Successfully!




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error Reading Partition Table" - Duplexing ESDI Controllers
   DOCUMENT ID#:	FYI.P.4179
           DATE:	01OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10a
     SUPERSEDES:	NA

SYMPTOM

	The user was duplexing Compaq ESDI controllers and had four drives total, two per controller.  After the user loaded INSTALL, selected Disk Options, and then tried to look at either of the two drives on the second controller, the system displayed the following error:

		Ŀ
		Error reading partition table
		

	NetWare recognized and listed all four drives (or "Devices") but return the error if <Enter> was pressed on either of the last two devices in the list.  In FDISK, the user could see all four drives and could CREATE or REMOVE DOS partitions.  The user tried duplexing with only one drive per controller; however, the system still could not recognize the drive off the second controller.

ISSUE/PROBLEM

	When loading ISADISK (v3.10a), the user was using the following defaults:

		Interrupt line E for the first controller
		Interrupt line F for the second controller

SOLUTION

	When the user to tried a lower number for the interrupt setting for the second controller, it worked.  When the user tried interrupt line A, the system returned a "not supported" error.  The user ended up using interrupt line B and mentioned that interrupt line C was also a valid choice.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Errors with EMSNET5 in NetWare v3.11
   DOCUMENT ID#:	FYI.P.4182
           DATE:	01OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user's system received the following errors:

		"File server information returned error 1"
		"Error getting preferred server information"
		"Error reading server name(-30719)"
		"Unable to get connection information 8801"

ISSUE/PROBLEM

	Configuration:

		Model 70 using IBM DOS 5.0,
		HP IIIsi laser printer

	The user was using a HP IIIsi with a network board in it.  If the user was using EMSNET5 and IBM DOS 5.0 and sent a print job to it, the following error appeared at the workstation screen:

		Ŀ
		File server information returned error 1
		

	The same error occurred with EMSNETX and IBM DOS 5.0.  For some reason, the user was loading EMSNET5 or EMSNETX high with QEMM.SYS.

	If the user executed SLIST from C: or F: drive, the system displayed the following error:

		Ŀ
		Error reading server name(-30719)
		

	When the user logged out after getting the previous errors, the system displayed the following error:

		Ŀ
		Unable to get connection information 8801
		

SOLUTION

	If the user used a Compaq DOS 5.0 or loaded NETX high, the system did not display any of the errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	Removable Media Reference in VOLINFO
   DOCUMENT ID#:	FYI.P.4167
           DATE:	27SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	There is an interesting added volume reference in VOLINFO.  At the top of the first volume information window, the volume name will be followed by the symbol "[R]" if the volume is on REMOVABLE MEDIA.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NPRINT Not Working from Applications - NetWare v3.11
   DOCUMENT ID#:	FYI.P.4169
           DATE:	27SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	This user had an application that somehow issued Novell's NPRINT command while it was running; however, it was not working properly.  Apparently, it was not finding the NPRINT.EXE.

ISSUE/PROBLEM

	For some reason, the application was not able to use the search mapping to find NPRINT.

SOLUTION
	After the user copied the NPRINT.EXE from the PUBLIC directory to the application's home directory, NPRINT worked just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Exception Assembly Abend" - Corrupt SERVER.EXE
   DOCUMENT ID#:	FYI.P.4160
           DATE:	26SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When trying to boot a NetWare v3.11 SERVER.EXE on a HP Vectra QS16, the system displayed the following error on the screen:

	Ŀ
	Error on file server: "Exception assembly abend exception
	number D (GENERAL PROTECTION)                            
	

ISSUE/PROBLEM

	The symptom was caused by a corrupt SERVER.EXE file.

SOLUTION

	After the user recopied SERVER.EXE from the original diskette, it worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Invalid COMMAND.COM" with DOS 5.0 and RPL
   DOCUMENT ID#:	FYI.P.4159
           DATE:	26SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	"Invalid COMMAND.COM"

ISSUE/PROBLEM

	Configuration:

		Using DOS 5.0
		Doing Remote Program Load (RPL)

	Whenever the user got through the login script, the system displayed the following error:

		Ŀ
		Invalid COMMAND.COM
		

SOLUTION

	After using the LOGIN.EXE from NetWare v3.11, the system worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Insufficient Memory, Do You Want to Save" - VREPAIR
   DOCUMENT ID#:	FYI.P.4147
           DATE:	25SEP91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When executing VREPAIR, the system displayed the following message:

		Ŀ
		Checking FAT.....  error insufficient memory, do you want to save?
		

ISSUE/PROBLEM

	VREPAIR runs in real mode as opposed to the operating system that runs in protected mode.  It is common for VREPAIR to run out of real memory.

SOLUTION

	Simply save and execute VREPAIR again until you do not run out of memory, then you are done.  It may take several times before you are done.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Divide Overflow" - Everex 486, NetWare v3.10a
   DOCUMENT ID#:	FYI.P.4194
           DATE:	02OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10a
     SUPERSEDES:	NA

SYMPTOM

	"Divide Overflow"

ISSUE/PROBLEM

	The user upgraded the file server machine from an Everex 386/33 to an Everex 486 EISA machine.  When they loaded SERVER, the system displayed the following error and exited back to DOS:

		Ŀ
		Divide Overflow
		

	If the user typed SERVER again, it loaded fine.  The user could get SERVER.EXE to work the first time by typing SERVER SERVER.

SOLUTION

	Novell instructed the user to reload SERVER.EXE from floppy diskette.

	After the user loaded SERVER.EXE from floppy diskette, loading SERVER worked as expected.  Then the user reapplied the RTAGFIX.EXE patch to fix the problem of NetWare v3.10a receiving the "ABEND: Bad Resource tag passed to AES process" error.   After applying the patch, loading SERVER.EXE still worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	PRINTCON, PRINTDEF and Primary Versus Default Server
   DOCUMENT ID#:	FYI.P.4715
           DATE:	19NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	You can create print job definitions (modes or functions) with PRINTDEF.  These will be stored on the server that you are on regardless of where PRINTDEF was pulled from when loading.  When you load PRINTCON, it automatically pulls you back to your primary file server, not just to your default.

	Example:	You can be logged into server A, B, and C on which you are a user without the authority to create PRINTDEF assignments.  Then you log into server D as a Supervisor or Supervisor Equivalence and create PRINTDEF assignments.  Subsequently, these definitions are stored on server D.

	        	When you execute the command PRINTCON from the PUBLIC directory or any other directory on server D, PRINTCON starts and you are transferred to server A as indicated by the prompt "User XXXX on Server A."  Of course, you can specify queue assignments on other servers; however, you will not be able to pull up any device definitions other than those on server A.

	Running PRINTCON becomes even more complex when running it on a multiple server network.

	Reassigning your default server using ATTACH does not solve the problem because PRINTCON searches for the primary file server and not the default.  If you log out of your primary server (now you do not have one) and then load PRINTCON from server D, you will receive an error message about not having a primary server and that this server D is now your primary.  At that point, it will all work and then you can just log in all over the place when done.

SOLUTION

	The primary server is the server that your shell first attaches to when you run NETX.  The preferred server option changes this.  Also, if you log in to a server as an invalid user, it will change your primary server to that server you tried to log in to.

	Three such distinguishing names for a server are in the table of servers:

	1.  Primary server
	2.  Preferred server
	3.  Default server

	System calls are available that allow you to change the first two of these to whatever server you prefer in your server name table.

	The primary server is the server from where your login script executed or the last server you set it to with SetPrimaryConnectionID (F004h) system call.

	Preferred server is either the server you first logged in to or the server you last made a request to.  It may be changed with the Preferred Server = statement in the SHELL.CFG or the SetPreferredConnectionID (F000h) system call.  Many of the NetWare system calls must have the preferred server explicitly set by this system call before commands will be routed to the desired server.

	The default server is the server to which packets are currently being routed and is a combination of the above two special cases in the server name table of the workstation.  The default server is part of the algorithm that a workstation uses to determine which server to route information to.  This can be found page 17-5 of the System Calls manual.
	Quick Recap:

	1.	Some system calls give an explicit server name; use it first.
	2.	If the preferred server has been set, use it next.
	3.	Check to see if the default drive is a network drive, and use it.
	4.	Use the primary server next.
	5.	Finally, if four is lost, use the first server in the name table.

	Note:  There is no preferred server unless you have a SHELL.CFG statement naming one or unless you have explicitly set one and the primary server could no longer exists if you have lost your attachment to the server you logged in on (either accidentally or by choice).

	If you set your preferred server, the problem mentioned with PRINTCON defaulting to the first server you logged in to should go away.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Missing or Illegal Printer Number" - NetWare v2.2 Core Printing
   DOCUMENT ID#:	FYI.P.4720
           DATE:	19NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	"Missing or illegal printer number"

ISSUE/PROBLEM

	When trying to create a port at the console, the system displayed the following message:

		Ŀ
		Missing or illegal printer number
		

	The symptom still existed even after the user tried deleting the queues and creating different printer numbers with different printer ports.

SOLUTION

	After reinstalling the operating system, the user was then able to create ports and print with no problems.  A typographical error in the AUTOEXEC.SYS (or at the console) will cause this error as well.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Resolution for Opening Named Pipes on DOS Workstation
   DOCUMENT ID#:	FYI.P.4692
           DATE:	19NOV91
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3
     SUPERSEDES:	NA

SYMPTOM

	Unable to open as many Named Pipes as desired on a DOS workstation.

ISSUE/PROBLEM

	The user is unable to open as many Named Pipes as desired on a DOS workstation.

SOLUTION

	Install NSD004.ZIP available on NetWire or NetWare Express.

	Novell has changed the way DOSNP allocates file handles.  It now recognizes the number of file handles that DOS (CONFIG.SYS, "FILES=") allocates.  If DOSNP (SHELL.CFG, "FILE HANDLES") requests more file handles than are available, then DOSNP aborts the load.  A maximum of 253 file handles is available, (254 and 255 are reserved).  A screen similar to the following appears when loading DOSNP.EXE with more file handles than allowable:

	Ŀ
	NetWare DOS NP Extender v1.30 Rev C (PTF 911011)                     
	                                                                     
	NetWare IPX/SPX Based Transport Copyright (c) 1990, 1991 Novell, Inc.
	All rights reserved.                                                 
	                                                                     
	Configuring NP Extender from SHELL.CFG.                              
	                                                                     
	FILE HANDLES 100                                                     
	                                                                     
	No room in DOS Handle Table for Named Pipe handles! A Maximum of     
	255 handles is allowed (2 are reserved).  You have exceeded that     
	value by 92.  Adjust the "FILE HANDLES" parameter in SHELL.CFG (the  
	default is 40) and/or the "FILES =" parameter in CONFIG.SYS so that  
	the two do not exceed 253.                                           
	                                                                     
	NetWare DOS NP Extender -- NOT loaded!                               
	




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	CAPTURE Cr= Leaves Garbage in CAPTURE SH
   DOCUMENT ID#:	FYI.P.4696
           DATE:	18NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM
	If you do a CAPTURE CR=textfile and then run an application when you exit the application and execute a CAPTURE SH, you will see something similar to the following:

		Ŀ
		Capturing lpt1 to queue=*!&-
		

ISSUE/PROBLEM

	When CAPTURE ends, it is trying to set the new CAPTURE to the default print queue.  Because no default print queue is in NetWare v3.11 (3.x also), CAPTURE's attempt to get the default will return garbage.

SOLUTION

	The solution to this is to give 386 a default by typing the following at the console type:

		spool 0 queue_1

	CAPTURE v3.51 does not have the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Insert Disk with COMMAND.COM in A: Drive"
   DOCUMENT ID#:	FYI.P.4669
           DATE:	15NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA

SYMPTOM

	The system displayed the following error in the same place you would normally get invalid COMMAND.COM after exiting an application that was entered through the menu:

		Ŀ
		Insert disk with COMMAND.COM in A: drive
		

ISSUE/PROBLEM

	The COMMAND.COM in the search drive PUBLIC/v3.3 was gone.

SOLUTION

	After the user copied COMMAND.COM back, everything was fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Deleting SYSTEM DIR Causes "F: Drive No Longer Valid"
   DOCUMENT ID#:	FYI.P.4680
           DATE:	14NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	After a user had deleted another user, the system displayed the following error when the user tried to log in to the network:

		Ŀ
		F: drive no longer valid
		

ISSUE/PROBLEM

	The user found that the SYSTEM directory had been deleted.

SOLUTION

	After the user reloaded the SYSTEM files, the error no longer occurred.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	"Line 128 Syntax Error" - System Supervisor CBT
   DOCUMENT ID#:	FYI.P.4671
           DATE:	14NOV91
        PRODUCT:	CBT
PRODUCT VERSION:	v3.1
     SUPERSEDES:	NA

SYMPTOM

	During the installation of the System Supervisor Computer-Based Training (CBT), the system displayed the following error:

		Ŀ
		Line 128 syntax error
		

ISSUE/PROBLEM

	Line 128 is where the installation batch file attempts to flag the files it has copied as Shareable Read Only.  This error indicates that the user has insufficient rights to change the flags.

SOLUTION

	Log back in as a user that has sufficient rights and either set the flags manually (by this point in the install all files have been copied and just need to be flagged properly) or reinstall the CBT.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NCOPY from Menu Problems
   DOCUMENT ID#:	FYI.P.4679
           DATE:	14NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The example using NCOPY from a menu on page 154 and 156 of the NetWare Version 2.2 Using the Network manual does not work if entered exactly as shown.

SOLUTION

	The example works if everything is placed on one line and a space is put between the drive source command and the drive destination command.

	Corrected example:

	NCOPY @1"Enter source drive/filename" @2"Enter destination drive/ filename"




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	UltraStor 12f Controller with Micropolis 1664 Drive
   DOCUMENT ID#:	FYI.P.4649
           DATE:	14NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When using an UltraStor 12f controller with a Micropolis 1664 drive, the following error is displayed with heavy disk I/O usage.

		Ŀ
		Write error: dir = 0x0300 file = D12.DAT;  Hot Fix turned off on
		drive 1 (volumes VOL2, VOL3);                                   
		

ISSUE/PROBLEM

	Although the UltraStor 12f and the 1664 are certified separately, they are not certified together.  Micropolis is selling a PC PAK that is an UltraStor 12f controller and a Micropolis 1664 hard disk.  On NetWare v2.2, v3.11, and v2.15 operating systems, the drive will fail under heavy I/O.  Under NetWare v2.2 operating system, the server sends an abend; and on NetWare v2.15 operating system, Hot Fix shuts off.

SOLUTION

	The solution at this point is to disable the BIOS on the controller and use Disk Manager N or use a different drive.  Micropolis is aware of the problem and is working on a solution.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Attempt to Map to Server..." - NNS
   DOCUMENT ID#:	FYI.P.4618
           DATE:	13NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The following error occurred when executing a domain login script after synchronizing in a new server and creating new users.

		Ŀ
		Attempt to map to server to which you are not attached
		

	Existing users had no problem.

ISSUE/PROBLEM

	The profile server list allows automatic attaching to domain servers defined in the profile server list.  Unless attachments are made for the new users, the above error will occur.

SOLUTION

	Assign the new server needs to profile server list.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NFS Problems with DOS Memory Limits in SYSCON
   DOCUMENT ID#:	FYI.P.4621
           DATE:	13NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Memory allocation errors (MALLOC)

ISSUE/PROBLEM

	Network File System (NFS) users are exceeding DOS memory limits in SYSCON.  This shows up as MALLOC or other memory allocation errors.

SOLUTION

	The only resolutions are the following:

		Have smaller NFS volumes.
		Do not fill up the volume (fewer files).
		Run the OS/2 version of SYSCON.

	In other words, if you are having MALLOC problems or some other memory allocation error in SYSCON and it happens on a NFS volume, there is no solution for the DOS version of SYSCON.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems Transferring Macintosh Files to Optical Volume
   DOCUMENT ID#:	FYI.P.4659
           DATE:	13NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	This problem was seen when transferring Macintosh files from a Macintosh machine to the Optical volume on the file server.  This particular drive was a Storage Dimensions LNE-1000.  If the amount transferred was greater than 6 to 7 MB at a time, the Optical volume would be corrupted.  The volume would not mount, was not usable, and had to be formatted.

	There was no problem when transferring large amounts of DOS files (100 MB) at a time.

ISSUE/PROBLEM

	The file server only had three File Service Processes (FSPs) available.

SOLUTION

	In a dedicated operation, the file server has five File Service Processes (FSPs) available.

	The user regenerated the operating system for dedicated operation.  After regenerating the file server, there were no problems copying large amounts of Macintosh files (70 MB+ at a time).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Seek Error Writing Drive C:" - NetWare v2.15c
   DOCUMENT ID#:	FYI.P.4655
           DATE:	13NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA

SYMPTOM

	After changing the hard disk in the workstation (it had failed), the system displayed the following error only when the user logged in to the 386/25 file server and tried to copy files from the A: to C: drive:

		Ŀ
		Seek error writing drive c:
		

	When logged into the 486/25, the user could copy with no errors.  Copying from the C: to A: drive worked fine on either system.

ISSUE/PROBLEM

	Configuration:

		The user had two servers on a network both running NetWare v2.15c.
		- One was a Compaq 386/25
		- One was a Compaq 486/25
		The workstation was a Model 60-041.

	The system login script on the 386/25 file server contained the statement "DOS VERIFY ON."

SOLUTION

	After the user removed the "DOS VERIFY ON" statement from the script, the problem did not occur.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Workstations Get Sending or Receiving Errors - PCONSOLE
   DOCUMENT ID#:	FYI.P.4586
           DATE:	07NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When a print job was sent to the queue and the RPRINTER started to print the job, all workstations on network hung and displayed the following errors:
		Ŀ
		Error sending on network
		
		Ŀ
		Error receiving from network
		

ISSUE/PROBLEM

	An extra PSERVER subdirectory was in the SYSTEM directory.  PCONSOLE v1.51 does not delete the subdirectory as it should when the print server is deleted.

SOLUTION

	After deleting the subdirectory, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	New NE1500T Card
   DOCUMENT ID#:	FYI.P.4590
           DATE:	07NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What is the 1500T network board?

SOLUTION

	This is the twisted pair version of the NE2100 network board that was previously to have been named the NE2100T board, but was renamed due to confusion in the market place.  Because the NE2100T board had not been released, Novell was able to change the name before it went out.  However, the NE2100 board had already been released and will not be renamed to avoid further confusion.

	The NE1500T has a whole new set of files that go with it that have names such as ANE150A1.OBJ to correlate with the board name.  Engineering indicated that the 2100 drivers will work with it, but the message strings within the driver give erroneous errors referring to the NE2100 board.

	Think of the NE1500T board as a new board and do not worry about its relationship to the NE2100.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NETCON and "CreatePortal Returned Error of 254"
   DOCUMENT ID#:	FYI.P.4582
           DATE:	06NOV91
        PRODUCT:	NetWare Naming Service
PRODUCT VERSION:	v1.0
     SUPERSEDES:	NA

SYMPTOM

	While using NETCON and trying to access anything such as account restrictions, the system displayed the following error:

		Ŀ
		CreatePortal returned an error code of 254.
		

ISSUE/PROBLEM

	The workstation was running a number of terminate-and-stay resident (TSRs) and was short on memory.  It only had 440 KB available.

SOLUTION

	Removing the TSRs allowed NETCON to run without errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Known Bindery Object Types
   DOCUMENT ID#:	FYI.P.4546
           DATE:	04NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What are the current bindery object types?

SOLUTION

	The following is a list of known NetWare Bindery Object Types:

Ŀ
Description                Object Type (Hex) 
Ĵ
Unknown                          0    (0000h)
User                             1    (0001h)
Group                            2    (0002h)
Print Queue                      3    (0003h)
File Server                      4    (0004h)
Job Server                       5    (0005h)
Gateway                          6    (0006h)
Print Server                     7    (0007h)
Archive Queue                    8    (0008h)
Archive Server                   9    (0009h)
Job Queue                       10    (000Ah)
Administration                  11    (000Bh)
NAS SNA Gateway                 33    (0021h)
NACS                            35    (0023h)
Remote Bridge Server            36    (0024h)
Bridge Server                   38    (0026h)
TCP/IP Gateway                  39    (0027h)
Gateway                         41    (0029h)
Time Synchronization Server     45    (002Dh)
Archive Server                  46    (002Eh)
Advertising Print Server        71    (0047h)
Btrieve VAP/NLM 5.xx            75    (004Bh)
SQL VAP/NLM                     76    (004Ch)
Xtree Network Version           77    (004Dh)
Btrieve VAP/NLM 4.xx            80    (0050h)
Appletalk                       83    (0053h)
X25 Gateway                     88    (0058h)
WANCopy                        114    (0072H)
TES - NetWare for VMS          122    (007Ah)
NetWare Access Server          152    (0098h)
Portable NetWare               158    (009Eh)
Compaq IDA Status Monitor      172    (00ACh)
NetWare 386 Server             263    (0107h)
CSA_MUX                        276    (0114h)
CSA_LCA                        277    (0115h)
CSA_CM                         278    (0116h)
CSA_SMA                        279    (0117h)
CSA_DBA                        280    (0118h)
CSA_NMA                        281    (0119h)
CSA_SSA                        282    (011Ah)
CSA_STATUS                     283    (011Bh)
CSA_APPC                       286    (011Eh)
SNA-TEST                       294    (0126h)
CSA_TRACE                      298    (012Ah)
Communications Executive       304    (0130h)
NNS Domain                     307    (0133h)
NNS Profile                    309    (0135h)
NNS Queue                      311    (0137h)
?                              780    (030Ch)
WordPerfect Network Version           (8888h)
Wildcard                        -1    (FFFFh)





                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Lists of Patches and Fixed for NetWare v3.x
   DOCUMENT ID#:	FYI.P.4540
           DATE:	04NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Is there a compiled list of the patches or fixes for NetWare v3.10 and NetWare v3.11 operating systems?

SOLUTION

	Refer to the following files:

	  FILE		      LOCATION
	311PT5.ZIP	NetWire
	PAT310.ZIP	NetWire
	PAT311.ZIP	NetWire
	TB.P.278		NSE (v3.10 essential patches)
	TB.P.279		NSE (v3.10 special case patches)




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Where USERDEF Stores Templates
   DOCUMENT ID#:	FYI.P.4544
           DATE:	04NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x, v3.x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Where does USERDEF store templates?

SOLUTION

	USERDEF stores templates in the SYS:PUBLIC directory.  Template files are flagged "HIDDEN" and have a .UDT extension.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Nondedicated Servers Not Allowing Print Screen
   DOCUMENT ID#:	FYI.P.4528
           DATE:	01NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	A nondedicated file server is an EMULATED DOS environment and being so, does not transfer all the BIOS functions to the DOS process, one function being Prt-Scrn.  The reason Prt-Scrn is not transferred is mostly due to the CPU performance hit imposed by this function.  In basic terms, it means you cannot do a Print Screen from a nondedicated server's DOS process.

	As for PRINT, this is a DOS TSR that attempts to gain control of the LPT port; thus confusing CAPTURE.  Because of this confusion, NPRINT was developed.  PRINT leaves itself resident (TSR) and TSRs are not recommended on a nondedicated server.  PRINT tries to get control of the LPT port directly and PRINT is not aware of NetWare queues.

	NPRINT on the other hand acknowledges NetWare queues, print jobs, and all the other functions CAPTURE does.  Also, NPRINT is not a TSR and does not try to control the local workstation's hardware.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	FILER Error of 142 - NetWare v3.10
   DOCUMENT ID#:	FYI.P.4522
           DATE:	01NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to SET the owner for a group of files while using FILER, the system displayed the following message:

		Ŀ
		Error: SetFileInformation returned an error of 142
		

ISSUE/PROBLEM

	The user indicated that the files he was trying to set were a group of database files, and he discovered that other users were using the files.

SOLUTION

	When the other users logged out, the user was able to change the file's owners without receiving any errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NDIR /dates Showing Invalid Archived Date and Time
   DOCUMENT ID#:	FYI.P.4509
           DATE:	30OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x, v3.x
     SUPERSEDES:	NA

SYMPTOM

	"NDIR /dates" does not show a valid Last Archived Date and Time.

ISSUE/PROBLEM

	"NDIR /dates" does not show a valid Last Archived date and time.

SOLUTION

	The function call SetFileInformation allows the backup software to change the "Last Archived" date and time.  When a read request is received, NetWare cannot distinguish if it is for an archive or not.  The backup software has the responsibility to update the "Last Archived" date and time.  Most backup software does not bother to do this.  In fact, none of Novell's backup utilities update the "Last Archived" date and time.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	The /s Switch in Login Script
   DOCUMENT ID#:	FYI.P.4503
           DATE:	30OCT91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	A corrupt or invalid system login script will not allow user to log in to the server.

ISSUE/PROBLEM

	If the system login script file (NET$LOG.DAT) becomes corrupt or the login script becomes invalid after alterations, what recourse does one have to log in to the server?

SOLUTION

	If you use the /s switch, followed by a filename, it will try to execute the file name as the login script.

	Example:

		Login /s c:\dummy.txt <file server>/<user name>

	This redirects the login to a nonexistent file, so it gives an error but completes the login.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	"Error Initializing Driver ..." - NetWare v2.15c on Model 80
   DOCUMENT ID#:	FYI.P.4495
           DATE:	29OCT91
        PRODUCT:	NetWare Advanced
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	When booting a Model 80 with v2.15c NetWare, the system displayed the following error:

		Ŀ
		Error initializing driver. Cannot find 3com Etherlink
		microchannel adapter.                                
		

ISSUE/PROBLEM

	The RAM address on the reference diskette was d000-d5fff and the user had selected c0000 in NetWare.

SOLUTION

	When the user changed the reference diskette so the system recognized it at c000-c5fff, the system came up fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Can LOGIN.EXE Return Error Levels
   DOCUMENT ID#:	FYI.P.8737
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user wanted to write a batch file to make a user log in before anything else could be done on the workstation.  He had questions on specifying the LOGIN.EXE returning error level's syntax.

SOLUTION

	Example batch file:

		goto run
		exit
		:run
		login <servername>/<username>
		if errorlevel 1 goto run




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Intermediate Database File TEMP$$DB.TMP..." - PRINTDEF
   DOCUMENT ID#:	FYI.P.8743
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to modify PRINTDEF v1.51, the system displayed the following error:

		Ŀ
		Intermediate database file temp$$db.tmp can not be renamed
		to net$ prn.dat                                           
		

ISSUE/PROBLEM

	NET$PRN.OLD was corrupt; thus it would not allow the PRINTDEF changes to be made.

SOLUTION

	When the user deleted this NET$PRN.OLD file, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Only Local Directories Can Be Selected" - ELS Level II
   DOCUMENT ID#:	FYI.P.8740
           DATE:	03SEP92
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.15b
     SUPERSEDES:	NA

SYMPTOM

	"Only local directories can be selected."

ISSUE/PROBLEM

	The user upgraded the workstation to MS-DOS v5.0.  Then, whenever the user tried to insert the server name while running SYSCON or SESSION, the system displayed the following error message:

		Ŀ
		Only local directories can be selected.
		

SOLUTION

	When the user upgraded to ELS NetWare Level II v2.15c, the symptom disappeared and everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Print Jobs Going to Wrong Printer
   DOCUMENT ID#:	FYI.P.8745
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Print jobs sent to the PaintJet would go to the HP IIIsi unless they were sent from PCONSOLE.

	Two servers with the same name showed under "Currently Attached Servers" in PCONSOLE.

ISSUE/PROBLEM

	The user had two printers and two queues.  One was a PaintJet attached to the server and one was a HP IIIsi connected through its own Token-Ring board.  Deleting and recreating queues and printer definitions did not stop the symptoms.

	The user was sure the HP IIIsi was set up for the Remote Printer mode; however, it was currently set for the QSERVER mode in PCONFIG.

SOLUTION

	After the user changed the HP IIIsi to the REMOTE PRINTER mode, it worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Configuration Files Running NetWare and IBM NetBIOS
   DOCUMENT ID#:	FYI.P.8741
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The following are configuration files from an OS/2 station that was  running both NetWare NetBIOS and IBM NetBIOS compatibly:

	CONFIG.SYS

	IFS=C:\OS2\HPFS.IFS  /CACHE:512 /CRECL:4 /AUTOCHECK:C
	PROTSHELL=C:\OS2\PMSHELL.EXE
	SET USER_INI=C:\OS2\OS2.INI
	SET SYSTEM_INI=C:\OS2\OS2SYS.INI
	SET OS2_SHELL=C:\OS2\CMD.EXE
	SET AUTOSTART=PROGRAMS,TASKLIST,FOLDERS
	SET RUNWORKPLACE=C:\OS2\PMSHELL.EXE
	SET COMSPEC=C:\OS2\CMD.EXE LIBPATH=D:\IBMLAN\NETLIB;C:\MUGLIB\DLL;.;
	 C:\OS2\DLL;C:\OS2\MDOS;C:\;C:\OS2\APPS\DLL;C:\IBMCOM\DLL;
	 D:\NetWare;D:\NOTES
	SET PATH=D:\IBMLAN\NETPROG;C:\MUGLIB;C:\OS2;C:\OS2\SYSTEM;
	 C:\OS2\MDOS\WINOS2;C:\OS2\INSTALL;C:\;C:\OS2\MDOS;C:\OS2\APPS;
 	 L:\OS2;P:\OS2;D:\NetWare;D:\NOTES
	SET DPATH=D:\IBMLAN\NETPROG;D:\IBMLAN;C:\MUGLIB;C:\OS2;C:\OS2\SYSTEM;
	 C:\OS2\MDOS\WINOS2;C:\OS2\INSTALL;C:\;C:\OS2\BITMAP;C:\OS2\MDOS;
	 C:\OS2\APPS;C:\IBMCOM;D:\NetWare;
	SET PROMPT=$i[$p]
	SET HELP=C:\OS2\HELP;C:\OS2\HELP\TUTORIAL;
	SET GLOSSARY=C:\OS2\HELP\GLOSS;
	PRIORITY_DISK_IO=YES
	FILES=20
	DEVICE=C:\ibmcom\lanmsgdd.os2 /I:C:\ibmcom
	DEVICE=C:\ibmcom\protman.os2 /I:C:\ibmcom
	DEVICE=C:\ibmcom\protocol\LANDD.OS2
	DEVICE=C:\ibmcom\protocol\LANDLLDD.OS2
	DEVICE=C:\OS2\TESTCFG.SYS
	DEVICE=C:\OS2\DOS.SYS
	DEVICE=C:\OS2\PMDD.SYS
	BUFFERS=30
	IOPL=YES
	DISKCACHE=512,LW
	MAXWAIT=3
	MEMMAN=SWAP,PROTECT
	SWAPPATH=C:\OS2\SYSTEM 2048 2048
	BREAK=OFF
	THREADS=512
	PRINTMONBUFSIZE=134,134,134
	COUNTRY=001,C:\OS2\SYSTEM\COUNTRY.SYS
	SET KEYS=ON
	REM SET DELDIR=C:\DELETE,512;D:\DELETE,512;E:\DELETE,512;
	BASEDEV=PRINT02.SYS
	BASEDEV=IBM2FLPY.ADD
	BASEDEV=IBM2ADSK.ADD
	BASEDEV=OS2DASD.DMD
	SET BOOKSHELF=D:\IBMLAN\BOOK;C:\OS2\BOOK
	SET EPATH=C:\OS2\APPS
	REM DEVICE=C:\OS2\APPS\SASYNCDB.SYS
	PROTECTONLY=NO
	SHELL=C:\OS2\MDOS\COMMAND.COM C:\OS2\MDOS /P
	FCBS=16,8
	RMSIZE=640
	DEVICE=C:\OS2\MDOS\VEMM.SYS
	DEVICE=C:\OS2\MDOS\VMOUSE.SYS
	DOS=LOW,NOUMB
	DEVICE=C:\OS2\MDOS\VDPX.SYS
	DEVICE=C:\OS2\MDOS\VXMS.SYS /UMB
	DEVICE=C:\OS2\MDOS\VDPMI.SYS
	DEVICE=C:\OS2\MDOS\VWIN.SYS
	DEVICE=C:\OS2\MDOS\VCDROM.SYS
	DEVINFO=SCR,VGA,C:\OS2\VIOTBL.DCP
	SET VIDEO_DEVICES=VIO_VGA
	SET VIO_VGA=DEVICE(BVHVGA)
	DEVICE=C:\OS2\MDOS\VVGA.SYS
	DEVICE=C:\OS2\POINTDD.SYS
	DEVICE=C:\OS2\MOUSE.SYS
	DEVICE=C:\OS2\COM.SYS
	DEVICE=C:\OS2\MDOS\VCOM.SYS
	CODEPAGE=437,850
	DEVINFO=KBD,US,C:\OS2\KEYBOARD.DCP
	
	REM --- NetWare Requester statements BEGIN ---
	DEVICE=D:\NetWare\LSL.SYS
	RUN=D:\NetWare\DDAEMON.EXE
	DEVICE=D:\NetWare\TOKEN.SYS
	DEVICE=D:\NetWare\ROUTE.SYS
	device=d:\NetWare\odinsup.sys
	DEVICE=D:\NetWare\IPX.SYS
	DEVICE=D:\NetWare\SPX.SYS
	RUN=D:\NetWare\SPDAEMON.EXE
	rem DEVICE=D:\NetWare\NMPIPE.SYS
	rem DEVICE=D:\NetWare\NPSERVER.SYS
	rem RUN=D:\NetWare\NPDAEMON.EXE NP_COMPUTERNAME
	DEVICE=D:\NetWare\NWREQ.SYS
	IFS=D:\NetWare\NWIFS.IFS
	RUN=D:\NetWare\NWDAEMON.EXE
	DEVICE=D:\NetWare\NETBIOS.SYS
	RUN=D:\NetWare\NBDAEMON.EXE
	DEVICE=D:\NetWare\VIPX.SYS
	DEVICE=D:\NetWare\VSHELL.SYS
	REM --- NetWare Requester statements END ---
	
	RUN=C:\ibmcom\protocol\landll.exe
	RUN=C:\ibmcom\protocol\netbind.exe
	RUN=C:\ibmcom\lanmsgex.exe
	DEVICE=C:\IBMCOM\PROTOCOL\NETBEUI.OS2
	DEVICE=D:\IBMLAN\NETPROG\RDRHELP.200
	
	IFS=D:\IBMLAN\NETPROG\NETWKSTA.200 /I:D:\IBMLAN /N
	DEVICE=C:\IBMCOM\PROTOCOL\NETBIOS.OS2
	rem DEVICE=C:\IBMCOM\MACS\IBMTOK.OS2
	RUN=D:\IBMLAN\NETPROG\LSDAEMON.EXE
	
	
	OS/2 LAN Requester Initialization File
	
	[networks]
	; This information is read by the redirector at device initialization time.
	  ;net1=netbeui$,0,LM10, 32, 50, 14
	  NET1=IPXNB$,0,LM10,16,16,8
	  NET2=NETBEUI$,0,LM10, 32, 50, 14
	
	[requester]
	  COMPUTERNAME =LAB
	  DOMAIN =OS2LAB
	
	
	; The following parameters generally do not need to be
	; changed by the user.
	
	  charcount = 16
	  chartime = 250
	  charwait = 3600
	  keepconn = 600
	  keepsearch = 600
	  maxcmds = 16
	  maxerrorlog = 100
	  maxthreads = 10
	  maxwrkcache = 64
	  numalerts = 12
	  numcharbuf = 10
	  numservices = 12
	  numworkbuf = 15
	  numdgrambuf = 14
	  othdomains =
	  printbuftime = 90
	  sesstimeout = 45
	  sizcharbuf  = 512
	  sizerror = 1024
	  sizworkbuf = 4096
	
	; The next lines help you to locate bits in the wrkheuristics entry.
	;                           1         2         3
	;                 0123456789012345678901234567890123
	  wrkheuristics = 1111110121311111110001011120111221
	
	  ;wrknets =net1
	   wrknets =net2
	   wrkservices = lsclient,messenger,netpopup
	
	[messenger]
	  logfile = messages.log
	  sizmessbuf = 4096
	
	[lsclient]
	  multilogon = no
	
	[replicator]
	  replicate = IMPORT
	  importpath = D:\ibmlan\repl\import
	  tryuser = yes
	  password =
	
	[services]
	; Correlates name of service to pathname of service program.
	; The pathname must be either
	;       1) an absolute path (including the drive specification)
	;                       OR
	;       2) a path relative to the IBMLAN root
	
	  requester = services\wksta.exe
	  messenger = services\msrvinit.exe
	  netpopup = services\netpopup.exe
	  replicator = services\replicat.exe
	  lsclient = services\lsclient.exe
	
	NET.CFG FILE
	
	link driver token
		frame token-ring
		frame token-ring_snap
	
	protocol odinsup
		bind token
	
	link support
		buffers 14 4202
	
	NetWare Netbios
		Commands 85
		names 10
		sessions 40
	
	NetWare Requester
		Sessions 15
	
		PROTOCOL.INI FILE
	
	[PROT_MAN]
	 DriverName = PROTMAN$
	
	[IBMLXCFG]
	 IBMTOK_nif = IBMTOK.nif
	 LANDD_nif = LANDD.nif
	 NETBEUI_nif = NETBEUI.nif
	
	[LANDD_nif]
	 DriverName = LANDD$
	; Bindings = IBMTOK_nif
	 Bindings = TOKEN
	 ETHERAND_TYPE = "I"
	 SYSTEM_KEY = 0x0
	 OPEN_OPTIONS = 0x2000
	 TRACE = 0x0
	 LINKS = 8
	 MAX_SAPS = 3
	 MAX_G_SAPS = 0
	 USERS = 3
	 TI_TICK_G1 = 255
	 T1_TICK_G1 = 15
	 T2_TICK_G1 = 3
	 TI_TICK_G2 = 255
	 T1_TICK_G2 = 25
	 T2_TICK_G2 = 10
	 IPACKETS = 250
	 UIPACKETS = 100
	 MAXTRANSMITS = 6
	 MINTRANSMITS = 2
	 TCBS = 64
	 GDTS = 30
	 ELEMENTS = 800
	
	[NETBEUI_nif]
	 DriverName = netbeui$
	; Bindings = IBMTOK_nif
	 Bindings = TOKEN
	 ETHERAND_TYPE = "I"
	 USEADDRREV = "YES"
	 SESSIONS = 40
	 NCBS = 95
	 NAMES = 21
	 SELECTORS = 5
	 USEMAXDATAGRAM = "NO"
	 ADAPTRATE = 1000
	 WINDOWERRORS = 0
	 TI = 30000
	 T1 = 500
	 T2 = 200
	 MAXIN = 1
	 MAXOUT = 1
	 NETBIOSTIMEOUT = 500
	 NETBIOSRETRIES = 8
	 NAMECACHE = 0
	 PIGGYBACKACKS = 1
	 DATAGRAMPACKETS = 2
	 PACKETS = 350
	 PIPELINE = 5
	 MAXTRANSMITS = 6
	 MINTRANSMITS = 2
	 DLCRETRIES = 5
	
	
	[IBMTOK_nif]
	 DriverName = IBMTOK$
	 PRIMARY
	 MAXTRANSMITS = 12
	 RECVBUFS = 2
	 RECVBUFSIZE = 256
	 XMITBUFS = 1
	
	[TOKEN]
	
	[NETBIOS]
	 DriverName = Netbios$
	 Bindings = TOKEN
	 ADAPTER0 = IPXNB$,0
	 ADAPTER1 = NETBEUI$,1

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Errors Backing Up Server with Maynard Tape Unit - CLIB.NLM
   DOCUMENT ID#:	FYI.P.8728
           DATE:	02SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The system displayed errors when the user backed up the file server with the Maynard tape unit.

ISSUE/PROBLEM

	Many users are asking about a new CLIB.NLM that Maynard's engineers claim Novell has.
SOLUTION

	Novell does not have a new CLIB.NLM; however, Novell does have a patch for the existing NLM named PAT311.ZIP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Slow Network and Locking - NE2000 in Gateway 2000
   DOCUMENT ID#:	FYI.P.8716
           DATE:	02SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Workstations have slow interaction or lock when doing simple requests of the file server.

ISSUE/PROBLEM

	The NE2000 is reported to be incompatible (in spite of W16 jumper) with a new (and uncertified) Gateway 2000 486 DX/2 50 mHz server.  Gateway reports having tested Novell's board.  The users report being able to attach and log in, but lock with even small volumes of traffic.

SOLUTION

	When the user replaced the NE2000 with an Atcon Ethernet board (NE2000 clone--also not certified), the user was able to use the NE2000 driver successfully.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Archive Backup Will Not Backup DIRSTAMP.SYS File
   DOCUMENT ID#:	FYI.P.8701
           DATE:	01SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM
	
	The user could not back up the hidden file DIRSTAMP.SYS.  The user tried everything from unhiding the file (could not do it) to excluding it (obviously, just would not get the error).

ISSUE/PROBLEM

	Configuration:

		Using Archive 150 backup application

	Unless a backup application is "NetWare Aware," it will not be able to backup this file because some specific NetWare Core Protocol's (NCPs) must be called.

SOLUTION

	If this file is not present when the server is restored and brought back up, it will be recreated automatically; consequently, this scenario will not harm your system.

	DIRSTAMP.SYS does not contain trustee information or the base file attributes.  The only useful information it contains is file ownership and the last archive dates used by LARCHIVE and NARCHIVE.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Set Enable Packet Burst Statistics Screen
   DOCUMENT ID#:	FYI.P.8702
           DATE:	01SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM
	NA

ISSUE/PROBLEM

	This document concerns the SET ENABLE PACKET BURST STATISTICS SCREEN = ON|OFF parameter.

	What does the Packet Burst Statistics screen show?

SOLUTION

	Setting this parameter on a NetWare v3.11 server will result in a screen that you can switch to from the NetWare console screen.  Besides the rows of zeros in the screen's lower portion (which are not meaningful at present), two numbers in the format "xxx:yyy" will appear in the screen's upper left hand portion.

	The xxx number represents the connection number.  Each workstation has a unique connection number.  This connection number does not relate to any of the other connection numbers with which Novell is familiar; it is unique to the Burst protocol.

	The yyy number is a hexadecimal value representing the Burst Gap Time.  The value is usually low, around 0Eh.  This number changes until it finds its optimal value.  It should only take a moment for this number to settle to its final value.  If it keeps getting higher and higher, this is evidence of a bug in the current version of the protocol.

	Each workstation that is running Burst Mode and is connected to that server will have a separate xxx:yyy number.

	Switching to the Packet Burst Statistics Screen is helpful when no perceptible performance increase is noted.  It may be that the client is not currently running Burst Mode.  The cause is usually from failing to add the PB Buffers = [2-10] line to the NET.CFG.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Setting Up Print Server to Service Other Servers - NetPort
   DOCUMENT ID#:	FYI.P.8714
           DATE:	01SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Is it possible to set up a print server that will service queues on other file servers when NetPorts are being used?

SOLUTION

	It is possible; however, the NetPort on the initial file server must be set up as a remote printer.  Intel provides step-by-step instructions.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Entering Windows, All Network Drives Are Set to Local
   DOCUMENT ID#:	FYI.P.8707
           DATE:	01SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When entering Windows 3.1, all network drives are set to local.

ISSUE/PROBLEM

	Configuration:

		Using EMSNETX.EXE

	Because Microsoft was unable to reproduce or determine cause of problem, the Microsoft Windows 3.1 NETWORKS.WRI file stated the following:

		"Note: The EMS NetWare shells (EMSNETX.EXE, etc.) are not supported when Windows is running in 386 Enhanced mode."

	Because Novell has not published such a statement, the user figured it should work.  A Microsoft technician stated the following:

		"Loading network drivers in EMS memory is a bad idea due to the unreliable nature of anything that uses paged memory.  This would hold true for any network driver residing in EMS memory."  The technician also indicated that saying that a problem with EMSNETX is a Novell problem that they are unwilling to fix would be an "incorrect statement."  Thus, any brand of Network driver (Microsoft, Artisoft, Novell, etc.) could have problems if loaded into EMS memory.  Microsoft suggested loading NETX high as a way to free up conventional memory.

SOLUTION

	In the rare instances where EMSNETX has problems with Windows, the solution is to use NETX or XMSNETX.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error Spooling to Network Printer" - PSERVER.VAP
   DOCUMENT ID#:	FYI.P.8710
           DATE:	01SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Everything was working fine until the user had problems at one of the workstations and they replaced a hard disk.  At the same time, the user added a couple of network users to the Solomon application; thereafter, the system displayed the following messages:

	                   		Ŀ
	Error from Solomon:		Error spooling to network printer.
	                   		
	    Ŀ
	Error from PCONSOLE:	The specified target print server for this
	                   		job/queue is unknown.                     
     	

ISSUE/PROBLEM

	Configuration:

		Using the PSERVER VAP v1.22r
		Running NetWare v2.2 nondedicated
		Loading Solomon III v7.01 at the nondedicated station through AUTOEXEC.BAT when the server is booted

	The error associated with PCONSOLE is normal when viewing the Print Queue Entry Information screen when printing a job.  However, the user saw some of the information in the screen being corrupted, and that is not normal.

SOLUTION

	It looked like the system had corrupted something; however, replacing or updating the operating system, shell, PSERVER.VAP, RPRINTER, PCONSOLE, and running a virus scan did not fix the problem.  There is no solution; but user did the following as workaround:

	The user connected the printer off the server and used core printing.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NE2000 Driver Not Loading in AUTOEXEC.NCF
   DOCUMENT ID#:	FYI.P.8695
           DATE:	31AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user had two NE2000-type boards and a NetWorth hub running NetWare v3.11 Runtime version.  The user could not get the NE2000 driver (NE2000.LAN, 07-26-91) to load and bind (two times) automatically in the AUTOEXEC.NCF.  It worked fine, loading manually, at the console prompt or if he just loaded the driver once.  The user also tried recreating the AUTOEXEC.NCF and checked the syntax for loading the LAN driver.

ISSUE/PROBLEM

	The AUTOEXEC.NCF file was located on the DOS partition (C: drive) instead of in SYS:SYSTEM.  Also, they were loading the DISK driver in the AUTOEXEC.NCF file instead of in the STARTUP.NCF file.

SOLUTION

	When the user copied the AUTOEXEC.NCF to SYS: volume and loaded the disk driver in STARTUP.NCF, he was able to load the NE2000 driver twice in the AUTOEXEC.NCF with no problems.

	Nothing is wrong with loading a disk driver in the AUTOEXEC.NCF or with the AUTOEXEC.NCF being on the C: drive.  Sometimes the disk driver must be loaded in the AUTOEXEC.NCF; however, in this case, it would not work.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Server Abends - Network C for NLMs
   DOCUMENT ID#:	FYI.P.8690
           DATE:	31AUG92
        PRODUCT:	Network C for NLMs
PRODUCT VERSION:	NA
     SUPERSEDES:	NA

SYMPTOM

	Server receives an abend or just incorrect results

ISSUE/PROBLEM

	If a symbol NOT in CLIB is referenced in an .OBJ and it happens that the symbol is in the DOS static library CLIB3S, WLINK will not only pull in the definition for the DOS function but will also pull in other modules that contain symbols referenced by that object module.

	Examples:	The API dup() was referenced by an NLM; and not only was dup() pulled in, but unlink(), _get_errno_ptr() and a host of other APIs were also pulled.  This will cause many undesirable results.

			If an interrupt line 21 is executed, the server will abend, making the problem very easy to resolve.  However, other much more subtle bugs might go unnoticed.

			One case was a DOS API failing with -1, but errno showing 0, because the errno from a library module was getting set instead of CLIBs thread errno.

SOLUTION

	The following options are workarounds for the problems.

		Always use the NOD option when linking.  This keeps WLINK from searching the libraries whose names are embedded into the .OBJ files.

		Do not set the LIB386 environment variable.  That way, the LINKER cannot find the DOS libraries.

	Everything in this example is working as designed.  It is normal for C compilers to search all libraries in their libpath in an attempt to resolve symbols.  It is also normal to link in everything in a library rather than only the specified routine.  This is true for all major PC based C compilers (Borland, Microsoft, Watcom, and MetaWare all perform this way).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NB310.ZIP to NetWire
   DOCUMENT ID#:	FYI.P.8698
           DATE:	31AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM
	NA

ISSUE/PROBLEM

	This document concerns NB310.ZIP that contains the latest NetBIOS v3.1 that has passed Software Test.  This version contains fixes made in the previous version (v3.02C) as well as these additional fixes:

	1.	This version correctly displays parameters met in the NET.CFG file.  Previous versions correctly applied parameters from the NET.CFG file but would sometimes garble the parameters on the screen.

	2.	This version corrected a problem that had been fixed in the OS/2 version for some time.  At times, the Adapter Status command would return an error code of 06 (short buffer) when it should have returned a 00 code.

	3.	This version fixes the problem that occurred while running with Artisoft's LANtastic for NetWare where the workstation hung with the following error:

		Ŀ
		!!!NetBIOS ABEND FreeIPXBlock - already on free list,
		during file copy."                                   
		

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error 4" Running UPGRADE from Floppy Diskette
   DOCUMENT ID#:	FYI.P.8678
           DATE:	28AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user executed UPGRADE v3.50 from a floppy diskette to restore the upgraded binderies to a NetWare v3.11 server.  When running DOS 5.0, the system displayed the following message when the user selected the option "Restore to 386 3.x File Server" from the Upgrade Main Menu:

		Ŀ
		Error 4
		

ISSUE/PROBLEM

	The error is probably generated by DOS 5.0.

SOLUTION

	When the user executed UPGRADE from the NetWare v3.11 network drive instead of the floppy diskette, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error 1139 Cache Memory Allocator Out of Available Memory"
   DOCUMENT ID#:	FYI.P.8688
           DATE:	28AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user was trying to place three NE2100 boards in the server.  After loading the third driver, the system displayed the following error:

		Ŀ
		Error 1139 cache memory allocator out of available memory
		

	However, the user could bind IPX to the board.  When the user loaded INSTALL, the server hung.

ISSUE/PROBLEM

	When the first NE2100 board is installed, it takes about half of the bandwidth; installing the second board uses the rest of the bandwidth; and adding the third board hung the server.

SOLUTION

	The supplement manual for the NE2100 states the following:

		"Do not install more than one NE2100T in each workstation, router, or server.  Do not install any other bus master board in a machine with an NE2100T installed."




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	File Services NCP Request Available to NETX
   DOCUMENT ID#:	FYI.P.8670
           DATE:	27AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Slow response

ISSUE/PROBLEM

	A file-services NetWare Core Protocol (NCP) request (2222), function code 3B, is available to NETX that was not available to the previous versions of the shell.

	Function code 3B is file services NCP request function code for purge (from cache not disk drive) that is used mostly by database applications.  This function could relatively be time consuming.  The file server's response to this shell request might make the NETX shell seem slower than the older shells if a database application is using it extensively.

	One user took a trace and measured the time difference.  The user noticed the slow down while doing some very heavy duty database operations and the application was using this function heavily.

SOLUTION

	This is not a problem because it is an extra function made available to the shell.  It is up to the application whether to use the 3B function code.  Novell suggests using BNETX (packet burst) not only to make up for the lost time but also to gain major performance increase.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Load DOS and XMSNETX High
   DOCUMENT ID#:	FYI.P.5038
           DATE:	18DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Cannot load DOS and XMSNETX high.

ISSUE/PROBLEM

	The user was unhappy that Novell's driver was written so that they could not load DOS 5.0 and XMSNETX high.

SOLUTION

	The problem is not with Novell's driver.  To be real-mode accessible, DOS or XMSNETX must be loaded in the 64 KB above 1 MB area.  In almost all applications, the memory manager searches the 64 KB area and if anything is in there, it will not load there.  DR DOS 6.0 allows the 64 KB area to be shared only when running DR DOS programs.  Even if 64 KB is not large enough for DOS and a shell, it is more flexible than other memory managers.

	None of Novell's shells or programs are able to load into the HMA to coexist with DR DOS utilities.  Anything written to share that area must be DR DOS specific and is written to try that area first.

	Note: The statements LOAD HIGH, HILOAD, or LOAD A PROGRAM HIGH are referring to the Upper Memory Area (UMA) and not the High Memory Area (HMA).



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	PSERVER.VAP Locks ARCnet File Server
   DOCUMENT ID#:	FYI.P.5015
           DATE:	18DEC91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM
	
	The user stated that PSERVER.VAP locks the server from time to time.  Then when the user typed PSERVER STOP and then PSERVER START, a fatal error occurred.

ISSUE/PROBLEM

	The problem only happened when the users went home at night.  PSERVER would be down when they came in the next morning.  Also the user had just added an Arcnet segment to the server with one workstation.

SOLUTION

	Novell instructed the user to leave the workstation attached to the server and not to shut it off at night.  After doing this, everything has worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Error Reading Mirror Information - NetWare v2.15c
   DOCUMENT ID#:	FYI.P.4779
           DATE:	27NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	The file server crashed and displayed the following error:

		Ŀ
		Abend: Error reading mirror information on all drives
		

	The problem seemed intermittent.  When the user rebooted the file server, it came up fine.  VREPAIR did not help solve the problem.

ISSUE/PROBLEM

	The user had a faulty disk controller.

SOLUTION

	When the user replaced the disk controller, the file server worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SLANSUP.OBJ Hangs Token-Ring Adapters Loading IPX
   DOCUMENT ID#:	FYI.P.4761
           DATE:	25NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	If a significant amount of broadcast traffic is present on an IBM Token-Ring network, a workstation running IBM LAN Support with SLANSUP.OBJ v2.62 (generated with any version of IPX.OBJ) will hang when IPX.COM loads and tries to initialize the adapter.

ISSUE/PROBLEM

	This symptom takes place most often on workstations that have FAST CPU speeds.  ISA bus and MCA bus machines will reproduce this problem.  All IBM 16/4 or 4 MB adapters are involved.

SOLUTION

	Use LANSUP.COM from ODIUP3.ZIP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Exit to DOS with PSERVER.NLM
   DOCUMENT ID#:	FYI.P.4714
           DATE:	20NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user could not exit to DOS (v3.3) after shutting down the server and typing EXIT on the command line.  The screen and keyboard froze.

ISSUE/PROBLEM

	The user checked for the obvious causes by doing thing such as removing DOS and booting then removing the floppy diskette.

	The user had just installed the PSERVER.NLM (dated 02-11-90) a few days earlier.  After unloading the NLM, the user could exit to DOS.

SOLUTION

	After the user installed the latest version of PSERVER.NLM (v1.22), the symptoms disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Online Transfer of Upgrade Hangs on Macintosh File AUX*
   DOCUMENT ID#:	FYI.P.4737
           DATE:	21NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	An online transfer method of UPGRADE hung during the transfer from a NetWare v2.15 to v3.11 SYS: volume.  MAC.NAM was loaded and Name space for Macintosh files was added to the NetWare v3.11 SYS: volume.

ISSUE/PROBLEM

	A Macintosh file that occurred in several folders named Auxiliary Contacts was being read by the upgrade as AUX.CON.  AUX, being a DOS reserved word, stopped the process and left the file open on the NetWare v3.11 server but closed on the NetWare v2.15 server.

SOLUTION

	After the user renamed all instances of Auxiliary Contacts, the upgrade completed without further problems.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Out of Environment Space" - WordPerfect, Novell Menu
   DOCUMENT ID#:	FYI.P.4709
           DATE:	20NOV91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	A 386/SX workstation received the following error when the user executed WordPerfect from a Novell's MENU:

		Ŀ
		Out of environment space
		
ISSUE/PROBLEM

	The user was executing MENU from the System login script.

SOLUTION

	After the user made the login script exit to a .BAT file that called the MENU, the error did not occur.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Workstations Unable to Recognize Server after ROUTEGEN - Low on Memory
   DOCUMENT ID#:	FYI.P.8974
           DATE:	30SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	After generating a router with ROUTEGEN, the workstations on Ring 3 could not recognize the file server when running NETX.

ISSUE/PROBLEM

	Configuration:

		Three Token-Rings:
		-	Ring 1 had a NetWare v2.2 server and the ring was attached to Ring 2 through an IBM source routing bridge.
		-	Ring 2 was attached to Ring 3 through a Novell dedicated router.
		Router generated as dedicated real mode
		Loading ROUTE.VP0

	The user did not have enough memory to load the ROUTE.VP0.

SOLUTION

	When the user generated the router to run in a dedicated protected mode, everything worked fine.  Making the router run in the protected mode router gave the user access to the necessary memory.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems with CD to Root of F: Drive
   DOCUMENT ID#:	FYI.P.8973
           DATE:	30SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c
     SUPERSEDES:	NA

SYMPTOM

	After logging into the NetWare 2.15c server with DOS 5.0 loaded on the workstation, the F: prompt appeared on screen and the user was unable to CD\ to the F: drive root.  When the user issued a DIR command, it showed the login subdirectory.

ISSUE/PROBLEM

	Configuration:

		IPX 2.15b and NET3
		IPX 3.1 and NETx 3.26

	The user had a generic AUTOEXEC.BAT and CONFIG.SYS files (no memory management).  The system login had mappings to subdirectories like the mapping shown below:

		map ins s1:=sys:public

	The user had some commands in the user login script.  However, the system login script did not have an exit statement; therefore, the default login would not execute.

	The final analysis of the problem is that DOS 5.0, NetWare v2.15c and the NetWare shells together cause this error when the user logs in to the system.

SOLUTION

	The following actions could be used to solve the problem:

		If the user placed the map F:=EYES\SYS:LOGIN command at the beginning of the system login script, then the F:\LOGIN prompt would be returned to the screen after the user logged in to the system and the user could CD\ to the root.

		If the user used the NetWare v3.11 LOGIN.EXE without the mapping mentioned above, then the F:\LOGIN prompt would also return to the screen.

		Also, if the user put an exit at the end of the system login script, the correct prompt would appear for the F:\SYSTEM that the user is set to as the Supervisor and the default login script would be executed.

	All of the above took place under DOS 5.0 and any version of the shell that was used.

		If the user used the SYSTEM and USER login and booted to DOS 3.3, then the F:\LOGIN prompt would show up as it should with both versions of the shells.

	The final resolution was to have the user put the MAP F:=EYES\SYS:LOGIN command at the beginning of the login script.  Novell recommended this action because they were not sure of problems that the user might run in to by using NetWare v3.11 LOGIN.EXE with NetWare v2.15 operating system.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Expanding a Volume After It Is Full
   DOCUMENT ID#:	FYI.P.8955
           DATE:	28SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	If a volume that spans two drives becomes full and is expanded by adding another segment to a new drive, is the data still striped (data spread over multiple disk drives) across the drives?

SOLUTION
	No.  For striping to become effective again, data would have to be backed up, the volume deleted and created from scratch, and data restored.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SECURE.ZIP Loaded to NetWire
   DOCUMENT ID#:	FYI.P.8960
           DATE:	28SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	This document concerns the patch SECURE.ZIP.

	SECUREFX.NLM and SECUREFX.VAP are designed as an enhancement to the existing security features in the NetWare v3.11 and v2.2 Operating Systems respectively.

	SECUREFX.NLM for NetWare v3.11 Operating System

		When a security violation is detected, the following notification messages will be displayed at the file server console, displayed at all attached workstations, and written to the error log:

		Ŀ
		Security breach against station <connection number> NEUTRALIZED.
		

		In addition, the following message will be displayed at the server console and written to the error log:

		Ŀ
		Connection TERMINATED to prevent security compromise
		
		By default, the connection, whose security would have been breached, will be terminated when SECUREFX.NLM detects a security violation. If the user wishes to be notified of an attempted security breach without terminating any user connections, the command line parameter -NK should be used when loading SECUREFX.NLM.  When the -NK option is used, the following notification message will be displayed at the server console, displayed at all attached workstations, and written to the error log:

		Ŀ
		Security breach against station <connection number> DETECTED.
		

		SECUREFX.NLM is intended for all number-of-user versions of the NetWare v3.11 Operating System.  SECUREFX.NLM is a dynamic patch that is loaded at the file server console as a NetWare Loadable Module.  SECUREFX.NLM requires the latest version of PATCHMAN.NLM (v2.23) to load.

		Unlike previous patches, the SERVER.EXE file is never modified by this patch.  SECUREFX.NLM patches the operating system in memory and not on the disk.  This means that SECUREFX.NLM must be loaded each time before any fixes take effect.  To ensure that the patch is always in effect when the server is initially brought up, Novell recommends placing the LOAD SECUREFX command in the server's AUTOEXEC.NCF file.  When the -NK option is desired, place the LOAD SECUREFX -NK command in the AUTOEXEC.NCF.  This NK option must be in upper case.

		Because SECUREFX.NLM is an NLM, it can be loaded and unloaded without bringing down the server.  When SECUREFX.NLM is loaded, the operating system is patched and ready to go.  Unloading SECUREFX will restore the operating system to its original unpatched state.

		Like all NLM-type patches, SECUREFX.NLM requires the Patch Manager (PATCHMAN.NLM) to be loaded before it can be loaded.  If PATCHMAN is not already loaded, SECUREFX will attempt to locate PATCHMAN and load it automatically if found.  PATCHMAN only needs to be loaded once.  All other patches can load after PATCHMAN is loaded.  PATCHMAN cannot be unloaded until all patches that rely on it are first unloaded.  Typing PATCHES at the system command line after PATCHMAN is loaded will display all patches currently loaded on the file server.

		To install SECUREFX.NLM, place the SECUREFX.NLM file in the same directory as the other NLM files (SYS:SYSTEM or DOS partition), and type LOAD SECUREFX (or LOAD SECUREFX -NK).  When the patch has loaded, all changes are in effect until SECUREFX is unloaded.  If an error message appears, contact Novell Technical Support.

		The changes made by this patch will be implemented in all future versions NetWare.  This patch and PATCHMAN.NLM (v2.23) will only operate on NetWare v3.11 operating systems.  Future versions of NetWare will require a version of PATCHMAN specific to that release.

	SECUREFX.VAP for NetWare v2.2 Operating System

		SECUREFX.VAP is intended for all number-of-user versions of dedicated and nondedicated NetWare v2.2 Operating System.

		SECUREFX.VAP functions in a similar manner as SECUREFX.NLM; however, with SECUREFX.VAP, the notification message is only displayed at the file server console and is not broadcast to connected users or written to the error log.

		To install SECUREFX.VAP, place the SECUREFX.VAP in the directory where the other VAP files reside.  Reboot the file server and select y (yes) when prompted to load the VAPS.  By default, SECUREFX.VAP will terminate the connection whose security would have been breached.  To use the -NK option defined above, type the following command at the server console:

			:SECUREFX -NK

		The use of the -NK option only detects a security breach and displays the notification message at the server console.

		To reverse the effects of the -NK option, type the following command at the server console:

			:SECUREFX -YK

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Restrict Rights to Users in Directory
   DOCUMENT ID#:	FYI.P.8943
           DATE:	25SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA

SYMPTOM

	The user had granted the group, Everyone, rights using a trustee directory assignment (TDA) at the root directory.  Then, the user tried to revoke those rights by using a TDA with no rights at a subdirectory.

ISSUE/PROBLEM

	The problem was that the TDA in the subdirectory was granted to a group other than Everyone.  A "logical or" is done on trustee directory assignments for different objects, so a TDA for one object cannot restrict a TDA for another object at a higher level.

SOLUTION

	The answer for this user was to restrict the rights by creating a TDA with no rights for the group Everyone in the subdirectory.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Users Break Out of Login Script with No Break on Statement
   DOCUMENT ID#:	FYI.P.8940
           DATE:	25SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	BREAK OFF in login script did not inhibit <Ctrl><Break>
ISSUE/PROBLEM

	When running LOGIN.EXE (06-04-91), the users could break out of the login scripts even though no BREAK ON statement was in the login script (and it was explicitly OFF).

SOLUTION

	When the user downloaded LOG365.ZIP from NetWire, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	What Is SQE?
   DOCUMENT ID#:	FYI.P.8893
           DATE:	24SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All Versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What is SQE?

SOLUTION

	SQE stands for Signal Quality Error.  It is also called the Transceiver/Adapter Heartbeat.  It is the result of a test performed after every transmission by an IEEE 802.3 or Ethernet II transceiver.  The test checks the collision detection circuitry in the transceiver.

	If SQE is enabled on an Ethernet adapter (usually a hardware jumper or switch on the network board), the adapter will try to verify that its transceiver is operating correctly.

	Just after a packet has been shipped from the Ethernet Adapter, the card (with SQE enabled) will attempt to simulate a collision just to see if its transceiver will report it.  If it does, everything is fine.  If the transceiver does not report it, the Ethernet adapter assumes that the transceiver is unstable and reports that the "Signal Quality" of its transceiver is questionable.

	Only one (Ethernet) node can reliably transmit at a time on a segment.  As a node is transmitting, the voltage of the segment rises to a known level that signals all other nodes that the segment is in use.  No other nodes on the segment should attempt to transmit while in this condition.

	A collision occurs when two nodes begin transmitting at the same time.  This condition raises the voltage of the cable above the normal transmission level.  All nodes on the segment can sense this condition and generate a Collision Detect (CD) to inform software to stop transmitting.  This information is most important, of course, to the transmitting nodes.

	If the transceiver failed to detect or report a collision condition, it could cause many problems.  IEEE decided to make a way to ensure that the transceiver is behaving.

	Ethernet II transceivers send a Signal Quality Error (SQE) burst through the collision detection pair and back to the controller card to verify that the collision detection circuitry is functioning.  This test is performed after each packet is sent.  Ethernet I does not perform this test.  Most controller cards must be jumpered to indicate the expected burst.

	Some fan-out units (Multiport transceivers) do not distinguish which port should receive the SQE burst; therefore, they produce erroneous SQE bursts as collisions.

	Repeaters should only be connected to the network through transceivers that have SQE disabled.

	Disabling SQE simply tells the Ethernet adapter not to test its transceiver.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	No Servers Showing Up in RCONSOLE
   DOCUMENT ID#:	FYI.P.8916
           DATE:	22SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	No servers listed in RCONSOLE.

ISSUE/PROBLEM

	Configuration:

		Doing source routing (Token-Ring)
		Using ODI

	On some workstations, no servers would show up on the list in RCONSOLE.

SOLUTION

	When the user took out the TRO=2 parameter of the ROUTE.COM load line, all servers appeared.  The TRO= parameter determines how many times (number of IPX timeouts that will occur) IPX will search the local ring for the destination server before sending out a source routed packet that will cross IBM bridges.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Utilization Jumps when Sending Job to Print Server - ARCSERVE.NLM
   DOCUMENT ID#:	FYI.P.8929
           DATE:	22SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Utilization jumps up to 90 percent when a job is sent to the print server.

ISSUE/PROBLEM

	Configuration:

		NetWare v3.11 server using the PSERVER.NLM.
		Loading ARCSERVE.NLM v4.0

	Whenever a job is printed, the server utilization jumps to 90 percent.

SOLUTION

	When the user removes the ARCSERVE.NLM, the problem does not occur.  Cheyenne Software Inc. gave the user a file called CHEYENNE.NLM that fixes this problem.

	Cheyenne's technical support explained that while trying to fix a different problem with their ARCSERVE.NLM, they introduced this high utilization issue; so they created this NLM to fix it.  The utilization issue only occurs with ARCSERVE.NLM v4.0.  This patch is not necessary and should not be used with older versions of the ARCSERVE.NLM (v3.0b or earlier).  The NLM is available on Cheyenne's BBS (516-484-3445) in the file name CHEYENNE.ZIP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: Disk Controller Timeout Called ... - ELS NetWare
   DOCUMENT ID#:	FYI.P.8918
           DATE:	22SEP92
        PRODUCT:	NetWare ELS II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	"Abend:  Disk controller timeout called from non-disk process."

ISSUE/PROBLEM

	When the user shut down the server and tried to reboot, the system displayed the following message:

		Ŀ
		Abend:  Disk controller timeout called from non-disk process.
		

	The user tried booting from a floppy diskette, running VREPAIR, replacing the motherboard, and regenerating and replacing the operating system; however, nothing seemed to help.

SOLUTION

	Finally, when the user replaced the IDE drive, the error messages no longer occurred.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Using Two LAN Boards in Workstation Using ODI Drivers
   DOCUMENT ID#:	FYI.P.8921
           DATE:	22SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Can you use two LAN boards in a workstation using ODI drivers?

SOLUTION

	Currently, the IPX protocol (IPXODI.COM) will only bind to one board.  The following shows the contents of the AUTOEXEC.BAT and NET.CFG:

	AUTOEXEC.BAT

	 HILOAD C:\WINDOWS\mouse.COM /Y
	 PATH C:\WINDOWS;C:\DRDOS;C:\TC\BIN;C:\TTASM;C:\TD;C:\TPROF
	 SHARE /L:80
	 PROMPT $P$G
	 SET TEMP=C:\TEMP
	 IF NOT "%TEMP%"=="" MD %TEMP% >NUL
	 set dfpath=.;prv-srs/sys:srsprog;prv-srs/sys:srsdata/current
	 HILOAD boot\lsl
	 HILOAD boot\ne2000
	 HILOAD boot\token
	 HILOAD boot\ipxodi
	 HILOAD boot\netx
	 HILOAD boot\tcpip
	 HILOAD boot\telapi
	 MEMMAX -U >NUL

	NET.CFG

	 file handles = 125
	 cache buffers = 10

	 Link Support
	        Buffers 8 1500
	        MemPool 4096
	         Max Stacks 8

	 Link Driver TOKEN
	      MEM #2 D8000
	      MAX FRAME SIZE 4096
	      frame token-ring
	      protocol ipx E0 token-ring

	 Link Driver NE2000
	       INT  3
	       PORT 300
	       Frame Ethernet_II
	       Protocol TCPIP 8137 Ethernet_II

	 Protocol TCPIP
	        ip_address      137.65.44.56
	        ip_router       137.65.44.254
	        ip_netmask      255.255.255.0
	        tcp_sockets     8
	        udp_sockets     8
	        raw_sockets     1
	        nb_sessions     4
	        nb_commands     8
	        nb_adapter      0
	        nb_domain       Provo.NPD.Novell.Com




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"No Default Queue Can be Found on Server ..." - NetWare Tools
   DOCUMENT ID#:	FYI.P.8853
           DATE:	19SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user used NetWare Tools for OS/2 v2.0 to make all the server connections and drive mappings.  Then, when the user executed OS2 CAPTURE, the system displayed the following message:

		Ŀ
		No default queue name can be found on server<servername>
		

	Then, when the user executed CAPTURE S=xxx J=xxx, the system displayed the following message:

		Ŀ
		<name> is not a valid PrintCon job definition
		

	When the user ran PRINTCON, the system displayed the following error:

		Ŀ
		You have lost your primary file server connection.
		The new primary file server is now <server name>. 
		

	After running PRINTCON and receiving the error, CAPTURE executed fine.

ISSUE/PROBLEM

	The NetWare Tools for OS/2 program does not make any particular server the primary server.

SOLUTION

	Using LOGIN to make the server attachments will allow CAPTURE and PRINTCON function without the errors.




                               FYI
(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Using DCBs with ELS NetWare
   DOCUMENT ID#:	FYI.P.8859
           DATE:	18SEP92
        PRODUCT:	NetWare ELS
PRODUCT VERSION:	v2.1x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Can you use a DCB with ELS?

SOLUTION

	ELS comes with disk drivers already linked in to the system.  The assumption when 2.x ELS came out was that most systems would only have one controller, so they only linked in drivers for channel 0.  The operating system would automatically determine whether to use the ISA, ESDI, or MFM driver.  The issue with DCBs is that they can only run on channel 1, 2, 3, and 4.  There is no Channel 0 DCB(Novell).  Because ELS does not have any drivers prelinked on channel 1, it will not work.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Load NUT.NLM" - NetWare v3.10
   DOCUMENT ID#:	FYI.P.8805
           DATE:	17SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.10
     SUPERSEDES:	NA

SYMPTOM

	When loading the new PSERVER.NLM (v1.22) on the file server, the system displayed the following errors:
		Ŀ
		Unable to load NUT.NLM
		

		Ŀ
		PSERVER is unable to find NUT.NLM
		

ISSUE/PROBLEM

	The user was loading PSERVER.NLM v1.22 on a NetWare v3.10 server.  PSERVER.NLM v1.22 is a NetWare 3.11 version of PSERVER.NLM that requires access to NUT.NLM that is also a 3.11 version NLM.

SOLUTION

	Use a version of PSERVER.NLM made for NetWare v3.10 such as v1.20.  NUT.NLM is a NetWare v3.11 NLM, and there is not a NUT.NLM v3.10.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Login File Becoming Corrupt - NetWare v2.2
   DOCUMENT ID#:	FYI.P.8817
           DATE:	16SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	The login file was corrupt and was not allowing a user to log in to the network in spite of its ability to attach to the server and recognize its name.  Login claimed the server name did not exist.  After the user successfully logged in from diskette and restored the login file from the original, the file became corrupt again.

ISSUE/PROBLEM

	The NE2000 driver had been in use on the 200E adapter.

SOLUTION

	When the user replaced the server clone NE2000 16-bit Ethernet adapter (Advanced LAN Products 200E, Revision B) with an Anthem/Eagle NE2000 adapter, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Allocation Failure - PSERVER.NLM 1.21
   DOCUMENT ID#:	FYI.P.8828
           DATE:	15SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Allocation Failure"

ISSUE/PROBLEM

	When a Q&A print job was sent to an HP LaserJet III that was attached to the parallel port on the file server (using PSERVER.NLM v1.21), the following error message was displayed on the server console:

		Ŀ
		Allocation Failure
		

SOLUTION

	When the user upgraded to PSERVER.NLM v1.22, the error did not occur and printing worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NLMs Shipped with NFS Package
   DOCUMENT ID#:	FYI.P.8766
           DATE:	09SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The NFS NLMs that come with the NFS package are patched or updated by the following ZIP files: NFS113.ZIP and NFS114.ZIP on NetWire.

		INETD.NLM        NetWare 386 INETD V1.2 (911112)
		XCONSOLE.NLM     XCONSOLE V1.2 (911112)
		LPR_PSRV.NLM     NetWare LPR Print Server V1.2 (911122)
		PLPD.NLM         Unix->NetWare LPR Print Server V1.2 (911112)
		FILTER.NLM       Print Filters V1.2 (911112)
		FLTRLIB.NLM      Print Filter Library V1.2 (911112)
		RPCBSTUB.NLM     NetWare 386 RPCBind Shared Stub V1.2 (911112)

	Updating Network File System (NFS) with NFS113.ZIP and NFS114.ZIP found on NetWire will update all NFS products.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Losing Connections, Connection Errors - IBM Token-Ring
   DOCUMENT ID#:	FYI.P.8774
           DATE:	09SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Workstations kept losing connections.

ISSUE/PROBLEM

	Along with using older drivers and source routing modules, the user also noticed congestion errors.

SOLUTION

	To eliminate the symptoms, the user upgraded software using TOKENB.ZIP, fixed faulty cabling, and added another ring.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	AIOWriteData Documentation Problems - Network C for NLMs
   DOCUMENT ID#:	FYI.P.8763
           DATE:	08SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Using Network C for NLMs software developer's kit

	The documentation for AIOWriteData() mentions that the function does not succeed unless the entire requested data length can be copied to the transmit buffer all at once.

SOLUTION

	This requirement is a mistake in the documentation.  AIOWriteData() will allow partial writes.  In these cases, the unsent characters just have to be resent.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Determining Files That Have No Owner
   DOCUMENT ID#:	FYI.P.8755
           DATE:	04SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Files with no owners

ISSUE/PROBLEM

	Is there a utility that will tell a user if their system has any files without an owner?

SOLUTION

	Use NDIR.  From the volume root, use the following syntax:

		NDIR /SUB /OW LE *




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Read the Session Header ..." - SBACKUP
   DOCUMENT ID#:	FYI.P.8753
           DATE:	04SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was using SBACKUP (from SBACK.ZIP) to do a backup and was testing the restore.  The system did not receive any errors when the user was doing the backup.  However, RESTORE displayed the following error:

		Ŀ
		Unable to read the session header from the media error 0x31
		

ISSUE/PROBLEM

	Errors similar to the one above may be caused by not formatting a DATAdat tape.  The user said he had a DATAdat tape type and the problem was bad termination on a hard drive.

SOLUTION

	Some tapes need to be formatted before backing up.  It depends on the tape manufacture.  Generally, the tapes that are DDSdat do the formatting as it is backing up the data.  Tapes that are DATAdat need to be formatted first before backing up data.  Formatting can be done by a hardware switch on the tape drive or it can be a software utility.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Get Hotkey to Work - NETWARE.DRV
   DOCUMENT ID#:	FYI.P.8761
           DATE:	04SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user had the correct syntax in NETWARE.INI file and had a good driver (dated 03-10-92); however, the hotkey would not pop up when the user  pressed <F6>.

SOLUTION

	The user was loading a number of applications in the Startup group, including DaVinci Email v1.8.  After unloading DaVinci, the hotkey worked and the user was able to access NetWare dialogue boxes.

	Note:  Novell was unable to reproduce this problem.  DaVinci v1.8 worked fine with the Hotkey in the Novell Labs.  Novell suspects that the problem was the combination of DaVinci and some other application the user had loaded that caused the system not to perform as expected.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Novell MENU Options Not Appearing with Harvard Graphics
   DOCUMENT ID#:	FYI.P.8734
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Configuration:

		Running Harvard Graphics v3.0 with Novell's MENU v2.31

	Whenever the user exits out of Harvard, the system gets the background portion of the menu, but the option's portal does not show up.  Pressing <Esc> will not let the user out, so the user has to press <Ctrl-C> to get out.  If the user goes back into menu at this point, it appears to be fine.  It only happens with Harvard.  It appears to have something to do with the graphics mode that Harvard jumps into when going into a presentation.  If you only bring up the first screen and then exit, there is no problem.  You have to go into a presentation.

SOLUTION

	The user tried putting a MODE CO80 command in the MENU script just after the "Harvard Graphics" command.  This is a DOS command to put the display back into a COLOR 80 Column mode.  It did help some (was not happening every time) but still happens occasionally.

	Some programs leave the display in two-color graphics mode.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printing Out of Wrong Port
   DOCUMENT ID#:	FYI.P.8733
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user sent a job to one printer attached to LPT1, it printed on the printer attached to COM1.  Everything was set up correctly in PCONSOLE.

ISSUE/PROBLEM

	The user remembered someone may have had the printers defined differently and that he had recently changed the definitions in PCONSOLE.  The changes had not taken effect because no one had unloaded PSERVER and reloaded it to make the changes take effect properly.

SOLUTION

	When the user unloaded PSERVER and reloaded it, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Time Taken to Clear Connection - NetWare Time Restrictions
   DOCUMENT ID#:	FYI.P.8731
           DATE:	03SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	A user wanted to know how long it would take for a connection to be cleared once the time restriction took effect.

SOLUTION

	It takes approximately 7 minutes.

	Example:

		If you are allowed to be logged in until 4:00, a message is sent out at 4:01 stating that the connection time has expired and a warning to log out is given.  At 4:06 a message is sent that the connection will be cleared in one minute.  At 4:07 the connection is cleared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"AddTrusteeToDirectory Return Error 252" - SYSCON
   DOCUMENT ID#:	FYI.P.9035
           DATE:	02OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user ran SYSCON, the system displayed the following error:

		Ŀ
		AddTrusteeToDirectory return error 252.  System unable to add
		trustee id 1000000 to the specified directory.               
		

	The error appeared when the user started SYSCON; however, when the user pressed <Esc>, all the SYSCON functions appeared to work correctly.

ISSUE/PROBLEM

	The bindery was corrupt.

SOLUTION

	After the user recreated the bindery, the error ceased.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	TRSTFIX.NLM Dated 05-15-92 Will Not Load
   DOCUMENT ID#:	FYI.P.9034
           DATE:	02OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user loading TRSTFIX.NLM dated 05-15-92 from 311PT8.ZIP, the system returned the following message:

		Ŀ
		Error: unexpected code encountered in area to be patched.
		Module initialization failed.                            
		

ISSUE/PROBLEM

	The user tried loading this NLM in different places, such as after other NLMs, but it still received the same message.  The error occurred on the 250-user version and below.

SOLUTION

	Using TRSTFIX.NLM dated 10-02-92 from 311PT9.ZIP fixed the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	USERDEF Errors in NNS Domain
   DOCUMENT ID#:	FYI.P.9021
           DATE:	02OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user used USERDEF to create several users at a time on the network.  When the user ran USERDEF, the system displayed the following errors:

	Ŀ
	Executing user make file on server xxx in domain xxx.             
	user TSTEMP created                                               
	Could not create password on server xxx for user xxx in domain xxx
	Error copying file \\server\sys\udflogin.src to                   
	\\server\sys\mail\xxxxxxxx\login                                  
	

	The occurrence of the errors seemed to be getting worse and over a period of about two months.  Then, the system started displaying errors when the user copied the profile scripts.

ISSUE/PROBLEM

	Configuration:
		Five server domain
		Three- to four-hundred users defined

	USERDEF creates a script that spawns MAKEUSER and hands MAKEUSER the script that is then used to create the users.  With NetWare Naming Service (NNS) one piece is added to this configuration.  NNS requires the RSA-encryption that allows encrypted passwords to be unencrypted and synchronized to servers coming into a domain.  This piece takes up an additional 50 to 70 KB of workstation memory.

	After some extensive testing, Novell found that if the workstation had around 550 to 560 KB when running USERDEF, the errors did not occur.  As the binderies continue to group for this user, the problem will begin to reoccur.

SOLUTION

	Create some standard scripts for MAKEUSER, and then use MAKEUSER to create the users.  This takes USERDEF.EXE out of the picture and frees up a chunk of memory.

	Run USERDEF.  When it prompts you to verify the Supervisors password for the domain, instead of giving the password do the following:

	1.	Go to another workstation.
	2.	In the directory where USERDEF is run, locate a script file called UDFSCRIPT.USR.  This script is created by the USERDEF template that is passed to MAKEUSER.
	3.	Flag the file "Normal," and copy it to a different file name.
	4.	Then exit USERDEF on the other workstation.

	At this point, you will be able to run MAKEUSER and select the user file that was created by USERDEF.  Now you have a MAKEUSER script to create users that is identical to the template used in USERDEF to create users.  A few lines will need to be modified in the script that is created; otherwise, it will work fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NE1000 and NE2000 Shell Drivers Are Not Jumpers Configurable
   DOCUMENT ID#:	FYI.P.9026
           DATE:	02OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	All Versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Are there any NE1000 and NE2000 shell drivers that are jumpers configurable?

SOLUTION

	No.  You must use ODI shells if you want to use interrupt line and I/O settings that are not available with the dedicated IPX drivers.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Router Node xxxxx claims XX Should be XX"
   DOCUMENT ID#:	FYI.P.9028
           DATE:	02OCT92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user's system displayed the following message:

		Ŀ
		Router Node xxxxx claims XX should be XX
		

ISSUE/PROBLEM

	The user had 5 LAN cards in a NetWare v3.11 server on a backbone to the NetWare v2.15 server on LAN address 1.  The user also had a LAN card addressed at LAN 5 in the NetWare v2.15 server, so Novell thought somehow LAN 5 was cabled to LAN 6; however, after checking the configuration, everything looked fine.  After the user unplugged the LAN 5 in the NetWare v2.15 server, the errors continued to report.  When using TRACK ON, the user saw a packet named NEW_NACS coming in on LAN 6.

SOLUTION

	After the user changed the NetWare Asynchronous Communications Server (NACS) to the correct address (in this case LAN 6), everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Error 0X1, Error Reading from Media" - SBACKUP
   DOCUMENT ID#:	FYI.P.8831
           DATE:	15SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.x
     SUPERSEDES:	NA

SYMPTOM

	The system displayed the following error when the user tried to do a backup for the first time with SBACKUP on a Mountain 2 GB tape backup unit.

		Ŀ
		Error 0x1, error reading from media.  One sector requested one
		sector not read, possibly eorm device sense 0000f008.         
		

	The user also tried using the TAPEDAI.DSK with the Adaptec controller and using the DIBIDAI.NLM, however, using this driver resulted in the same error.

ISSUE/PROBLEM

	Configuration:

		Dell 450S server box
		Tape unit connected to an Adaptec 1740 card
		Loading AHA1740.DSK and ASPITRAN
		Using NOVADIBI.NLM

	If no backup sessions are on the tape, SBACKUP takes you back to change the append option to NO before you start the backup.  If the driver does not support appending, the option does not show up in the menu.  In some cases, if the device has problem searching for the end of the first session, it would error out.  So, in this case, if there was no session file on the tape, the problem was that software had problem searching the tape for the session files.  This means that the user has a bad tape, device, or some kind of hardware problem, and they will experience problems in the future when they restore data.

SOLUTION

	When the backup options appeared on the SBACKUP screen, there was an option to append this session.  This option only appears if the tape unit is able to append another backup to the same cartridge.  The default to this parameter is set to YES.

	When the user changed the default parameter from the default of YES to NO, the backup continued as normal without the above error.

	For a safe backup, download SBACK.ZIP from NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Using Node Addresses to Specify Workstations in Token-Ring
   DOCUMENT ID#:	FYI.P.8752
           DATE:	04SEP92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Configuration:

		Using remote boot on Token-Ring LAN boards VAP from RPLB.ZIP

	The user wanted to use the BOOTCONF.SYS remote-boot file to specify by node address only the workstations on the Token-Ring LAN segment.  When the user tried using the first four digits of their node address that were the same and an *, it would not work.

	Example:  0x3,1000*

SOLUTION

	When the user tried a ? for each digit, it worked.

		Example:  0x3,1000????????




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abends on Floating Point Divisions - Network C
   DOCUMENT ID#:	FYI.P.8692
           DATE:	31AUG92
        PRODUCT:	NetWare C for NLMs
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	Abend message sent on floating point divisions when /fpc switch is used.

ISSUE/PROBLEM

	If /fpc switch is used, the system sends an abend message.

SOLUTION

	This is just a reminder that when building NLMs, do not use the /fpc switch.  This was intended for "linking in the emulation code" with the application.  The emulation code for the NLM SDKs is in CLIB.MESSAGES.

	Novell has only seen division abends; however, others may exist as well.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SPX API May Trash Memory - NetWare C Interface for DOS
   DOCUMENT ID#:	FYI.P.8689
           DATE:	31AUG92
        PRODUCT:	NetWare C Interface for DOS
PRODUCT VERSION:	v1.2
     SUPERSEDES:	NA

SYMPTOM

	SPX APIs may trash memory

ISSUE/PROBLEM

	A problem observed using the MSC compiler, versions 5.1 and up, seems to cause some problems for SPX APIs in the Small and Medium models due to assumptions for the ES register.

	The C Interface for DOS SPX APIs makes an assumption that the ES register will be the same as the DS register.  The following scenario forces this condition to be false and thus possibly causing memory overwrites and system crashes.   Example:

	 SPXEstablishConnection(..) is used
	
	 int _far *dummy = NULL;/* set pointer to NULL (0:0) */
	 int ivar;
	 :
	 :
	 ivar =*dummy;  /* forces ES:SI to the pointer value */
	 SPX<function name>     /* call any SPX function using ECB's */

	The SPX function saves and restores the ES register; however, is also used just before returning from the call.  ES is assumed to point to DS (after is was restored).   However, the assignment of "*dummy" to "ivar" forces ES:SI to be the "dummy" pointer.  This will essentially be writing into 000:000 (with the above example).

	This may cause very strange problems with behavior of applications when FAR addressing capabilities are used just before calling SPX functions.

SOLUTION

	Just before calling SPX functions, set ES = DS in the Small and Medium model or modify the C Interface for DOS source to "pop es" following its manipulation.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Unable to Recognize Login Name within NetWare Management Map
   DOCUMENT ID#:	FYI.P.8683
           DATE:	28AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When doing a report within the NetWare Management Map, the system cannot recognize the login name.

ISSUE/PROBLEM

	The user had the faulty version from NetWare Premium.

SOLUTION

	There are two versions of this product.  An incomplete version of the NetWare Management Map ships with NetWare Premium.  This is simply not the complete product.  The complete product is called NetWare Services Manager, NSM.  This product has much more functionality and it includes an NLM called RATTLER.NLM.  This NLM is what allows the user names to show up instead of the network address.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SBACKUP Documentation Error
   DOCUMENT ID#:	FYI.P.8807
           DATE:	17AUG92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was having problems getting the following files from SBACK.ZIP to work with the HP35480A DAT backup system:

		TAPEDAI.DSK
		AHA1540.DSK
		ASPITRAN.NLM
		DIBIDAI.NLM

	Whenever the DIBIDAI.NLM option was selected from the DIBI2$DV.DAT file, the following error messages appeared when using SBACKUP.NLM dated 03-5-92:

		Ŀ
		No device found, dibi device drives did not respond
		

ISSUE/PROBLEM

	The user tried the following but nothing worked even though the documentation says that it is supported this way:

		Recopied the SBACKUP files into the system subdirectory and made sure that a DIBI and TSA directory was present.
		Recreated the DIBI2$DV.DAT file with just the DIBIDAI.NLM option.
		Removed the .NLM extension in the DIBI2$DV.DAT file.

	Novell discovered that the HP35480A is not hard coded into the TAPEDAI.DSK file (31576 bytes dated 05-11-92).  Therefore, the documentation is wrong and this device is not supported with these drivers.

SOLUTION

	HP35480A will be available in the next release of the TAPEDAI.DSK.  In the mean time, a workaround is to use the following drivers instead:

		AHA1540.DSK
		ASPITRAN.NLM
		NOVADIBI.NLM




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Printserver <name> Is Unknown at This Time" - RPRINTER.EXE
   DOCUMENT ID#:	FYI.P.7899
           DATE:	13JUN92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Executing the RPRINTER command failed and returned the following error message:

		Ŀ
		Printserver <printserver name> is unknown at this time.
		

	PSERVER (VAP, NLM, or EXE) was loaded and running, and other remote printers were still connected and functioning properly.

ISSUE/PROBLEM

	The message above indicates:

	1.	The print server is not loaded, or

	2.	The PSERVER has stopped sending SAPs.  This can be verified by typing TRACK ON at the console to check if the print server is broadcasting.  Also, you can go into PCONSOLE and look under "Print Server Information" to check if the STATUS/CONTROL option is present.  If the option is not there, then the workstation is not recognizing the print server.

		When the print server stops sending SAPs, the above error will occur when a remote printer is unloaded and then a reload is attempted because the remote printer will not be able to recognize the print server.

SOLUTION

	Temporary Fix

		If running PSERVER.VAP, issue a PSERVER STOP and then a PSERVER START to reset the print server and allow it to start sending SAPs again.  If this does not work, try shutting down the server and bringing it back up (to reload the VAP).

		If running PSERVER.NLM, unload and reload the NLM.

	Permanent Fix

		The LAN card or its driver is the real problem.   Get a newer driver or replace the network board.  Some LAN cards or drivers have been known to cause the print server to stop sending SAPS.  Novell has seen this problem with the following boards or drivers:

			Kodiak
			Western Digital - WD8003
			Some 3Com boards
			David Systems

		Ensure that you are using the latest driver for the particular LAN card before deciding you have a hardware problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Tecmar Tape Backup Receives GPPE Backing Up v2.15c Server
   DOCUMENT ID#:	FYI.P.7874
           DATE:	12JUN92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c, v3.11
     SUPERSEDES:	NA

SYMPTOM

	General Protection Process Exception (GPPE)

ISSUE/PROBLEM

	The user had an Arcserve v4.00 on NetWare v3.11 server backing up NetWare v2.15c server.  The user could successfully back up the NetWare v3.11 server running a Tecmar tape from an Adaptec 1542 controller on the file server with Token-Ring 16/4 cards.  However, the system received a GPPE abend when the user attempted to backup the NetWare v2.15c server to the tape across a router.

SOLUTION

	Cheyenne Software Inc. is aware of the problem.  The fix is in Patchfile area/general utilities/286PATCH.ZIP on their BBS (516 484 3445).  Modem settings are 2400-9600 baud, xmodem or ymodem, 8-bit data, no parity, 1-stop bit.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Default Login Script Not Executing for Supervisor
   DOCUMENT ID#:	FYI.P.7725
           DATE:	05JUN92
        PRODUCT:	ELS NetWare Level II
PRODUCT VERSION:	v2.15
     SUPERSEDES:	NA

SYMPTOM

	Default login script was not executing for Supervisor, so after logging in the Supervisor was dropped at the LOGIN directory with no mappings.

ISSUE/PROBLEM

	SYSCON did not show a system or user login script.

SOLUTION

	The user discovered a LOGIN and LOGIN.BAK in the Supervisor MAIL directory.  After deleting both files, everything was fine.

	If the user does not have a login script, when the user tries to look at the login script, the system will return the following message: "login script does not exist."   In this case, a space or a return must have been in the user's login script.

	In NetWare v2.2 and v3.11, if a user's login script has a space or return as the only command, the default login script will still execute.  The NetWare v2.2 and v3.11 user-login scripts must have a nonspace character in them to execute it without the default login script.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Compaq DOS Locks with 3.22 Shell
   DOCUMENT ID#:	FYI.P.7698
           DATE:	01JUN92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	When booting a Compaq 386 machine using 3.22 shell or older, the machine returned the following error:

		Ŀ
		File server could not be found 
		

ISSUE/PROBLEM

	The 3.26 shell attached just fine.  The user also had an IBM AT that worked with any version of NETX.

	The only difference in the setup of the two machines was the kind of DOS they were using. (Compaq DOS 3.3 or 5.0 on the Compaq, IBM DOS 3.3 in the IBM)

SOLUTION

	After changing the DOS in the Compaq to IBM DOS 3.3, the user could use any version of NETX with no problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	BACKUP.VAP Only Works on Wangtek PC-36 Controller
   DOCUMENT ID#:	FYI.P.8209
           DATE:	16JUL92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	What will the BACKUP.VAP work on?

SOLUTION

	BACKUP.VAP only works on a Wangtek PC-36 controller.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Determining Invisible File Problems
   DOCUMENT ID#:	FYI.P.8201
           DATE:	15JUL92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x, v3.x
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The following is a straight forward procedure for determining the problem when someone calls with invisible file problems:

	1.	Always use NDIR so you know it is not a file flag problem.

	2.	You cannot revoke rights by GRANTING a trustee assignment; you can only ADD rights.  So, GRANT the INDIVIDUAL all rights to a given directory as Supervisor just for this test.

	3.	If the user still cannot see the file, then it is definitely a RIGHTS MASK problem (either the IRM as in 386 NetWare or the Maximum Rights Mask in 286 NetWare).  If the user can see the file at this point, it still does not tell you anything because a file trustee takes precedence over a file IRM. (This makes sense because they do not need to inherit any rights from a parent because they have been granted a trustee right specifically.)

	4.	Individual files have an IRM in 386 NetWare.  So check in FILER, both the DIRECTORY IRM and the FILE IRM (or the directory MRM in 286).  In 386 NetWare, the IRM should be FULL for all files and directories except the ROOT directory that should be empty, except possibly S.  (This makes sense because where else are you going to inherit rights from in the ROOT?).

	5.	If all the previous steps fail, it is a hardware problem.  It should work if you get all that sorted out.

	Note:  Many types of tape backup software clear file IRMs (some, even directory IRMs) when backing up from a 286 server and restoring to a 386 server.  So, this problem is usually prevalent during an upgrade.  Warn users in advance that if they are using their tape drive to move their data during an upgrade, they should turn OFF the NetWare aware aspects of their tape drive software.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Postscript Jobs Not Printing Completely - Kodak Ektaplus
   DOCUMENT ID#:	FYI.P.7469
           DATE:	11MAY92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.15c, v3.x
     SUPERSEDES:	NA

SYMPTOM

	The user was using a Kodak 7016 Ektaplus printer that supports postscript printing and was having problems getting a complete job to print.

ISSUE/PROBLEM

	The EOT control character (signifying the end of the job) was not getting to the printer correctly.

SOLUTION

	In many cases where large postscript print jobs would not print or smaller jobs would hang, using ti=0 solves the problem.  In this case, it helped but did not resolve all the issues.  The v3.26 shell from DOSUP5.ZIP (available on NetWire or NetWare Express) was used, and that solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Data Set Not Found Error Using SBACKUP
   DOCUMENT ID#:	FYI.P.7382
           DATE:	05MAY92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Data set not found"

ISSUE/PROBLEM

	The user could not backup his data using SBACKUP.  The system displayed the following error message when running SBACKUP:

		Ŀ
		Data set not found
		

SOLUTION
	Using the new SBACKUP in SBACK.ZIP solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Notes on Dual Requesting with OS/2
   DOCUMENT ID#:	FYI.P.7358
           DATE:	01MAY92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3 and v1.2
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Notes for Dual Requesters with OS/2

		CMGRLAN.SYS and LANSUP.SYS rely on NDIS drivers to control the network board.

		ODINSUP.SYS uses ODI drivers to control the network board.  ODI drivers used with ODINSUP require the v1.2 of the Media Support Module when they are developed.

		With the release of the v2.0 OS/2 Requester, LANSUP replaces the use of CMGRLAN.  They install in the same manner.  The only difference is that LANSUP only supports two of the four commonly used Ethernet-frame types.  This is due to a change in the LANDD.OS2 driver.  ETHERNET_802.3 and ETHERNET_II frames are no longer supported.  LANSUP is billed as the solution for the NDIS user who wants occasional connectivity to NetWare.  The use of LANSUP also requires that the node address with least or most significant bit designation be specified in the NET.CFG file.  Refer to the LANSUP handout for details.

	Compatibility

		ODINSUP works on everything including v1.3 SE @ CSD-XRO 5050.

		LANSUP works on everything except v1.3 SE.
		CMGRLAN only works on v1.3 EE @ CSD-WRO 5015 or above.

		(SE=Standard Edition,  CSD=Corrective Services Diskette,  EE=Extended Edition)

	The following are errors are display when something is done incorrectly in NET.CFG when installing ODINSUP on v1.3:

		If you insert STACK in the PROTOCOL ODINSUP option, the following error is displayed:
		Ŀ
		PRO0025: Failed to bind OS2EE$ to X3C503
		

		If the LINK SUPPORT option is before the PROTOCOL ODINSUP option, the following error is displayed:

		Ŀ
		MLI0213: Unable to find Named Adapter
		

		Novell recommends that the PROTOCOL ODINSUP option always be placed at the top of the NET.CFG file.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	CNE Assessment Test Problems on PS/2 Model 60
   DOCUMENT ID#:	FYI.P.5284
           DATE:	21JAN92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	CNE assessment tests not working on PS/2 model 60 machines

ISSUE/PROBLEM

	The Novell Germany office reported a problem with the CNE assessment tests that were available from NetWire.  The test worked fine on most machines except Model 60 machines.

SOLUTION

	The Novell Education department suggested using the newest assessment tests that have some built in fixes of known problems.  They are now on NetWire and work fine on a Model 60 machines.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Registering File Size while Open
   DOCUMENT ID#:	FYI.P.5230
           DATE:	16JAN92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	NetWare will not update a file's size after each write to a file.  The file size will be updated after the file is closed.

SOLUTION

	Use the following function to instruct NetWare to update the file size while the file is in an open mode:

		Call the DosCommit function (16 h) and pass it the file handle in the BX register.

	This will update the file size.  This procedure will only work when using NetWare v3.11 and the v3.22 shell (NETX).




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Loading PSERVER.EXE or PSERVER.NLM Causes Workstation to Hang
   DOCUMENT ID#:	FYI.P.5456
           DATE:	05FEB92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Loading PSERVER.EXE or PSERVER.NLM causes all workstations to hang.

ISSUE/PROBLEM

	The user had an SMC PC-210 card in the file server and workstations.

SOLUTION

	After the user did the following, everything worked fine:

	1.	Changed to a PureData pdi516 NIC.

	2.	Changed to a third-party driver.

	3.	Updated PSERVER.EXE to the new one in PSERV1.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Slow Printing through Network - UNIX Generated Print Jobs
   DOCUMENT ID#:	FYI.P.10713
           DATE:	04DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	A "proprietary application" running at the work station, gathers information from a UNIX machine and generates a file at the workstation.  The file is then redirected to a NetWare queue and printed.   When this file is printed through the network using NPRINT or CAPUTRE, it prints slowly.  If the report is printed directly to a printer attached to the workstation, then printing is speedy.

ISSUE/PROBLEM

	3Com's definition of MAXTRANSMITS sets the number of entries for outgoing frames in the transmit queue of the driver.  Each queue entry adds 138 bytes to the memory used by the driver.  Increasing the value of this parameter may improve performance in the SERVER configurations.  Using a value less that the installation value will severely degrade performance.
	Possible values are 8 to 50 with the default being 8.

	Example:

	 PROTOCOL.INI

	 ;protocol.ini for the Hughes LAN system MPD (Multi-protocol Driver) and
	 ;the 3com 3c509 Etherlink III Adapter Card
	 [PROTOCOL MANAGER]
	       DRIVERNAME = PROTMAN$

	 [KLSMPDNDIS]
	       DRIVERNAME = NPDNDIS$
	       BINDINGS = 3C509

	 [ETHERLINK]
	       IDADDRESS = 0x300
	       MAXTRANSMITS = 8
	       DRIVERNAME = ELNK3$

	 AUTOEXEC.BAT

	 SET PATH=C:\;C:\DOS:C:\PROLINC\TCP
	 LOADHI C:\PROLINC\DRIVER\PROTMAN\NETBIND
	 LOADHI C:\PROLINC\TCP\MPDINIT
	        C:\PROLINC\TCP\ETHRDRV
	 LOADHI C:\PROLINC\IPX\IPXMPD
	        C:\PROLINC\IPX\NET3
	 LOADHI BUFFERS=20
	 LOADHI FILES=40
	 SET FTP_ETC=C:\PROLINC\TCP
	 SET FTP_CONFIG=C:\PROLINC\NFS\FTP.CFG
	 SET INFORMIXDIR=C:\INFORMIX
	 SET SQLHOST=JAKE
	 SET FTP_ATTR=0x02,0x74,0x71
	 SET TEMP=C:\TEMP
	 G:
	 LOGIN ARKNOV_1/
	 M:
	 CAPTURE Q=HPIIISI_CC3 NB TI=5 NFF

	 Also CONFIG.SYS might be helpful in future:

	 LASTDRIVE=F
	 DEVICE=C:\QEMM\QEMM386.SYS RAM
	 DEVICE=C:\QEMM\LOADHI.SYS C:\PROLINC\TCP\IPCUST.SYS
	 DEVICE=C:\QEMM\LOADHI.SYS C:\PROLINC\TCP\ETKDRV.SYS
	 DEVICE=C:\PROLINC\DRIVER\PROTMAN\PROTMAN.SYS /i;C\PROLINC\DRIVER\ELNK3
	 DEVICE=C:\QEMM\LOADHI.SYS C:\PROLINC\DRIVER\ELNK3\ELNK3.DOS
	 DEVICE=C:\PROLINC\DRIVER\PROTMAN\MPDNDIS.SYS
	 SHELL=C:\COMMAND.COM C: /P/E:1024

SOLUTION

	After the user changed MAXTRANSMITS from 40 to 8 in the PROTOCOL.INI file under the [ETHERLINK] heading, the NetWare printing performance has dramatically increased.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Cannot Create/Write Temporary File..." - dBASE, NetWare v3.11
   DOCUMENT ID#:	FYI.P.10754
           DATE:	07DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Cannot Create/Write Temporary File <Drive letter>:"

ISSUE/PROBLEM

	When logged in as any user other than Supervisor, the users received the following message:

		Ŀ
		Cannot Create/Write Temporary File <Drive letter>:
		

	The users were launching dBASE from a subdirectory called SYS:TMDE\DBASE\DRAWINGS\BSTF\ATE\BASIC860.02.  They also had the drive letter mapped to dBASE by typing F:\APPS\DBASEIV\DBASE.

	Borland International, Inc said that their application creates a temporary file in whatever directory from which you launched dBASE and that you need WCM rights there.

	After using GRANT to give all users all rights to that subdirectory, the system still displayed the error.

SOLUTION

	When the user changed the directory name from \BASIC860.02 to \BASIC, then everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Target Exit Commands Are Not Supported..." - DR DOS
   DOCUMENT ID#:	FYI.P.10750
           DATE:	07DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	After installing DR DOS v6.0 when the user issued the EXIT command, the system displayed the following message:

		Ŀ
		Target exit commands are not supported on this machine
		

	The EXIT command worked fine on this machine when running with MS-DOS.

ISSUE/PROBLEM

	When a similar issue was reported with Compaq DOS, the solution was to insert the line "PCCOMPATIBLE" in the login script before issuing the EXIT command.

SOLUTION

	After the user added the PCCOMPATIBLE line to the login script, everything worked fine under DR DOS.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Formatting With -u Option Only Reporting 80 Percent Available Bytes
   DOCUMENT ID#:	FYI.P.10742
           DATE:	07DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	Problems running FORMAT

ISSUE/PROBLEM

	When formatting floppy diskettes with the /u option, FORMAT reported only 70 to 80 percent of bytes available.  When the user did CHKDSK immediately following FORMAT, it reported lost clusters in a large number of chains.   CHKDSK /f fixed them, sometimes filling the disk with hundreds of FILE000N.CHK files.  As an alternative to CHKDSK /f, the diskettes could be removed and reinserted.  Issuing subsequent CHKDSK commands reported no problems and all bytes available.

	Occasionally (also after formatting with /u), CHKDSK reported a larger number of files called ++++++++.+++ whose first sector was invalid.  Doing CHKDSK /f or removing and reinserting the diskette would not correct the situation.  Taking the floppy diskette to an MS-DOS machine and running CHKDSK /f did succeed in correcting the problem.

	The problems did not occur on all systems or on all diskettes (and not necessarily consistently on a particular machine with a particular diskette).

SOLUTION

	When the user disabled the SUPERPCK command line, the problem went away.  These symptoms did not occur when tested under SMARTDRV and DR DOS.

	About removing and replacing the diskettes as mentioned above, unloading SUPERPCK from memory accomplished the same thing. (Removing and replacing the diskettes from the drive causes SUPERPCK to take a new reading from the diskette rather than use the previously cached information; therefore, unloading SUPERPCK acting similarly to removing and replacing the diskette makes sense.)

	If unloading or disabling SUPERPCK whenever formatting is not desired, the user can solve the problem by adding a /-a (for the a drive) or a /-b (for the b drive) to the SUPERPCK command line.  This procedure can be used at the expense of not caching the drive specified.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Arrow Keys Not Working after INSTALL - NetWare v3.11
   DOCUMENT ID#:	FYI.P.10740
           DATE:	07DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Arrow keys not working after loading INSTALL.

ISSUE/PROBLEM

	When the user loaded INSTALL, the arrow keys on the number pad just beeped when pressed during a new install of a NetWare v3.11 operating system on a Model 95.

SOLUTION

	For lack of anything else to try, Novell instructed the user to try the PS2OPT driver instead of the PS2SCSI.  After the user used the PS2OPT driver, the keys starting working.  The PS2OPT driver was not designed to fix this problem; however, it was the only driver that worked.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	GPI Running LANSpool and Powerchute VAPs
   DOCUMENT ID#:	FYI.P.10736
           DATE:	07DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	The user was running NetWare v2.2 and loading the LANSpool and Powerchute value-added processes (VAPs).  If the user loaded both VAPs, the server stopped and sent a GPI error when a user tried to log in to the network.  If the user only loaded LANSpool, the network ran fine until a user tried to access LANSpool, at which point the server stopped and sent a GPI error.

ISSUE/PROBLEM

	The user suspected corrupt queues.

SOLUTION

	After the user deleted and recreated all the queues, the problem went away.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"You Must Boot DOS Before Executing..." - Upgrade to NetWare v3.11
   DOCUMENT ID#:	FYI.P.10734
           DATE:	07DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	After upgrading from ELS II a NetWare v3.11 operating system when the user shut down the server and tried to boot to DOS, the system displayed the following message:

		Ŀ
		You must boot DOS before executing non-dedicated NetWare
		

ISSUE/PROBLEM

	When doing the upgrade, the user did not use UPGRADE.EXE.  The user had done the following to make the upgrade:

	1.	Went into NetWare v3.11 INSTALL and deleted the 286 partition.
	2.	Then ran FDISK and made a bootable DOS partition.
	3.	Then installed the NetWare v3.11 operating system.

SOLUTION

	Along with the procedures used, the user needed to replace the master boot record.  After booting to DOS from a floppy diskette and running FDISK /mbr to replace the master boot record, the user could boot from the hard drive.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Disk Full" Error in DR DOS Editor
   DOCUMENT ID#:	FYI.P.10772
           DATE:	08DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When viewing a file on a disk that is full, the editor will allow you in and let you view most of the file.  However, after scrolling down through the file, the system displayed the following message:
		Ŀ
		Disk full, press ESC to continue
		

	When the user pressed ESC, the message returned, and the system seemed to be in an infinite loop.

ISSUE/PROBLEM

	Evidently, while scrolling through the file, the editor starts to use temporary files on the disk.

SOLUTION

	Initially, the only solution that worked was to reboot the machine.  However, further research showed that pressing ESC and quickly pressing CTRL-K-Q right after allowed the user to exit the file.  However, if CNTL-K-Q was not pressed fast enough, the above message would appear on the screen.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	MSCDEX and DR DOS Memory Management
   DOCUMENT ID#:	FYI.P.10759
           DATE:	08DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	Problems with MSCDEX  (Microsoft's CD-ROM Extension)

ISSUE/PROBLEM

	Note: The problems described below apply to MS-DOS as well as DR DOS.  They may, however, manifest themselves a little differently in MS-DOS.

	One known problem with MSCDEX is that it was created with the EXEpack linker.  This linker creates a file sort of like a zipped file.  When the program executes, it expands itself into memory.  However, this type of program is not used to load in the first 64 KB of conventional memory [It does some tricky procedures and tries to subtract a segment from the current address.  If the current address is below the 64 KB mark, that subtraction goes negative or wraps into the High Memory Area (HMA)].  DR DOS can detect some programs like this.  When DR DOS detects this, it loads the program at FF0 to avoid the problem that can cause memory fragmentation.  In cases where DR DOS does not detect the problem, the message "packed file is corrupt" occurs.  The packed file in question is the EXEpacked file (remember, these are "packed" files--like zipped files), and the command MEMMAX -L is necessary.

	One known workaround to this is to hiload the MSCDEX (making conventional memory fragmentation concerns irrelevant).  However, this brings up the other known problem with MSCDEX of requiring very large block of memory to initialize.  Often, hiloading MSCDEX fails because not many people have a contiguous upper memory block of around 100 KB.  With MSCDEX when hiload fails, it does not get loaded into conventional memory (or anywhere).

	In one case, a user had a CD-ROM and a CD-ROM version of Wing Commander II, which needs the CD-ROM drivers loaded.  It also needs about 590 KB conventional memory available and needs expanded memory; hence, requiring a page frame, which in turn makes it impossible to get enough upper memory space to hiload the MSCDEX.

	The /E switch (which has been confirmed as valid on MSCDEX v2.2) helps tremendously in the above situation.  The /E switch allows some of the MSCDEX to load into expanded (EMS, LIM) memory.  This means that if you HILOAD MSCDEX /E, not only will you avoid the conventional memory problem the EXEpacking causes but the "huge" space previously required to get the thing to load is no longer an issue.  The /E switch lets the initial large expansion of MSCDEX occur in expanded memory.

	For actual sizes, the user saw MSCDEX take 36 KB loaded normally (after initializing at around 100 KB).  With /E, it takes about 15 KB and the upper memory block it slid into was less than 28 KB in size (meaning that whatever initial expanding is done in upper memory, it is still doing a reasonably small amount).

	MSCDEX is made by Microsoft; however, they do not do end-user support for it because of all the MSCDEX on the market that has OEMed to individual CD-ROM makers.  It is possible that the /E switch is only valid with certain recent versions.  Users may have to contact their CD-ROM manufacturer for the newest version if theirs does not use the /E switch.

SOLUTION

	NA



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Server Network File Is Write Protected" - RBASE
   DOCUMENT ID#:	FYI.P.10758
           DATE:	08DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When launching Rbase v4.0 from the network, any user other than Supervisor received the following message:

		Ŀ
		Server Network File is Write Protected
		

	The user reinstalled three times and gave all rights to group Everyone where both data files and program files were stored.  The error occurred immediately after the Rbase logo came on the screen.

ISSUE/PROBLEM

	Rbase creates a temporary file in the PUBLIC directory each time it is launched.

SOLUTION

	After the supervisor gave users Create, Modify, File scan, Read, and Erase rights to the PUBLIC directory, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)
          TITLE:	Warning: No Files Were Copied from This Directory
   DOCUMENT ID#:	FYI.P.10787
           DATE:	09DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	The following system message was displayed:

		Ŀ
		Insert NSD diskette in the source drive OR A:REQUESTR
		Warning!  No files were copied from this directory.  
		

ISSUE/PROBLEM

	When running SECOS2.EXE, the -D parameter was not specified and the REQUESTR directory was not created.

SOLUTION

	Use the -D parameter when running SECOS2.EXE.  For example, SECOS2 -D.

	Note: You can copy the three install files, INSTALL.EXE, INSTALL.DLL, and INSTALL.HLP, and the NSD.LVL file to the root of the drive and create a REQUESTR directory with the remainder of the files located in it.  This will allow the install program to run correctly.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Upload of 2XTO3X.ZIP
   DOCUMENT ID#:	FYI.P.10785
           DATE:	09DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.x, v3.x
     SUPERSEDES:	NA

SYMPTOM

	NA
ISSUE/PROBLEM

	This document concerns the file 2XTO3X.ZIP available on NetWire and NetWare Express.

	This In-Place Upgrade utility uses the NetWare v3.11 operating system to upgrade a NetWare v2.1x or v2.2 file system and bindery to a NetWare v3.11 file system and bindery.  After the file system is upgraded, the INSTALL utility provided with NetWare v3.11 and future versions of v3.x can be used to place the new operating system files on the server's hard disks.

	If your current server has an 80386 or higher microprocessor, then the In-Place method provides the easiest way to upgrade your server.  Unlike the Transfer method, the In-Place Method only requires one server.  The Backup Device method upgrades as files are restored from a tape.  The In- Place Method reformats your hard disk's NetWare partitions without losing any data.  However, it is less flexible since volumes cannot be resized.  See the ASCII file, 2XUPGRDE.DOC, for a more detailed description of the tradeoffs between the upgrade methods.

	For more details, check each of the DOC files.

SOLUTION

	NA




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Corrupt Queue Causing "Out of Paper Error"
   DOCUMENT ID#:	FYI.P.10806
           DATE:	10DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user has the shell loaded with no CAPTURE loaded.  The system prints fine locally to the printer at LPT1; however, when CAPTURE is used, it reports the following message at the PSERVER console.

		Ŀ
		Out of paper
		

ISSUE/PROBLEM

	Novell suggested that the cause may be a port printer-communication problem.

SOLUTION

	After the user deleted and recreated the queue, printing worked fine with CAPTURE loaded.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"GetMessage Was Called..." - SYSCON
   DOCUMENT ID#:	FYI.P.10803
           DATE:	10DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"GetMessage was called, but the requested system message has been deleted."

ISSUE/PROBLEM

	The Supervisor could use SYSCON to create and look at users and user information.  When a user logged in and entered SYSCON and selected the "USER INFORMATION" option, the system displayed the following message:

		Ŀ
		GetMessage was called, but the requested system message
		has been deleted.                                      
		

SOLUTION

	When executing SYSCON from the PUBLIC directory, it worked fine.  The user had installed Message Handling System (MHS), and the MHS installation program had made the MHS directory the first search drive.  After the user made the PUBLIC directory the first search drive, SYSCON worked as expected and MHS still worked normally.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Specifying Alternate Adapters under OS/2
   DOCUMENT ID#:	FYI.P.10796
           DATE:	10DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3, v2.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user had two Token-Ring network boards in a PS/2 with the primary adapter setup for IBMs OS/2 Communications Manager.  The secondary or alternate adapter was to be used for the NetWare requester for OS/2.

SOLUTION

	Under OS/2 v1.3, use the following syntax:

	Link Driver token
	        alternate

	Under OS2 v2.0, use the following syntax:

	Link Driver token
	        port A24

	The word ALTERNATE applies to Token-Ring only.  If the person was using a NE2000, the following syntax should be used:

	Link Driver NE2000
	        Port 300

	Link Driver NE2000
	        Port 330



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Determining Communication Buffers for Routers
   DOCUMENT ID#:	FYI.P.10795
           DATE:	10DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	How can I find out how many communication buffers have been set up on the router?

SOLUTION

	Because the user did not want to run ROUTEGEN, the solution is to run DCONFIG against the ROUTER.EXE on the boot diskette.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Cannot Edit STARTUP.NCF Inside INSTALL
   DOCUMENT ID#:	FYI.P.10794
           DATE:	10DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Unable to edit STARTUP.NCF

ISSUE/PROBLEM

	The user went into INSTALL to edit the STARTUP.NCF and it would not allow editing.  The only commands seen on the screen were LOAD <DRIVER> statements; however, all actual STARTUP.NCF commands were being executed at boot up.  Attempts to edit returned the following error message:

		Ŀ
		Disk is full or write protected
		

	A similar issue in the Network Support Encyclopedia (NSE) had to do with UltraStor controllers.  This is not the case.

SOLUTION

	When the user removed the REMOVE DOS command from the AUTOEXEC.NCF, INSTALL worked as it should.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Slow Intel Fax Server across NetWare Router
   DOCUMENT ID#:	FYI.P.10827
           DATE:	11DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Intel FAX server v2.0 has slow performance across NetWare router
	Workstations that were on the same cable segment as an Intel FAX server v2.0 worked fine; however, the workstations on the other side of the NetWare v3.11 router were very slow in communicating with the FAX server.  For example, the DOS TSR took about 20 seconds to load (instead of 0.5 seconds), and sending a fax was unacceptably slow.

ISSUE/PROBLEM

	Configuration:

		The network consisted of the following:
		A NetWare v3.11 file server (internal router)
		An Intel FAX server
		Several DOS workstations
		All machines had NE2000 network boards

	The user was using linked IPX at all workstations.

SOLUTION

	When the user switched to using ODI drivers (from the WSGEN diskette from NetWare v3.11), performance was no longer slow.  The latest ODI drivers are in DOSUP6.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Volume Taking Too Long to Mount
   DOCUMENT ID#:	FYI.P.10825
           DATE:	11DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	A volume with a large directory is taking 35 minutes to mount.

ISSUE/PROBLEM

	The user had two volumes on the server.  The SYS: volume had 132,000 directory entries scattered throughout hundreds of directories, and the VOL1: volume had 25,000 directory entries all in one directory.  The SYS: volume would mount in about two minutes while the VOL1: volume would take about 35 minutes to mount.

SOLUTION

	Increasing Maximum Directory Cache Buffers and increasing Minimum Directory Cache Buffers solved the problem.  The documentation mentions increasing these parameters for directory searches in large directories; however, it does not say anything about mounting volumes with large directories.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	System Interrupts for DR DOS 6.0
   DOCUMENT ID#:	FYI.P.10823
           DATE:	11DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user wanted to know the system interrupts for DR DOS 6.0.

SOLUTION

	Three .ZIP files that a user can download from the Monterey BBS called INTER31A.ZIP, INTER31B.ZIP, and INTER31C.ZIP explain all the interrupts.  Also an Application Programming Interface (API) for TaskMAX that programmers can download and use to program for DR DOS is available on CompuServe.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Bad or Missing Command Interpreter" - SuperStor Drive
   DOCUMENT ID#:	FYI.P.10821
           DATE:	11DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	While booting up, the system displayed the following error message:

		Ŀ
		Bad or missing command interpreter
		

ISSUE/PROBLEM

	While trying to boot off a SuperStor drive, the user accidentally deleted the COMMAND.COM from the SuperStor drive.  Now, he cannot boot from the hard drive.  He can boot from a floppy diskette, but the SuperStor drivers are not loaded.  He can see the uncompressed portion of the hard drive.

SOLUTION

	The user put REM in front of the DEVSWAP command line in the CONFIG.SYS on the uncompressed drive (in effect making the uncompressed portion the boot partition, drive C: rather than drive D:), and the following happened:

	1.	The user was able to boot off the hard drive.
	2.	The SuperStor drivers were loaded.
	3.	The C: drive was the uncompressed and D: drive was the compressed.

	Then, the user copied the COMMAND.COM to the compressed partition and removed the REM from the DEVSWAP command line in CONFIG.SYS.  Now the user is able to boot normally.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Abend: GPPE Running Process Server..." - PSPrint
   DOCUMENT ID#:	FYI.P.10817
           DATE:	11DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Two issues this month have dealt with NetWare v3.11 file servers stopping several times a day while displaying the following message:
		Ŀ
		ABEND: GPPE running process server (01 - 04) process
		

	Both installations were using PSPrint, and the abends seemed to occur during printing.

ISSUE/PROBLEM

	In both cases, the PSPrint queues had become corrupted.

SOLUTION

	Deleting and recreating the queues solved the problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems with Hibuffers in CONFIG.SYS - DR DOS
   DOCUMENT ID#:	FYI.P.10814
           DATE:	11DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user has some software that does not allow the buffers (set in CONFIG.SYS) to be anywhere but in conventional memory.  When the user changed the "hibuffers" to "buffers," the buffers still went into upper memory.

SOLUTION

	Change HIDOS=ON to HIDOS=OFF in the CONFIG.SYS.  Buffers now load into conventional memory.  Using HIDOS=ON relocates "DR DOS data structures" to upper memory.  Buffers is one of the data structures.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems with Switch Feature in Batch Files - DR DOS
   DOCUMENT ID#:	FYI.P.10813
           DATE:	11DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	The user had a simple (non-nested) dual switch routine built into the AUTOEXEC.BAT.  Upon execution, the system displayed the following error:

		Ŀ
		Gosubs nested too deep
		

ISSUE/PROBLEM

	The user suspected an infinite loop.

SOLUTION

	The user was using "continue" as a label as well as "continue1."  DR DOS (most likely MS-DOS also) only differentiates down to the eighth character.  Therefore, a "goto continue1" in the batch file was causing control to be passes back to the "continue" label, which indeed caused a loop.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"IPX0105: LAN Support Module Not Installed"
   DOCUMENT ID#:	FYI.P.10811
           DATE:	11DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3 and v2.0
     SUPERSEDES:	NA

SYMPTOM

	The following errors are displayed:

		IPX0105: LAN support module not installed.
		NetWare for OS/2 v2.0 (920505)
		PROTOCOL OPTION: Novell IPX
		IPX0105: LAN support module not installed.
		SYS1201: The device driver "C:\NetWare\IPX.SYS" was not installed.

ISSUE/PROBLEM

	Configuration:

		The files from NSD201 were being used in combination with some drivers from the Requester v1.3.  The user did not have the NetWare requester for OS/2 v2.0.  LSL.SYS was copied from the Requester v1.3 diskettes.

	LSL.SYS from v1.3 will load, but when IPX.SYS tries to load, the support modules it requires are not loaded; therefore, the error messages above are returned.

SOLUTION

	Get the NetWare Requester for OS/2 v2.0.  IPX.SYS and LSL.SYS need to be from the same requester (v2.0 and v2.0 or v1.3 and v1.3) to work properly.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Interpreting STAT.NLM Results
   DOCUMENT ID#:	FYI.P.10849
           DATE:	14DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA
ISSUE/PROBLEM

	The user wanted documentation on how to interpret the results of the STAT.NLM.  All he could find was the March 92 application note that did not explain the results.

SOLUTION

	The README that comes with the STAT.NLM states the following:

		"The source code and programs on this diskette are provided for example and test purposes only." "They have not been extensively tested on a wide variety of systems, nor are they supported through any of Novell's technical support channels."




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Error Creating UPGR$BND.XXX
   DOCUMENT ID#:	FYI.P.10845
           DATE:	14DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The system displayed the following message while running UPGRADE.EXE.

		Ŀ
		Error creating UPGR$BND.xxx
		

	The workstation would beep and then return to a previous menu.

ISSUE/PROBLEM

	Configuration:

		Running the backup method

	The user did not have the COMSPEC set.

SOLUTION
	After setting COMSPEC, the user was able to do back ups with no more problems.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR DOS Windows Lock Utility Problem
   DOCUMENT ID#:	FYI.P.10836
           DATE:	14DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	When initially using the DR DOS LOCK utility to lock the Windows screen, it prompts the user to enter a password.  If the user decides to back out at this point and close the window, LOCK will not allow this even though the option is on the menu.

SOLUTION

	Enter a password to lock the screen, then reenter the password to unlock the screen.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Salvaging Files from Deleted Directories
   DOCUMENT ID#:	FYI.P.9327
           DATE:	18JUL91
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user was logged in to the network as Supervisor or equivalent, the user could not recover files from deleted directories.  When the user issued the SALVAGE command, the system displayed the following message:

		Ŀ
		You do not have rights to recover files from deleted
		directories on this volume                          
		

ISSUE/PROBLEM

	Using NDIR to look for a DELETED.SAV directory at the root, the user discovered that he did not have the directory.  After creating the directory, the same error message displayed.

SOLUTION

	After the user created the DELETED.SAV directory and flagged it hidden, SALVAGE worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"DOSCreateError Code = 206" - PCONSOLE, NetWare v2.2
   DOCUMENT ID#:	FYI.P.10684
           DATE:	01DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	When doing a new installation, the user responded "no" to the core printing prompt and used PCONSOLE to create the queues and print server.  He could create the queues; however, when trying to create the print server it would give the following error:

		Ŀ
		DosCreateError code=206...
		

ISSUE/PROBLEM

	The user had named the file server with a name that had more than eight characters and contained periods.

SOLUTION

	When the user removed the periods and shortened the name to less than eight characters, everything worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Insufficient Extended Memory to Run Windows..." - DR DOS
   DOCUMENT ID#:	FYI.P.10683
           DATE:	01DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to enter Windows, the system displayed the following message:

		Ŀ
		Insufficient extended memory to run windows, quit
		one or more applications and try again...        
		

ISSUE/PROBLEM

	Everything appeared to be fine in the AUTOEXEC.BAT and CONFIG.SYS files as far as memory configuration.  After looking a little harder, the user discovered that the SUPERPCK command line had a S:1024 option.  When it ran, it was being "ignored" as an invalid option.  It should have been /S:1024.  (The user did not have the slash in the command.)  Without the slash, SUPERPCK did not recognize the cache size option, and it defaulted to take all extended memory.

SOLUTION

	After the user put a slash on the SUPERPCK command line S:1024 option, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"You Do Not Have Access Rights to Queue"
   DOCUMENT ID#:	FYI.P.10681
           DATE:	02DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When trying to CAPTURE to a queue, only the Supervisor received the following message:

		Ŀ
		You do not have access rights to queue.
		

ISSUE/PROBLEM

	Adding the Supervisor to queue users in PCONSOLE did not remove the symptom.

SOLUTION

	Doing the following removed the symptom:

	1.	Deleted the group Everyone from queue users in PCONSOLE.
	2.	Ran BINDFIX.
	3.	Put the group Everyone back in queue users.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Abend: GPPE Creating Groups in SYSCON
   DOCUMENT ID#:	FYI.P.10680
           DATE:	02DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user created a group in SYSCON.  Then when adding users to the newly created group, the system displayed the following error:

		Ŀ
		Abend: General protection processor exception
		

ISSUE/PROBLEM

	Running BINDFIX or VREPAIR did not remove the symptom.

SOLUTION

	After the user updated to SYSCON v3.68 in SYS368.ZIP available on NetWire or NetWare Express, everything worked.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Slow Module in Aviation Application after NetWare v3.11 Upgrade
   DOCUMENT ID#:	FYI.P.10679
           DATE:	02DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Slow module in flight aviation application

ISSUE/PROBLEM

	The user had been using a flight application under a NetWare v2.15 operating system and it had run fine.  When the user upgraded to a NetWare v3.11 operating system, one of the modules that does extensive read/writes to the server slowed.  The module had been running at about 1 minute for completion.  When running on the NetWare v3.11 server, it took about 5 minutes for completion.

SOLUTION

	In the AUTOEXEC.NCF on the NetWare v3.11 server, change the "NCP file commit = ON" parameter to OFF.  The default is ON.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Adapter 00 for IBM Trnet Cannot Be Activated" - Requester
   DOCUMENT ID#:	FYI.P.10677
           DATE:	02DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	The user was having problems getting connected to an AS400 across an IBM source routing bridge using ODINSUP.SYS.

	The user was installing the Requester v2.0 on a workstation and was using ODINSUP.SYS to make connection to a NetWare v3.11 server as well as to a AS400 machine.  Then the user could connect to the AS400 by removing the requester statements or connect to the NetWare server by using the TOKEN.SYS driver and disabling the IBMCOM lines in the CONFIG.SYS file.  After the user made the necessary changes required to run ODINSUP in the CONFIG.SYS, NET.CFG, and PROTOCOL.INI file, the following error occurred:

		Ŀ
		Error adapter 00 for IBM trnet cannot be activated.
		

	After the user tried LANSUP.COM and made changes to the same files listed, he still could not get both connections.

ISSUE/PROBLEM

	The user had created the NET.CFG file initially in the root directory and had placed nothing in it.  Then the user had created the correct NET.CFG in the NetWare subdirectory.  So when the workstation came up, it never read the right NET.CFG file.

SOLUTION

	After removing the empty NET.CFG file in the root directory, the workstation executed and could connect to both the AS400 and NetWare server.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Errors Using Pinnacle CD-ROM Device
   DOCUMENT ID#:	FYI.P.10675
           DATE:	02DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user tried copying files to the CD-ROM drive, the system displayed the following errors:

		Ŀ
		Error writing FAT table for volume, Error writing to directory
		
		Ŀ
		Drive deactivated due to drive failure, volume dismounted
		due to drive deactivation.                               
		

ISSUE/PROBLEM

	Configuration:

		Using the Pinnacle CD-ROM 230 MB drive with a Future Domain controller on a machine with 8 MB of RAM
		Also using two 80 MB drives off another controller

	After the user updated got the hardware and drivers up to date, the system still displayed the errors:

	The problem appears to be a timing issue with the hardware being too fast for the CD-ROM drive.

SOLUTION

	In MONITOR under Disk Information, choose the device.  In the read-after-write status window, change the status from "hardware verify" to "software verify."




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR DOS Hangs while Loading - RLL Controller
   DOCUMENT ID#:	FYI.P.10671
           DATE:	02DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to install DR DOS 6.0, his machine hung at loading.  The diskettes worked fine on other machines.

ISSUE/PROBLEM

	The user had an RLL controller with a hard drive that needed to use type 47 (user definable).

SOLUTION

	After the user decreased the sector's specification from 28 to 26 in the setup, DR DOS 6.0 loaded fine.  The user lost some disk space by doing this, but it worked for him.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	How Large of a Partition Will DR DOS Create
   DOCUMENT ID#:	FYI.P.10658
           DATE:	02DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	The user reports problems when trying to create a primary partition of more than 512 MB under DR DOS.  The partition creates fine, but will not boot.

ISSUE/PROBLEM

	There has been some confusion about how large a partition the DR DOS 6.0 FDISK will create.  The written documentation says the limit is 512 MB.  However, 8/91 and 10/91 FDISK creates a primary partition with maximum size 512 MB and logical drives in extended partitions can theoretically be up to 2 GB.

SOLUTION

	The 12-91 and 4-92 FDISK permit primary partitions larger than 512 MB, theoretically as large as 2 GB.  The maximum size that Novell is aware of having been created is 670 MB for a primary partition and 1.3 GB for logical drive in an extended partition, using the 4-92 FDISK.

	DR DOS 6.0 FDISK, like the MS/PC DOS FDISK, cannot directly handle more than 1024 cylinders on a drive.  If the drive has more than 1024 cylinders, the controller must do controller-BIOS sector translation, or the user must format the drive with a utility such as Ontrack's DiskManager.  Usually large drives with more than 1024 cylinders are supplied with an appropriate disk formatting utility.

	If the user plans to use SuperStor on a partition, it cannot be larger than 256 MB.

	To create primary partition of more than 512 MB, use DR DOS FDISK dated 12-91 or later.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"SYS.COM Did Not Complete" - Installing DR DOS
   DOCUMENT ID#:	FYI.P.10655
           DATE:	02DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	The INSTALL program failed and displayed the following message:

		Ŀ
		SYS.COM did not complete successfully
		

ISSUE/PROBLEM

	The user had an old XT machine with only 512 KB.

SOLUTION

	The DR DOS Install program requires 640 KB to install properly.  Users with 512 KB machines must do a manual installation.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NETX Hangs after Reporting Version - NE2000
   DOCUMENT ID#:	FYI.P.10523
           DATE:	17NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NETX hangs

ISSUE/PROBLEM

	Configuration:

		The user was not loading any memory managers.
		The user had recently swapped hardware on this workstation to a 386 Leading Edge machine.

	NETX was hanging after reporting the version.

SOLUTION

	The user did the following the remove the symptom:

	1.	Pulled w16 jumper (timing) on the NE2000.
	2.	Deleted corrupt CONFIG.SYS and AUTOEXEC.BAT files.
	3.	Corrected faulty interrupt jumper on the network board.

	The surprising thing was that no load error was reported by IPX even though it was misconfigured for the wrong interrupt.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"AddFile Called With Directory..." - Ethernet
   DOCUMENT ID#:	FYI.P.10704
           DATE:	03DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Abend: Addfile called with directory with invalid first disk block."

ISSUE/PROBLEM

	The user reported that the following abend occurred on several platforms including Model 95, 80, and 70 servers:

		Ŀ
		Abend: Addfile called with directory with invalid first disk
		block.                                                      
 		

	The abend occurred at the following times:

		When using FCONSOLE to shut down the server
		When letting the UPS shut down the server
		Sometimes when manually dismounting the SYS: volume

	The common things in all three platforms were the following:

		RPL.NLM 05-28-92
		ETHERRPL 06-15-92
		Ethernet topology
		IBM hardware
		Token-Ring cards in the servers

SOLUTION

	The user upgraded the driver to TOKENDMA v3.13.  This driver is available on NetWire or NetWare Express in file name TOKENB.ZIP.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Sharing Violation Errors with NetWare CBTs
   DOCUMENT ID#:	FYI.P.10703
           DATE:	03DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Courseware:

		Novell NetWare v3.11 System Manager CBT
		Novell NetWare v3.11 Advanced System Manager CBT
		Novell NetWare Introduction to Networking CBT
		Novell NetWare Networking Technologies CBT

	When running any of the above Courseware Computer Based Training modules, the users received the following error message from within Microsoft Windows v3.0 or v3.1:
		Ŀ
		Sharing violation on drive ??.
		

ISSUE/PROBLEM

	Setting the DOS environment TEMP variable to a network drive results in the error.

SOLUTION

	The user must set the DOS environment TEMP variable to a local or virtual drive.

	If the user is running Microsoft Windows v3.0, setting a temp variable is not necessary unless an application requires it (the CBT will run under v3.0 without the TEMP variable set).  If the user is running Microsoft Windows v3.1, they must set a TEMP variable.  The CBT will not run unless a TEMP variable points to a local or virtual drive.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NetWare Utilities Lock Using QEMM under Windows
   DOCUMENT ID#:	FYI.P.10700
           DATE:	03DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NetWare utilities would lock up under Windows 3.1 when using QEMM.

	The user was connected to an IBM LAN server and a NetWare v3.11 server using LANSUP.  When the user accessed various NetWare utilities from Windows, either from a DOS session or using the Windows NetWare tools, the machine locked or displayed the following message:

		Ŀ
		Cannot read from device NETWORK...
		
ISSUE/PROBLEM

	Configuration:

		Using newest version of files

	The symptom appears to be caused from  a problem with stealth mode.  The statement in CONFIG.SYS was the following:

		device=qemm386.sys r:3 ram exclude=b000-bfff exclude=c800-cfff ST:M

SOLUTION

	When the user removed QEMM from CONFIG.SYS and used HIMEM.SYS, the system worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Undefined Public Variable" - Loading VREPAIR
   DOCUMENT ID#:	FYI.P.10697
           DATE:	03DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Undefined public variable

ISSUE/PROBLEM

	After having a power failure on the file server without an UPS, the fifth volume failed to mount.  When the user ran VREPAIR (v2.18 or shipping version), the file server displayed the following error:

		Ŀ
		Undefined public variable
		

SOLUTION

	After the user replaced SERVER.EXE, it allowed VREPAIR to load and fix the volume.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	DR DOS Not Recognizing DeLorne MAP Program
   DOCUMENT ID#:	FYI.P.10696
           DATE:	03DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When running DELORNE MAP EXPERT v1.0 (a Windows-based program), the program would run fine; however, the maps being read in from the CD-ROM would not show on the screen.

ISSUE/PROBLEM

	DeLorne Mapping Co. Technical Support at 207-865-1234 said that MAP EXPERT was written to make "calls" compatible with MS-DOS v4.01 (which DR DOS does not recognize).

SOLUTION

	The solution was for the user to download a file from the DeLorne BBS (207-865-3545) called MAPLIB.DLL, and then to copy this file into the directory where MAP EXPERT was installed.

	DeLorne also makes another product called USA ATLAS that has the same problem under DR DOS.  Another file in the DeLorne BBS takes care of this problem as well.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	SERVER.EXE Only Able to Remote Boot 19 Workstations
   DOCUMENT ID#:	FYI.P.10541
           DATE:	17NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user was trying to remote boot all 20 workstations with the latest boot ROMs and RPLB.ZIP.  He had a SERVER.EXE file dated 02-27-91 that would not work.  It would remote boot 19, but not 20.

SOLUTION

	The user tried a SERVER.EXE file dated 08-8-91 that did work.  This SERVER.EXE is the current version that is shipping.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Advanced Revelation Sessions Hanging - OS2 Requester
   DOCUMENT ID#:	FYI.P.10529
           DATE:	17NOV92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	Multiple sessions of Advanced Revelation hung

ISSUE/PROBLEM

	The user had some undetermined issues involving the NWIFS.SYS driver.

SOLUTION

	Apply the patches in NSD201.ZIP available on NetWire or NetWare Express.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Printer Control" Options Not Available Using JetDirect
   DOCUMENT ID#:	FYI.P.10521
           DATE:	17NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Unable to see "Printer Control" in the "Status of Printer" box in PCONSOLE.

ISSUE/PROBLEM

	The user had remote printers running JetDirect instead of PSERVER.  With RPRINTER running, a "Printer Control" option appears in PCONSOLE so that one can stop/start/rewind the printer.  With Jet Direct, this option does not appear.

SOLUTION

	A third-party device running as an RPRINTER on a NetWare print server would be able to be controlled through PCONSOLE status/control.  Third-party devices running as print servers (such as HP IIIsi or NetPorts) cannot be controlled.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Error Using Stacker with DR DOS 6.0
   DOCUMENT ID#:	FYI.P.10511
           DATE:	18NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA
SYMPTOM

	When the user loaded SUPERPCK, the system displayed an error message referring to heads and sectors not matching previous...

ISSUE/PROBLEM

	Configuration:

		Using DR DOS v6.0
		Using Stacker

	When SUPERPCK loads, it looks at the drive and sends this as a warning message because of the way Stacker handles the drive.

SOLUTION

	The user must press <Enter> twice to get past this message.

	This is only a warning.  SUPERPCK works fine with Stacker and the user can ignore the message.

	Use the following a workaround.

	If SUPERPCK is set up as Superpck /EM /S:1024, change it to read as follows:

		Superpck /EM /S:1024 /K- >NUL

	The /k- switch takes the pause out for issuing warning messages.  The >nul switch makes it so the user does not see the message.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	IPX 0105: LANSupport Module Not Installed
   DOCUMENT ID#:	FYI.P.10728
           DATE:	04DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v1.3, v2.0
     SUPERSEDES:	NA

SYMPTOM
	When the user initialized the LAN card while booting the workstation, the system displayed the following error message:

		Ŀ
		IPX 0105: LANSupport module not installed.
		

ISSUE/PROBLEM

	Configuration:

		Using an Ethercard Plus network board with SMC8000.SYS

	The user was using Requester v1.3 with the NSD201.ZIP update file.

SOLUTION

	After the user installed Requester v2.0, the problem disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Error Running Money Counts and DR DOS
   DOCUMENT ID#:	FYI.P.10727
           DATE:	04DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	When user ran Money Counts, the system displayed an error message instructing the user to increase files.  When the user set the file handles to the maximum, it had no effect.

ISSUE/PROBLEM

	Configuration:

		Using Money Counts v.7.0E

	The user had installed SuperStor on D: drive but had a DCONFIG.SYS.

SOLUTION

	When the user removed the DCONFIG.SYS and ran the driver from the CONFIG.SYS, the problem disappeared.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error in Boot File" - Running DOSGEN
   DOCUMENT ID#:	FYI.P.10726
           DATE:	04DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	After the user ran DOSGEN, the system displayed the following error message when the user tried to boot an Earthstation 1 diskless workstation:

		Ŀ
		Error in bootfile
		

ISSUE/PROBLEM

	Configuration:

		Using Compaq 3.31 DOS

	NET$DOS.SYS was not in the login directory.

SOLUTION

	After copying NET$DOS.SYS to the login directory, the user was able to log in just fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printer Connected to LPT3 Will Not Print
   DOCUMENT ID#:	FYI.P.10721
           DATE:	04DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The printer connected to LPT3 will not print.

ISSUE/PROBLEM

	On a PS/2 MicroChannel machine, the user had two Boca boards with an LPT port on each, along with the LPT port on the motherboard.  The user could connect to the printers from LPT1 and LPT2 to print, but never to LPT3.

SOLUTION

	After the user turned off the interrupts in PCONSOLE for all three ports, all printers began to work as desired.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Errors Running VREPAIR without Shutting Down Server
   DOCUMENT ID#:	FYI.P.10719
           DATE:	04DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was in the habit of running VREPAIR to check to see that there were no problems with the drive.  Every time the user dismounted the volumes and ran VREPAIR v2.18 (from VRP31X.ZIP) without shutting down the server, the system displayed the following errors:

		Ŀ
		Error at directory entry xxxx.  Not marked as free entry.
		
		Ŀ
		The reserved area was not properly zero filled.
		
		Ŀ
		Expected unused block to be marked as free or bad.
		

	However, if the user shut down the server before running VREPAIR, the system came up without giving any errors.

ISSUE/PROBLEM

	This is a known problem.  When a volume is dismounted, the operating system updates the BACKOUT.TTS file, but is does not properly free up the connection to that file.  The BACKOUT.TTS file is located on the SYS: volume by default.  When VREPAIR is run on the TTS backout volume, it finds the problem, which is not really a problem because it does not cause data corruption or anything.

SOLUTION

	Ignore these errors.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Compatibility Issues with PCTOOLS and DR DOS
   DOCUMENT ID#:	FYI.P.10718
           DATE:	04DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	Configuration:

		Using PCTOOLS v.8

	Two users have reported problems with the new release of PCTOOLS working with SuperStor.  Neither of the users did the obvious errors of running COMPRESS or DISKFIX but were using TSRs such as PCCACHE and others that worked fine with earlier versions of PCTOOLS.

	User 1:	SuperStor kept getting corrupted.  The day after the user restored everything and recompressed the files, SuperStor was corrupt again.  After the user restored without PCTOOLS and recompressed the files, everything has worked fine.

	User 2:	After running SuperStor, the user could not run DISKOPT or CHKDSK.  The system displayed an the following error:

				Ŀ
				Error reading from the drive
				

			When the user disabled all PCTOOLS TSRs and rebooted, CHKDSK and DISKOPT worked fine.

SOLUTION

	Do not run TSRs from PCTOOLS.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Are There Reads and Writes when Mounting a Volume?
   DOCUMENT ID#:	FYI.P.10867
           DATE:	14DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	A user was trying to run some performance tests and wanted to know what happens when you mount a volume.  Specifically, are there reads and writes or just reads?

SOLUTION

	Mounting the volume performs reads and writes.  The FAT tables are read into memory, sequentially, then the DET tables.  A consistency check is performed in memory that compares one copy of these tables to the other copies, which may not necessarily be a sequential process.

	The writes are made to, among other things, the VOL$LOG.ERR file.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Problems Reported Creating Very Large Bootable Partition
   DOCUMENT ID#:	FYI.P.10866
           DATE:	15DEC92
        PRODUCT:	DR DOS
PRODUCT VERSION:	v6.0
     SUPERSEDES:	NA

SYMPTOM

	Some users report an inability to create a very large bootable primary partition using the DR DOS FDISK utility.

ISSUE/PROBLEM

	The FDISK utility with DR DOS 8-91, 10-91, 12-91, and 4-92 dates would fail to create a bootable primary partition if the size of that primary partition exceeded 600 cylinders or so (the exact cylinder number at which the failure occurred is not available).

SOLUTION

	Users needing a large bootable primary partition can obtain FDISK files dated 7-92 or later.  The easiest place to obtain this file is in UT1192.ZIP available on NetWire or NetWare Express and the Monterey BBS machine 408-649-3443.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Where Are Requester RPRINTER Settings Stored?
   DOCUMENT ID#:	FYI.P.10858
           DATE:	15DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The user wants to know where the settings for the OS/2 v2.0 RPRINTER are stored.

SOLUTION

	The settings for the following versions of RPRINTER are listed below:
		Ŀ
		            VERSION             STORED LOCATION 
		Ĵ
		 RPRINTER.EXE 161,265 03-10-92  OS2.INI         
		 RPRINTER.EXE  55,808 09-17-92  PMRP.CFG        
		

	RPRINTER dated 03-10-92 shipped with the Gold release of the NetWare requester for OS/2 v2.0.  RPRINTER dated 09-17-92 is included with NSD201 and later.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Environment Variables Outside Login Script Does Not Work with MAP
   DOCUMENT ID#:	FYI.P.10855
           DATE:	15DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2, v3.11
     SUPERSEDES:	NA

SYMPTOM

	Environment variables not recognized outside the login script when using MAP command.

ISSUE/PROBLEM

	On one day a user set an environment variable to the following:

		set TERMTYPE=Whatever

	Then when the user used the MAP command with this the following syntax, it mapped the drive correctly to the WHATEVER subdirectory:

		"map s16:=sys:\%TERMTYPE%,"

	The next day when he issued the MAP command, the system displayed the following message:

		Ŀ
		Directory ****** is not locatable
		

SOLUTION

	When desiring to use functionality only supported with LOGIN.EXE such as the one described above, do the following procedures as a workaround:

	1.	Create a text file with the desired LOGIN commands.

	2.	Then create a batch file or just execute LOGIN.EXE with the "/n" (no attach) and "/s filename" (use script file) options.
	3.	You should also be able to pass command line parameters if using a DOS batch file.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printing Problems from NetWare to Xyplex Print Server
   DOCUMENT ID#:	FYI.P.10854
           DATE:	15DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	Printing output from a NetWare v3.11 server was missing parts of banner page and large sections and pages of the documents.

ISSUE/PROBLEM

	Xyplex MX-1450 is a print server machine certified last October by Novell (documented in Novell Labs test bulletin, P-87) that shares printing devices between DEC VAX systems using Local Area Transport (LAT) protocol and NetWare Servers using IPX Protocol.  Only print jobs from the NetWare server were being affected.

SOLUTION

	The Xyplex print server downloads an image file from the VAX at initialization that enables it to process IPX as well as LAT.  This image file v4.2 was patched by v4.2S1 to correct the processing of IPX.  Users must obtain the v4.2S1 patch from Xyplex.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Batch File Not Executing from Login Script - NET.COM
   DOCUMENT ID#:	FYI.P.10875
           DATE:	16DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	After the user installed the new NETX.EXE (v3.31), the system no longer executed the batch file commands at the EXIT command when logging into the server.  The user had "Long Machine type" in NET.CFG and "PCCOMPATIBLE" in the login script, but the system still did not respond to the batch file commands.

ISSUE/PROBLEM

	A NET.COM in WINDOWS\SYSTEM directory was being run instead of NETX.EXE.

SOLUTION

	After the user renamed NETX.COM to another filename, NETX.EXE would execute and everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"CreatQueueJobAndFile Returned Error 2" Requester
   DOCUMENT ID#:	FYI.P.10869
           DATE:	16DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	PCONSOLE.EXE (DOS v1.50, v1.51, and v1.52) is not fully functional when run in a Global DOS box (VDM) in OS/2.

	Example:

		If you select a print queue name; then select "Current Print Job Entries" option; and then press <Insert> to specify a directory from which a file is to be selected, PCONSOLE returns the following error if the directory you specify is a network directory:

			Ŀ
			There are no files in the specified directory
			

		If the directory is a local directory, the error is not produced.

		When you specify a local directory, you can then select a file from the "Available Files" list.  Next, you may notice that only "(Pconsole Defaults)" is displayed in the available "Print Job Configurations" box.  No other defined print jobs are shown, even though other defined print jobs can be selected when the same function is performed from a regular DOS workstation.  Select "(Pconsole Defaults)" and make any necessary changes on the "New Print Job to be Submitted" form.  After saving the changes, PCONSOLE returns the following Error Report:

		Ŀ
		ERROR                                                  
		       CreateQueueJobAndFile returned error 2.         
		DESCRIPTION                                            
		       The description for this error is not available.
		SEVERITY                                               
		       The current operation cannot be completed.      
		

		The print job is then added to the queue, but its Status remains at "Adding" indefinitely.

		If PCONSOLE is run in a Private VDM or in an OS/2 session, it functions correctly.

ISSUE/PROBLEM

	Configuration:

		Using NetWare Requester for OS/2 v2.0

	When a Global VDM is used, VSHELL.SYS is loaded.  VSHELL.SYS does not have all the functionality of NETX (which can be loaded in a Private VDM).  Therefore, not all DOS applications will function properly in a Global VDM [specifically, applications that make certain NetWare Core Protocol (NCP) calls that VSHELL.SYS does not support].  VSHELL.SYS will be enhanced in future releases.

SOLUTION

	Run PCONSOLE in a Private VDM or in a OS/2 session.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Arcserve Not Finding IBM$RUN.OVL
   DOCUMENT ID#:	FYI.P.10887
           DATE:	17DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When running the EMSNETX shell with Dell's DOS 5.0 and trying to run ARCSERV from this machine, ARCSERV returned with an error that it could not find IBM$RUN.OVL.

ISSUE/PROBLEM

	The user checked the short machine type in the NET.CFG file.  It had not been set; therefore, it should be returning IBM.  To verify this, the user did a write statement in the login script.  Sure enough, the %SMachine returned a blank.

SOLUTION

	As a test, the user assigned the %SMachine type in the NET.CFG file; and everything worked.  ARCSERV also worked by removing EMSNETX and running just NETx.  Novell was unable to recreate this problem using MS-DOS.  It may be a problem with Dell's DOS.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	User Not Receiving Messages - NWPOPUP.EXE
   DOCUMENT ID#:	FYI.P.10883
           DATE:	17DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	After upgrading using WINUP7.ZIP and DOSUP6.ZIP when the user was in Windows, he would not receive messages from other users, himself, or the printer.  He had enabled messages in Windows.  If he exited to DOS, the message would be at the bottom of the screen.

ISSUE/PROBLEM

	The user had not upgraded the NWPOPUP.EXE.

SOLUTION

	When the user used NWPOPUP from WINUP7, messages worked as it should.  WINUP7 is available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Model 56 Workstation Hangs At LOGIN - DXMT0MOD.SYS
   DOCUMENT ID#:	FYI.P.10881
           DATE:	17DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user upgraded the processors in four of the workstations to 486 SLC 2 chips.  After that, they could attach to the server; however, as soon as they ran LOGIN, the workstations locked and they had to reboot.  They also could not connect to the IBM AS400.  The workstation that had not been upgraded still connected and logged in to the server and AS400 just fine.

ISSUE/PROBLEM

	Configuration:

		Five IBM Model 56 SX workstations on a Token-Ring.
		One NetWare v3.11 file server and an IBM AS400 on the same ring.

	In the CONFIG.SYS files, the upgraded workstations were loading a file DXMT0MOD.SYS to communicate with the AS400.  This file is not needed with the 486SLC2 processor.

SOLUTION

	After the user removed the DXMT0MOD line from CONFIG.SYS and reset the Multi-Station Access Unit (MSAU), the upgraded workstations could log in to the server or the AS400 with no problem.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	WSGEN Error "Description File IBMETHER.LAN Should Have..."
   DOCUMENT ID#:	FYI.P.10880
           DATE:	17DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	The user had recently downloaded the latest drivers from IBM and just put them all into the WSGEN subdirectory.  When the user executed WSGEN from the hard drive, the system displayed the following message as soon as WSGEN came up:

		Ŀ
		Description file IBMETHER.LAN should have had xxx bytes read...
		

ISSUE/PROBLEM

	IBMETHER.LAN is a file used by Network File System (NFS).  WSGEN had trouble with the IBMETHER.LAN file because it had a .LAN extension but was not in the format that WSGEN recognizes.

SOLUTION

	As soon as the user removed the IBMETHER.LAN file from the WSGEN subdirectory, WSGEN ran fine.



                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Error unloading NetWare shell..." - Unable to Unload NETX with U Argument
   DOCUMENT ID#:	FYI.P.10543
           DATE:	17NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	Unable to unload NETX with the U argument

ISSUE/PROBLEM

	Configuration:

		Using DOS v5.0

	If NETX is loaded into upper memory, it cannot be unloaded with the NETX U command.  Also, the following error was returned even though no other TSRs had been loaded following NETX:

		Ŀ
		Error unloading NetWare shell. There is a TSR loaded above
		the loaded shell.                                         
		

SOLUTION

	A workaround is to use NETX F to forcibly unload the shell.  Caution must be used with this workaround to ensure that no other TSRs are loaded after NETX or the machine can hang.

	NETX v3.31 (NETX.EXE) can be unloaded when loaded into upper memory.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"NCP Request Received with Invalid Security Signature"
   DOCUMENT ID#:	FYI.P.10900
           DATE:	18DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was testing PBURST.NLM from DOSUP6.ZIP.  Whenever a workstation tried to log in while the NLM was loaded, the following message was displayed at the console and the workstation was denied access:

		Ŀ
		NCP request received with invalid security signature
		

	If the user removed PBURST.NLM, the workstation could log in fine.

ISSUE/PROBLEM

	By default, PBURST uses a security signature for the new security enhancements.

SOLUTION

	To turn the security enhancement off, use SET NCP PACKET SIGNATURE OPTION=0.  This set parameter is documented in the SECDOC.ZIP file that is available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Issues Loading Brequest High - NetWare v3.11
   DOCUMENT ID#:	FYI.P.10893
           DATE:	18DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user was unable to load BREQUEST high from system login script

ISSUE/PROBLEM

	The user wanted to be able to load hi BREQUEST in the system login script and it would not take the command #lh brequest.

SOLUTION

	The user did some testing and found that BREQUEST would not load high using the "#" or "#command /c" options.  However, calling a batch file that loads BREQUEST high worked fine.

	Example:

		#COMMAND /C C:LOADHI.BAT.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Trustee Assignments Not Backed Up During Hardware Upgrade
   DOCUMENT ID#:	FYI.P.10892
           DATE:	18DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	While upgrading hardware (a new server), the user did an NBACKUP to get the trustees and the binderies and then an NCOPY for the data.  After restoring the NBACKUP session, the directory trustee assignments were there, but the file trustee assignments were not.

ISSUE/PROBLEM
	The user had inserted "*.*" and "*." in the files to exclude.  This excludes the files and the file trustee assignments.  The directory structure (skeleton) is backed up but the file trustee assignments are not.

SOLUTION

	Possible options for saving file trustee assignments are to use NBACKUP to get everything or use a tape backup.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Printing Corruption from MAS90 in NetWare Lite
   DOCUMENT ID#:	FYI.P.10444
           DATE:	06NOV92
        PRODUCT:	NetWare Lite
PRODUCT VERSION:	v1.1
     SUPERSEDES:	NA

SYMPTOM

	Printing corruption and possible file corruption

ISSUE/PROBLEM

	When printing from MAS90 printing, corruption occurs.  In many cases, the MAS90 files also become corrupt.

SOLUTION

	Apply the patch CLPRINTR.PAT in L11P01.ZIP available on NetWire or NetWare Express.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Startup Options for WordPerfect on Nondedicated Server
   DOCUMENT ID#:	FYI.P.10926
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	WordPerfect hanging on nondedicated server

ISSUE/PROBLEM

	Several users have reported hanging the nondedicated server running WordPerfect 5.1.

SOLUTION

	There are many startup options with WordPerfect.  Try the following options:

		/NH - Keeps WordPerfect from directly accessing hardware
		/NK - Disables enhanced keyboard calls

	Using one or both of these options has worked most of the time.  Otherwise, do not run WordPerfect on a nondedicated server.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Abend Invalid Opcode Running Process INSTALL" - NetWare v3.11
   DOCUMENT ID#:	FYI.P.10923
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Abend invalid opcode running process install" and "Break at xxxx because of int3 break point"

ISSUE/PROBLEM

	Configuration:

		386/40 AMD server with AMI 1990 BIOS
		UltraStor 14f controller using U14_31X.DSK v2.0
		Fujitsu M2624F 520 MB SCSI
		3c509 network board
		20 MB RAM

	Going into partition tables in MONITOR or INSTALL from the "Product Options" menu resulted in the following errors:

		Ŀ
		Abend invalid opcode running process install
		
		Ŀ
		Break at xxxx because of int3 break point
		

SOLUTION

	Put the following statements in your STARTUP.NCF:

		set reserved buffers below 16 meg = 20
		set auto register memory above 16 meg = off
		load u14_31x.disk /b
		autoexec.ncf:
		register memory 1000000 400000




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Installing DR DOS on PS/1 Machine
   DOCUMENT ID#:	FYI.P.10922
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	NA

ISSUE/PROBLEM

	The PS1 came with the ability to boot off ROM, but it was hard to find out how to disable this so DR DOS could be installed.
SOLUTION

	IBM gives the following procedure:

	1.	Exit to a DOS prompt.
	2.	Put the IBM INSTALLATION DOS diskette in the A: drive.
	3.	Boot off that diskette and go to the CUSTOMIZE directory.
	4.	Go to the "how computer boots" option.
	5.	Go to the "where to find OS" option.
	6.	Go to the "where to read config and autoexec" option.
	7.	Go to the "where to boot from" option.
	8.	Change this to "a:" and then "c:" option.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"SYS3176: A Program In This Session Encountered..." - Requester
   DOCUMENT ID#:	FYI.P.10920
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	"SYS3176: A program in this session encountered a problem and cannot continue."

ISSUE/PROBLEM

	When running the Novell Menu program in a Global or Private VDM (DOS session), the following error is produced when an option on the menu is exited:

		Ŀ
		SYS3176: A program in this session encountered a
		problem and cannot continue.                    
		

	Example:

		Run MENU MAIN; select "Session Management" (SESSION); then exit SESSION.

	Although the SYS3176 error seems to be the most likely error to occur, other errors such as the following are possible:

		Ŀ
		The system detected an internal processing error at
		location &041a:312b.  DosKrnl: RMDevCloseDI        
		
		Ŀ
		Trap 000d
		

SOLUTION

	Doing the following procedure will allows you to run applications on a "true" DOS kernel instead of the OS/2 emulation kernel:

	1.	Follow the instructions specified in the OS/2 Help index for "DOS, Starting DOS from a Diskette."

	2.	Insert the bootable diskette into the A: drive.

	3.	Then boot a DOS session by double-clicking on the "DOS from Drive A:" icon.

	Not all DOS applications require a "true" DOS kernal to function correctly, but MENU.EXE does.  When you boot to a "true" DOS kernel, MENU will run correctly whether the DOS "NetWare_RESOURCES" setting is set to Global, Private, or None.

	Note:  You can create an image of the DOS diskette by following the instructions specified in the OS/2 Help index "DOS, Starting from an Image File."




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	FLAG.EXE and NVER.EXE Not Working in Global VDM
   DOCUMENT ID#:	FYI.P.10918
           DATE:	21DEC92
        PRODUCT:	NetWare Requester for OS/2
PRODUCT VERSION:	v2.0
     SUPERSEDES:	NA

SYMPTOM
	When running FLAG.EXE, v3.27 dated 01-30-91, in a Global VDM (DOS Session), the following error is produced:

		Ŀ
		Files could not be found with pattern "*"
		

	Also, when running NVER.EXE, v3.12 dated 01-29-91, in a Global VDM, the following message is displayed and the DOS session hangs:

		Ŀ
		NetWare VERSION UTILITY, VERSION 3.12
		

ISSUE/PROBLEM

	Configuration:

		The user has all rights to the directory.
		There are plenty of files in the directory.
		Any pattern can be specified.

	The problem is a limitation of VSHELL.SYS, the virtual NetWare shell that is loaded in a Global VDM.  VSHELL.SYS will be enhanced in future versions of the NetWare Requester for OS/2.

SOLUTION

	Run the OS/2 versions of FLAG and NVER in an OS/2 session, or run the DOS versions in a Private VDM with NETX loaded.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Disk Full and I/O Errors - UltraStor 12f Controller
   DOCUMENT ID#:	FYI.P.10916
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v2.2
     SUPERSEDES:	NA

SYMPTOM

	When the user added a second drive to the controller, the system began having problems such as the following:

		"Disk full" errors displayed
		disk I/O errors
		RESTORE not completing
		various disk/controller problems

ISSUE/PROBLEM

	Configuration:

		Using UltraStor 12F controller, BIOS revision 007

	FYI.P.5369, FYI.P.5945, and FYI.P.7615 all reference problems with the UltraStor 12F and 12F-24 controllers using NetWare v3.11.  These problems were resolved by upgrading the BIOS on the controllers to 009 for the 12F and 011 for the 12F-24.  They state that the upgrade is needed to use the controllers with NetWare v3.11 while the older BIOS revisions work fine with 286 NetWare.

SOLUTION

	This user's problem with NetWare v2.2 was resolved by upgrading the BIOS on the controller to 009; therefore the problem seems to apply to 286 NetWare as well as 386.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	NWD0115 Error - IBM Communications Manager
   DOCUMENT ID#:	FYI.P.10915
           DATE:	21DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	All versions
     SUPERSEDES:	NA

SYMPTOM

	IBM's Communications Manager and IBM's NetBIOS were installed and working on the computer displaying the following error message:

		Ŀ
		NWD0115 error getting connection ID (0x880f)
		
	When the required drivers for the NetWare requester were loaded and LOGIN was executed, the following error message was returned:

		Ŀ
		No response from given server
		

	If the machine was brought up with DOS and the preferred server statement was used, the following error message was returned

		Ŀ
		Could not establish preferred server connection
		

ISSUE/PROBLEM

	Displayed on the console of the preferred sever was the following messages:

		Ŀ
		1.1.119 Out of server connections
		
		Ŀ
		1.1.119 User connect request failed
		

	All the user connections were being used.

SOLUTION

	Clearing a connection allowed the user to log in to the network.

	This user chose to upgrade from NetWare v3.11 5-user to 10-user.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Write Out Partition..." - UltraStor 12F-24
   DOCUMENT ID#:	FYI.P.5945
           DATE:	27MAR92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Unable To Write Out Partition..." UltraStor 12F-24

ISSUE/PROBLEM

	Configuration:

		Using UltraStor 12f-24 BIOS revision 28001-010
		NetWare v3.11
		ISADISK v3.11
		IDE311.ZIP

	Using UltraStor's new 12F-24, 24 MHz, 16-bit ESDI controller and NetWare v3.11 while in the INSTALL and creating the NetWare partition, the following errors were reported:

		Ŀ
		DESCRIPTION                                          
		Unable to write out partition information - ccode = 2
		                                                     
		SEVERITY                                             
		Program execution may not continue normally.         
		
		Ŀ
		DESCRIPTION                                             
		Error writing primary Directory block sequence <NUMBER>.
		                                                        
		WARNING                                                 
		Program execution may not continue normally.            
		

	ISADISK.DSK that shipped with NetWare v3.11 operating system and IDE311.ZIP with /b still produced the same error conditions.  Occasionally, everything would freeze up during the install.

	The ISADISK v3.10 worked and the 286 ISADISK would install.

SOLUTION

	UltraStor technical support confirmed that a newer BIOS 28001-011 (fits in 28-pin socket, U1, on the card) is available that does resolve these Novell ISADISK issues.
	Another possible solution is to load ISADISK /b and then create the volume.  You may also need to obtain the latest ISADISK.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Utilities Hang with 3270 Loaded
   DOCUMENT ID#:	FYI.P.10940
           DATE:	04DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The NetWare utilities are unable to load and hang when the NetWare 3270 program for DOS is loaded.

ISSUE/PROBLEM

	The overlay files (IBM$RUN.OVL and $RUN.OVL) shipped with the 3270 product were older and bigger.

SOLUTION

	When the user used the files from the PUBLIC directory, everything worked fine.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Insufficient Memory" WordPerfect for Windows - NetWare v3.11
   DOCUMENT ID#:	FYI.P.10938
           DATE:	28DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	When the user tried to launch WordPerfect for Windows, the system displayed a message indicating that workstation had insufficient memory.

ISSUE/PROBLEM

	Configuration:

		Using Remote Program Load (RPL) with a Model 56 SLC LS workstation
		6 MB of RAM in the workstation

	When loading Windows in Standard mode, the machine showed that it had 4,062 KB free.

SOLUTION

	Change the properties in Windows for the WordPerfect for Windows icon.  WordPerfect for Windows has some different load options that solve the problem.  For the Command Line option, use the /D WordPerfect for Windows load option to put in a directory where the user has rights to create files.

		Example:  WPWIN /D - D:\USERS\208M\PTRENT

	WordPerfect products create many temporary files.  Typically, it creates these files in the process of moving a document in and out of memory.  The /D-<path> instructs WPWIN or WP to place the temporary files created in a different path than from the one the program was executed.  If in your AUTOEXEC.BAT you use the SET WPC=/D-<path> command, it will place all temporary files for all WordPerfect products (DOS or Windows based) in that path.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	"Unable to Set Up Drive for Mirroring" - ESDI Drive
   DOCUMENT ID#:	FYI.P.10936
           DATE:	28DEC92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	The user had installed a new ESDI drive and wanted to mirror it to the existing drive.  The user created the partition in INSTALL, and when he selected mirroring, the system displayed the following error message:

		Ŀ
		Unable to set up drive for mirroring.
		

	The error displayed before showing the partition mirroring status menu.  Pressing <Esc> after the error only show the partition on the original drive.

ISSUE/PROBLEM

	The user had the ESDI drive defined as type 35 instead of type 1.

SOLUTION

	After setting the ESDI to type 1 and setting the controller for translation, the user was able to mirror the drives.




                               FYI

(Note: The origin of this information may be internal or external to Novell.  Novell makes every effort within its means to verify this information.  However, the information provided in this document is FOR YOUR INFORMATION only.  Novell makes no explicit or implied claims to the validity of this information.)

          TITLE:	Access Denied Error While Running SBACKUP
   DOCUMENT ID#:	FYI.P.10408
           DATE:	04NOV92
        PRODUCT:	NetWare
PRODUCT VERSION:	v3.11
     SUPERSEDES:	NA

SYMPTOM

	"Access denied, unable to connect target server"

ISSUE/PROBLEM

	A Supervisor and Supervisor Equivalent could run SBACKUP fine, but all other Supervisor Equivalents, even newly created Supervisor Equivalents, would get the following errors when trying to run SBACKUP:

		Ŀ
		Access denied, unable to connect target server
		

	Running BINDFIX did not improvement in the situation.

SOLUTION

	Upgrade to the v3.11b maintenance release of SBACKUP.  (SBACK.ZIP is available on NetWire or NetWare Express.)
